
        CHANGES IN spatstat VERSION 3.6-2

OVERVIEW

    o New functionality in sub-packages.

    o Updated documentation.

        CHANGES IN spatstat VERSION 3.6-1

OVERVIEW

    o New functionality in spatstat.sparse, spatstat.univar, spatstat.random

    o More changes in spatstat.explore

        CHANGES IN spatstat VERSION 3.6-0

OVERVIEW

    o Substantial changes in spatstat.geom and spatstat.explore.
    
    o Updated version dependencies.

    o Updated documentation.

        CHANGES IN spatstat VERSION 3.5-1

OVERVIEW

    o spatstat now exceeds 200,000 lines of code.
    
    o Internal improvements.


        CHANGES IN spatstat VERSION 3.5-0

OVERVIEW

    o Updated version dependencies for spatstat package family.

    o Updated documentation.

        CHANGES IN spatstat VERSION 3.4-1

OVERVIEW

    o New vignette 'NAobjects' on missing/unavailable objects.


        CHANGES IN spatstat VERSION 3.4-0

OVERVIEW

    o Updated version dependencies for spatstat package family.

    o Updated documentation.

    o Updated demo(spatstat)
    

        CHANGES IN spatstat VERSION 3.3-3

OVERVIEW

    o Updated version dependencies for spatstat package family.

    o Updated documentation.


        CHANGES IN spatstat VERSION 3.3-2

OVERVIEW

    o Updated version dependencies for spatstat package family.

    o Updated documentation.

    o Bug fix in 'bugfixes'
    
BUG FIXES

    o bugfixes
    Crashed on some installations due to problems with file permissions.
    Fixed.


        CHANGES IN spatstat VERSION 3.3-1

OVERVIEW

    o Updated version dependencies for spatstat package family.

    o Updated documentation.
    

        CHANGES IN spatstat VERSION 3.3-0

OVERVIEW

    o Updated version dependencies for spatstat package family.

    o Updated documentation.
    
        CHANGES IN spatstat VERSION 3.2-1

OVERVIEW

    o List the history of all changes made to a function in spatstat.

NEW FUNCTIONS

    o latest.changes
    Lists the recent changes that have been made to
    a particular function in the spatstat family of packages.

        CHANGES IN spatstat VERSION 3.2-0

OVERVIEW

    o Tweaks to documentation.


        CHANGES IN spatstat VERSION 3.1-1

OVERVIEW

    o Internal changes to satisfy CRAN.


        CHANGES IN spatstat VERSION 3.1-0

OVERVIEW

    o New package 'spatstat.univar'

    o Minor internal improvements.

PACKAGE DEPENDENCE

    o spatstat.univar
    The new package 'spatstat.univar' has joined the spatstat family.
    It supports estimation and manipulation of probability distributions
    of one-dimensional random variables.
    Some functions have been moved from 'spatstat.geom', 'spatstat.random'
    and 'spatstat.explore' into the new package 'spatstat.univar'.

SIGNIFICANT USER-VISIBLE CHANGES

    o spatstat.family
    The list of sub-packages now includes 'spatstat.univar'.
    
        CHANGES IN spatstat VERSION 3.0-8

OVERVIEW

    o Updated package dependencies and documentation.

    o Vignette on shapefiles updated and reinstated.
    
SIGNIFICANT USER-VISIBLE CHANGES

    o Vignette 'shapefiles'
    This vignette has been updated. The new version uses
    package 'sf' instead of the defunct package 'maptools'.
    
        CHANGES IN spatstat VERSION 3.0-7

OVERVIEW

    o New vignette on function objects (class 'fv' and 'envelope')

    o Vignette on shapefiles temporarily removed.
    
    o Updated cross-references to sub-packages.

    o Minor changes to package information.
    
SIGNIFICANT USER-VISIBLE CHANGES

    o Vignette 'fv'
    New vignette which explains how to manipulate and plot
    objects of class 'fv' and 'envelope'.

    o Vignette 'shapefiles'
    This vignette has been temporarily removed because of its dependence
    on the defunct packages 'sp' and 'maptools'. It will be rewritten
    and reinstated soon.
    
        CHANGES IN spatstat VERSION 3.0-6

OVERVIEW

    o Updated cross-references to sub-packages.
    
    o Package documentation corrected and updated.


        CHANGES IN spatstat VERSION 3.0-5

OVERVIEW

    o Package documentation repaired (latex package issues).
    

        CHANGES IN spatstat VERSION 3.0-4

OVERVIEW

    o Package version information updated.

    o Minor omissions corrected in vignettes.

    o Package documentation corrected and updated.

        CHANGES IN spatstat VERSION 3.0-3

OVERVIEW

    o Package version information updated.

    o Minor errors corrected in vignettes.
    
        CHANGES IN spatstat VERSION 3.0-2

OVERVIEW

    o Internal tweaks.


        CHANGES IN spatstat VERSION 3.0-1

OVERVIEW

    o Package nicknames are temporarily suppressed.

        CHANGES IN spatstat VERSION 3.0-0

OVERVIEW

    o Further split of the spatstat family of packages.

    o All package versions have been updated to 3.0-x.

SIGNIFICANT USER-VISIBLE CHANGES

    o Package structure
    The package 'spatstat.core' has been split into two packages called
    'spatstat.explore' (for exploratory data analysis)
    and 'spatstat.model' (for modelling and formal inference).

    o Package dependence
    'spatstat' now depends on the new packages 'spatstat.explore'
    and 'spatstat.model' which have replaced the old package 'spatstat.core'.

    o spatstat.family
    Packages 'spatstat.explore' and 'spatstat.model' have been added
    and 'spatstat.core' has been deleted from the list of packages.
    
    o bugfixes, latest.news
    Updated to cover the new sub-packages 'spatstat.explore'
    and 'spatstat.model'.

        CHANGES IN spatstat VERSION 2.3-4

OVERVIEW

    o Minor bug fixes and improvements.

BUG FIXES

    o latest.news
    Did not include news from the new package 'spatstat.random'.
    Fixed.

    o spatstat.family
    Omitted the new package 'spatstat.random'.
    Fixed.
    
        CHANGES IN spatstat VERSION 2.3-3

OVERVIEW

    o Minor internal changes.

        CHANGES IN spatstat VERSION 2.3-1

OVERVIEW

    o spatstat depends on the package 'spatstat.random'

SIGNIFICANT USER-VISIBLE CHANGES

    o package dependence
    spatstat now depends on the new package 'spatstat.random'.

        CHANGES IN spatstat VERSION 2.3-0

OVERVIEW

    o Minor tweaks to package information and documentation

    o The NEWS file for package='spatstat' now contains only
    the news for the sub-package 'spatstat'. Other changes in the spatstat
    family of packages are reported in the NEWS file for the relevant
    sub-package.

    o 'latest.news' now collects news from all packages in the spatstat family

    o 'bugfixes' now collects bug fixes from all packages in the spatstat family

    o New function 'spatstat.family'

NEW FUNCTIONS

    o spatstat.family
    Return the names of all packages in the spatstat family.

SIGNIFICANT USER-VISIBLE CHANGES

    o latest.news
    Now gives the latest news for all packages in the spatstat family.

    o bugfixes
    Now lists bugs reported for all packages in the spatstat family.
    
    
        CHANGES IN spatstat VERSION 2.2-0

OVERVIEW

    o Minor tweaks to package information


         CHANGES IN spatstat VERSION 2.1-0

OVERVIEW

    o Minor changes to package structure.


        CHANGES IN spatstat VERSION 2.0-1

OVERVIEW

    o Minor changes to satisfy CRAN checks.
    

        CHANGES IN spatstat VERSION 2.0-0

OVERVIEW

    o We thank Corey Anderson, Michael Chirico, Andy Craig,
    Marcelino de la Cruz, Tilman Davies, Pavel Fibich,
    Kurt Hornik, Gopalan Nair, Yonatan Rosen and Rasmus Waagepetersen
    for contributions.

    o spatstat has been divided into 7 sub-packages
    (spatstat.utils, spatstat.data, spatstat.sparse,
    spatstat.geom, spatstat.core, spatstat.linnet and spatstat).

    o spatstat now depends on R version 3.5.0 or later.
    
    o Version nickname: "Caution: contains small parts"

SIGNIFICANT USER-VISIBLE CHANGES

    o package structure
    The original 'spatstat' package has been divided into 7 sub-packages
    (spatstat.utils, spatstat.data, spatstat.sparse,
    spatstat.geom, spatstat.core, spatstat.linnet and spatstat).
    The remaining 'spatstat' package requires all the other sub-packages.
    Your existing code scripts should still work with minimal changes.
    
    o sessionInfo
    Output now lists packages that are imported but not loaded.

    o sessionLibs
    Package names are now sorted alphabetically.
    

	CHANGES IN spatstat VERSION 1.64-1

OVERVIEW

    o Important bug fix in vcov.ppm

    o Relative risk estimation may include case weights.
   
    o We thank Ian Buller, Brian Ripley, Maximilian Vogtland
    and Maximilian Hesselbarth for contributions.

    o Nickname: 'Help you I can, yes!'

SIGNIFICANT USER-VISIBLE CHANGES

    o rshift.ppp, rshift.splitppp
    New argument 'nsim'.

    o relrisk.ppp
    New argument 'weights'.

    o density.splitppp
    New argument 'weights'.

BUG FIXES

    o vcov.ppm
    Variances were sometimes overestimated for Gibbs models.
    That is, entries of the Fisher information matrix were underestimated,
    because some contributions due to interaction were omitted
    (due to a coding error).
    Fixed.

    o density.ppp
    Crashed when se=TRUE if there were multiple columns of 'weights'.
    Fixed.
    
    o rbind.hyperframe
    Crashed unless all arguments had the same number of rows.
    (Spotted by Maximilian Vogtland).
    Fixed.
    
        CHANGES IN spatstat VERSION 1.64-0

OVERVIEW

    o We thank Robert Aue, Tilman Davies, Greg McSwiggan, Tyler Rudolph
    and Rasmus Plenge Waagepetersen for contributions.
    
    o Interactive graphics functions have been removed to a separate package.

    o spatstat no longer needs the packages 'tcltk' and 'rpanel'.

    o The suggested package 'maptools' should be version 0.9-9 or later.

    o Important bug fix in density.ppp.
    
    o Add new vertices to a linear network.

    o Relative risk estimation on a network.
    
    o Leave-one-out density estimation on a network.
    
    o Improvements and extensions to linear networks code.

    o Improvements to 'nndist' methods.

    o Function lengths.psp has been renamed lengths_psp.

    o Bug fixes related to mppm.

    o Stability improvements.

    o Version nickname: 'Susana Distancia'

NEW FUNCTIONS

    o relrisk.lpp
    Method for 'relrisk' for point patterns on a linear network.

    o bw.relrisklpp
    Bandwidth selection for relative risk on a network.
    
    o densityfun.lpp
    Method for 'densityfun' for point patterns on a linear network.

    o addVertices
    Add new vertices to a network, at locations outside the existing network.
    
    o lengths_psp
    This is the new name of the function 'lengths.psp',
    which had to be changed because of a conflict with the generic 'lengths'.

    o densityEqualSplit
    The equal-split algorithm for kernel density estimation on a network
    is now visible as a separate function.

    o densityHeat
    The heat-equation algorithm for kernel density estimation on a network
    is now visible as a separate function. It has also been extended
    to computing leave-one-out density estimates at the data points.

    o hotrod
    Compute the heat kernel kappa(u,v) on a one-dimensional line segment.

    o heatkernelapprox
    Calculate an approximation to the value of the heat kernel
    on a network evaluated at the source point, kappa(u,u).
    
SIGNIFICANT USER-VISIBLE CHANGES

    o nndist.pp3, nndist.ppx, nndist.lpp
    These functions now recognise the argument 'by'
    allowing computation of the nearest distance to each group of points.
    
    o pairdist.lpp, crossdist.lpp
    These functions can now handle large networks,
    using the sparse representation.

    o density.lpp, densityQuick.lpp
    Infinite bandwidth (sigma=Inf) is now permitted,
    and results in a density estimate that is constant over all locations.
    
    o as.linnet.psp
    The resulting network now has an attribute 'camefrom'
    indicating the provenance of each line segment in the network.
    
    o as.linnet.linnet
    New argument 'maxsize'.

    o repairNetwork
    Increased capability of detecting and repairing inconsistencies.

    o joinVertices
    New argument 'marks'.

    o insertVertices
    Marks attached to the lines of the network are now retained.

    o as.lpp
    Accepts more data formats.

    o iplot, iplot.ppp, iplot.layered, iplot.linnet, iplot.default
    These interactive plotting functions have been removed from spatstat
    into a new package 'spatstat.gui'

    o istat
    This interactive analysis function has been removed from spatstat
    into a new package 'spatstat.gui'

    o crossdist.lpp
    New argument 'check'.
    
    o lengths.psp
    This function will soon be Deprecated,
    in favour of the new name 'lengths_psp'

    o density.lpp
    Formal arguments changed. No effect on usage.

    o integral.linim
    Now handles complex-valued functions.
    
    o transect.im
    New argument 'nsample'.
    
    o bw.lppl
    Accelerated when distance="path".

    o collapse.fv
    Recognises the abbreviations used by fvnames()
    
BUG FIXES

    o density.ppp
    Edge correction factors were calculated incorrectly when the
    window was not a rectangle, causing a negative bias in the
    estimated intensity. [Spotted by Tilman Davies.]
    Bug introduced in spatstat 1.57-0, october 2018.
    Fixed.

    o mppm
    Internal data were malformed if the interaction was Hardcore()
    or MultiHard() or a hybrid involving these interactions.
    This caused various errors when the fitted model was used.
    Fixed.

    o mppm
    Ignored the arguments 'nd' and 'eps' controlling the quadrature scheme.
    Fixed.

    o "[.linnet", "[.lpp"
    In X[W] where W is a window, if a vertex of the network
    lay exactly on the boundary of W, an edge of length zero was created.
    Fixed.
    
    o valid.ppm
    Crashed sometimes when applied to the result of subfits().
    Fixed.

    o as.im.densityfun
    Crashed if argument W was missing.
    Fixed.
    
    o as.linnet.linnet
    This code could crash the R session, when sparse=FALSE, if there was
    insufficient memory available to create the matrix of distances
    between all pairs of network vertices.
    Fixed.

    o Summary.linim
    A spurious warning was generated when the operation any() or all()
    was applied to a logical-valued image on a network.
    Fixed.

    o "[<-.linim"
    Crashed if the assignment would have replaced some existing NA values.
    Fixed.

        CHANGES IN spatstat VERSION 1.63-3

OVERVIEW

    o Minor changes for compatibility with future versions of R

    o Minor improvements

    o Version nickname: "Wet paint"

SIGNIFICANT USER-VISIBLE CHANGES

    o plot.ppp
    The coordinate axes will be plotted if axes=TRUE.
    Axis labels xlab, ylab will be plotted if ann=TRUE.


        CHANGES IN spatstat VERSION 1.63-2

OVERVIEW

    o Minor changes to satisfy the package checker.

    o Version nickname: "I'm sorry Dave, I'm afraid I can't do that"

        CHANGES IN spatstat VERSION 1.63-1

OVERVIEW

    o Enhancement to plot.linim

    o Fill missing pixel values by taking the nearest defined pixel value.
    
    o Minor improvements and bug fixes.

    o spatstat now requires spatstat.utils version 1.17-0.
    
    o Version nickname: 'Made from recycled electrons'

NEW FUNCTIONS

    o is.linim
    Tests whether an object belongs to class 'linim'.

    o nearestValue
    Given a pixel image on a subset of a rectangle,
    extend the image to the entire rectangle,
    using the nearest well-defined pixel value.
    
SIGNIFICANT USER-VISIBLE CHANGES

    o markconnect
    Runs faster and handles much larger datasets.

    o markvario
    Runs faster and handles much larger datasets.

    o markcorr, markconnect, markvario 
    The 'weights' can now be an expression to be evaluated,
    or a function, or a pixel image, as well as a numeric vector.

    o Smooth.ppp
    The 'weights' can now be an expression to be evaluated,
    or a function, or a pixel image, as well as a numeric vector.

    o rpoislpp
    If 'lambda' is a list of 'linim' or 'linfun' objects, then
    the argument L can be omitted.

    o plot.linim
    New argument 'fatten' improves visual appearance when style="colour".
    
    o plot.im, plot.owin
    The coordinate axes will be plotted if axes=TRUE.
    Axis labels xlab, ylab will be plotted if ann=TRUE.

    o bugfixes
    If sincedate="all" or sinceversion="all", then all bugs will be listed.
    
    o Jfox
    New argument 'warn.trim' makes it possible to suppress repeated warnings.
    
    o requireversion
    New argument 'fatal'

BUG FIXES

    o predict.rhohat, simulate.rhohat
    When applied to a 'rhohat' object computed from
    linear network data (lpp or lppm), there was a warning
    about the lengths of vectors, and the results were incorrect.
    Fixed.

    o predict.rhohat, simulate.rhohat
    Crashed when applied to a 'rhohat' object computed from *multitype* 
    linear network data (multitype lpp or lppm).
    Fixed.

    o Jfox
    envelope() commands using the summary function 'Jfox'
    crashed sometimes with a message about illegal spacing of 'r' values.
    Fixed.

    o leverage, influence, dfbetas
    Crashed when applied to an 'ippm' object in which
    the irregular components of the score, but not the Hessian,
    were provided by symbolic differentiation.
    Fixed.
    
    o parres
    Crashed in rare circumstances, when the data did not contain
    enough useable values to perform smoothing.
    Fixed.

        CHANGES IN spatstat VERSION 1.63-0

OVERVIEW

    o Compute minimum or maximum nearest-neighbour distance between
    each pair of types in a multitype point pattern.
    
    o Important bug fix in simulations of the multitype hard core process.

    o Numerous improvements and bug fixes.

    o Deprecated functions have been removed.

    o Version nickname: "Trees in space"
 
SIGNIFICANT USER-VISIBLE CHANGES

    o minnndist, maxnndist
    New argument 'by' makes it possible to find the minimum or maximum
    nearest neighbour distance between each pair of possible types
    in a multitype pattern.

    o beachcolours
    If 'sealevel' lies outside 'srange', then 'srange' will be extended
    to include it (without a warning).
    
    o split<-.ppp
    The default for argument 'un' in 'split<-.ppp' 
    now agrees with the default for the same argument in 'split.ppp'.

    o lineardisc
    New argument 'add'.
    Default plotting behaviour has changed.

    o rmh, rmh.default
    The printed output of the debugger (invoked by snoop=TRUE)
    has been improved.

    o plot.owin
    New argument 'use.polypath' controls how to plot
    a filled polygon when it has holes.
    
    o plot.profilepl
    This function has now been documented, and the graphics improved.

    o erode.owin, dilate.owin
    These deprecated functions have now been deleted
    (replaced by erosion.owin and dilation.owin)

    o delaunay.distance, delaunay.network
    These deprecated functions have now been deleted
    (replaced by delaunayDistance, delaunayNetwork)

    o dirichlet.edges, dirichlet.network, dirichlet.vertices, dirichlet.weights
    These deprecated functions have now been deleted
    (replaced by dirichletEdges, dirichletNetwork,
    dirichletVertices, dirichletWeights)

BUG FIXES

    o rmh, simulate.ppm, MultiHard
    Simulated realisations of the multitype hard core model
    were completely incorrect (the interaction was effectively removed,
    changing the model into a Poisson process).
    Fixed.

    o kppm, AIC
    For kppm models fitted with method='clik2', the resulting value of logLik()
    was equal to 1/2 of the correct value. This would have affected
    model comparison using AIC, and model selection using step().
    Fixed.

    o hyperframe
    Did not correctly handle date-time values (columns of class 'Date', etc).
    Fixed
    
    o rlpp
    The resulting pattern was unmarked even when it should have been multitype.
    Fixed.
    
    o idw
    Estimates were zero if 'se=TRUE' and 'power != 2' and 'at="pixels"'.
    Fixed.
    
    o model.matrix.mppm
    Sometimes returned a matrix with the wrong number of rows.
    Fixed.

    o nncross.ppp
    Format of output was incorrect if X was an empty pattern.
    Fixed.

    o rmh, rmh.default
    For a marked point process, the debugger did not display the marks.
    (The rmh debugger is invoked by calling rmh with snoop=TRUE).
    Fixed.
    
    o pairs.im, pairs.linim
    The argument 'labels' was sometimes ignored.
    Fixed.

    o as.im.data.frame
    Results were incorrect for factor-valued data.
    Fixed.

    o relrisk.ppp
    Crashed if there were more than 2 types of points
    and method = "leastsquares" or "weightedleastsquares".
    Fixed.

    o as.im.nnfun
    Crashed when applied to a function generated by nnfun.psp.
    Fixed.
    
    o diagnose.ppm
    Crashed for some models with an error message from 'beachcolours'.
    Fixed.

    o predict.rho2hat
    Crashed if one of the original covariates was a function
    rather than an image.
    Fixed.

    o lineardisc
    Crashed in some graphics environments.
    Fixed.

    o lineardisc
    Crashed if the network segments had marks.
    Fixed.

    o rmh
    Crashed for multitype models if 'nsave' was specified.
    Fixed.

    o vcov.mppm, simulate.mppm
    Crashed for multitype models with a hardcore interaction component.
    Fixed.

    o effectfun
    Crashed if 'covname' was not the name of a covariate appearing in
    the model and was not one of the reserved names 'x', 'y', 'marks'.
    Fixed.
    
        CHANGES IN spatstat VERSION 1.62-2

OVERVIEW

    o Urgent bug fixes and workarounds.

    o Version nickname: "Shape-shifting lizard"

SIGNIFICANT USER-VISIBLE CHANGES

    o colourmap
    Argument 'col' is now permitted to have length 1, representing
    a colour map in which all values are mapped to the same colour.

    o lut
    Argument 'outputs' is now permitted to have length 1, representing
    a lookup table in which all inputs are mapped to the same output value.

BUG FIXES

    o envelope
    Crashed sometimes, with a message about unrecognised arguments,
    when applied to a summary function created by the user.
    Fixed.
    

        CHANGES IN spatstat VERSION 1.62-1

OVERVIEW

    o We thank Mohammad Ghorbani, Ute Hahn, Abdollah Jalilian, Nestor Luambua,
    Greg McSwiggan, Annie Mollie and Jakob Gulddahl Rasmussen for contributions.

    o spatstat now requires spatstat.utils version 1.15-0
    and goftest version 1.2-2.
    
    o Nearest Neighbour Index function can now return mark values.

    o Important fix in Ripley isotropic correction.

    o Index of repulsion strength for determinantal point process models.

    o Nearest neighbours between two point patterns in any number of dimensions.

    o More options for handling bad simulation outcomes in envelope().

    o Bandwidth selectors warn about extreme values of bandwidth.

    o Tessellations on a linear network can now have marks.

    o New functions for simulating point processes on a linear network.

    o More functions for manipulating tessellations on a linear network.
    
    o mppm accepts case weights.
    
    o Bug fixes and minor improvements.
    
    o Nickname: 'An update which will live in infamy'

NEW FUNCTIONS

    o repul
    Repulsiveness index for a determinantal point process model.

    o reach.kppm
    Reach (interaction distance) for a Cox or cluster point process model.

    o summary.dppm, print.summary.dppm
    Summary method for determinantal point process models.

    o nncross.ppx
    Nearest neighbours between two point patterns in any number of dimensions.

    o uniquemap.matrix
    Method for uniquemap for matrices.
    
    o repairNetwork
    Detect and repair inconsistencies in internal data
    in a linnet or lpp object.
    
    o marks<-.lintess, unmark.lintess
    Assign marks to the tiles of a tessellation on a linear network.

    o marks.lintess
    Extract the marks of the tiles of a tessellation on a linear network.
    
    o tilenames.lintess
    Extract the names of the tiles in a tessellation on a linear network

    o tilenames<-.lintess
    Change the names of the tiles in a tessellation on a linear network

    o nobjects.lintess
    Count the number of tiles in a tessellation on a linear network

    o as.data.frame.lintess
    Convert a tessellation on a linear network into a data frame.

    o rcelllpp
    Simulate the cell point process on a linear network
    
    o rSwitzerlpp
    Simulate the Switzer-type point process on a linear network

    o intersect.lintess
    Form the intersection of two tessellations on a linear network
    
    o chop.linnet
    Divide a linear network into tiles using infinite lines
    
SIGNIFICANT USER-VISIBLE CHANGES

    o lintess
    New argument 'marks'
    Tessellations can now have marks.

    o tilenames, tilenames<-
    These functions are now generic, with methods for 'tess' and 'lintess'

    o mppm
    New argument 'weights' specifies case weights for each row of data.
    
    o unstack.lintess
    Now handles marks.
    
    o plot.lintess
    Modified to display the marks attached to the tiles.
    Changed options: style=c("colour", "width", "image").

    o as.linfun.lintess
    The default function values are the marks.
    
    o print.lintess, summary.lintess, print.summary.lintess
    Output now includes information about marks.

    o nnfun.ppp, nnfun.psp, nnfun.lpp
    New argument 'value' specifies whether to return the index of the
    nearest neighbour or the mark value of the nearest neighbour.

    o envelope.ppp, envelope.ppm, envelope.kppm, envelope.pp3
    New arguments 'rejectNA' and 'silent'.
    
    o envelope.lpp, envelope.lppm
    New arguments 'maxnerr', 'rejectNA' and 'silent'.
    
    o plot.psp
    New argument 'col' gives control over the colour map
    representing the values of marks attached to the segments.

    o plot.im
    Some warnings are suppressed when do.plot=FALSE.

    o plot.linim
    New explicit argument 'box' determines whether to plot a bounding box.
    Default is now FALSE in all cases.

    o Kest, Kinhom, pcf, pcfinhom, edge.Ripley
    Calculation of isotropic edge correction for polygonal windows
    has changed slightly. Results are believed to be more accurate.
    Computation has been accelerated by about 20 percent in typical cases.

    o bw.diggle, bw.ppl, bw.lppl, bw.pcf, bw.CvL, bw.voronoi
    A warning is issued if the optimal value of the cross-validation criterion
    occurs at an endpoint of the search interval.
    New argument 'warn'.

    o mad.test, dclf.test, dg.test, bits.test
    Function values which are infinite, NA or NaN are now ignored
    in the calculation (with a warning) instead of causing an error.
    Warning messages are more detailed.

    o rmhcontrol, rmh
    The parameter 'nsave' can now be a vector of integers.
    
    o diagnose.ppm
    Accelerated, when type="inverse", for models without a hard core.

    o uniquemap.data.frame
    Accelerated for some cases.
    
    o vcov.ppm, vcov.mppm
    New argument 'nacoef.action' specifies what to do if
    some of the fitted coefficients are NA, NaN or Inf.

    o Lest, Linhom, Ldot, Lcross, Ldot.inhom, Lcross.inhom
    These summary functions now have an explicit argument 'correction'.
    Behaviour is unchanged.

    o bugfixes
    Arguments sinceversion="book" or sincedate="book"
    are interpreted to give all bugs reported after publication
    of the spatstat book.

    o cbind.hyperframe, rbind.hyperframe
    The result now retains the row.names of the original arguments.
    
    o print.summary.owin
    More information is printed.

    o append.psp
    Arguments may be NULL.

    o as.psp
    Now permits a data frame of marks to have only one column,
    instead of coercing it to a vector.
    
BUG FIXES

    o as.linnet.psp
    Sometimes produced a network with duplicated segments.
    [Such objects can be repaired using 'repairNetwork'.]
    Fixed.
    
    o edge.Ripley, Kest, Kinhom
    Isotropic correction weights for polygonal windows were sometimes incorrect
    for small radius 'r' if the polygon contained many small segments
    [spotted by Annie Mollie] or if the polygon was very long and thin
    [spotted by Nestor Luambua]. Problem arose in spatstat 1.60-0.
    Fixed.

    o lppm
    Did not correctly handle the case where the left-hand side of the formula
    is the name of an entry in the 'data' argument.
    Fixed.

    o plot.lpp
    Did not correctly handle the argument 'which.marks'.
    Fixed.

    o plot.im
    Did not correctly handle the argument 'ribargs$at'.
    Fixed.
    
    o density.lpp
    Sometimes requested a larger value of 'iterMax' but ignored it.
    Fixed.
    
    o [.linnet, [.lpp
    Crashed if x contained inconsistent internal data
    (when index 'j' was a window, and snip=TRUE).
    Fixed.
    
    o plot.linim 
    Crashed if the pixel values were complex numbers.
    Fixed.
    
    o plot.linfun
    Crashed if the function values were complex numbers.
    Fixed.

    o integral.linim, mean.linim
    Crashed if the image had logical values.
    Fixed.
    
    o Re, Im, Arg, Mod, Conj
    For pixel images on a linear network (class 'linim')
    these operations crashed if the pixel values were complex numbers.

    o studpermu.test
    Crashed if the hyperframe was very large.
    Fixed.

    o studpermu.test
    Crashed in some cases when the simulated functions were
    incompatible with each other, due to the use of different edge
    corrections.
    Fixed.

    o vcov.ppm, print.ppm, summary.ppm
    Crashed in some cases if the fitted coefficients were NA.
    Fixed.

    o quantess.owin, quantess.ppp, quantess.im
    Crashed in some cases because the tile labels were not unique.
    Fixed.
    
    o plot.pp3
    Did not correctly handle graphical arguments ('col', 'pch', 'cex')
    if they were vectors [Spotted by Abdollah Jalilian].
    Fixed.
    
    o shift.linnet
    Generated a spurious warning.
    Fixed.

    o density.lpp, lixellate
    Crashed in some cases when a data point was exactly at a vertex.
    [Spotted by Jakob Gulddahl Rasmussen.]
    Fixed.

    o plot.linim
    Crashed (when style="width") if any pixel values were NaN.
    Fixed.
    
    o Fest, Jest, Jdot, Jcross, Hest, Iest, rectcontact
    envelope() commands using one of these summary functions
    crashed sometimes with a message about illegal spacing of 'r' values.
    Fixed.

    o plot.linnet, plot.psp
    Ignored argument 'col' when style="width".
    Fixed.

    o rshift.psp
    Crashed if X had a data frame of marks.
    [Spotted by Ute Hahn.]
    Fixed.

    o Kscaled
    Crashed if Ripley's isotropic edge correction was selected
    but the translation edge correction was not.
    Fixed.
    
        CHANGES IN spatstat VERSION 1.61-0

OVERVIEW

    o We thank Jordan Brown, Tilman Davies and Greg McSwiggan for contributions.
    
    o Fast kernel estimation on a linear network using 2D kernels.

    o Nonparametric maximum likelihood estimation of 'rho'.

    o Extension of Scott's rule for bandwidth selection.

    o Cross-validated bandwidth selection on a linear network.

    o More support for character-valued images.

    o Random thinning of clumps.

    o Bug fixes and minor improvements.

    o Nickname: 'Puppy zoomies'
    
NEW FUNCTIONS

    o densityQuick.lpp
    Fast kernel estimator of point process intensity on a network
    using 2D smoothing kernel.

    o bw.scott.iso
    Isotropic version of Scott's rule (for point patterns in any dimension).

    o data.lppm
    Extract the original data point pattern from a fitted model of class 'lppm'.

    o rthinclumps
    Divide a spatial region into clumps and randomly delete some of them.

    o dimnames.hyperframe, dimnames<-.hyperframe
    Methods for extracting and changing the 'dimnames' of a hyperframe.
    
SIGNIFICANT USER-VISIBLE CHANGES

    o rhohat
    Estimation by nonparametric maximum likelihood is now supported,
    assuming the intensity is a monotone function of the covariate.
    New options: smoother="increasing" and smoother="decreasing".
    
    o density.lpp
    New argument 'distance' offers a choice of different kernel methods.

    o bw.scott
    Now handles point patterns of any dimension.
    New arguments 'isotropic' and 'd'.

    o bw.ppl
    New argument 'shortcut' allows faster computation.
    Additional arguments '...' are now passed to density.ppp.
    
    o [<-.im
    New argument 'drop' controls behaviour when indices are missing
    as in 'x[] <- value'

    o mppm
    Now supports 'self-starting' interactions.

    o as.im
    New argument 'stringsAsFactors' is recognised by many methods.
    It enables the creation of character-string-valued images.

    o plot.im
    Axes are now prevented from extending outside the image rectangle.

    o plot.im
    New argument 'zap'.

    o blur
    New argument 'kernel'.
    
    o Smooth.im
    New argument 'kernel'.

    o quadrat.test
    New argument 'df.est'.

    o edge.Ripley
    Numerical stability has been improved on some platforms.
    Results may have changed in marginal cases (e.g. where the circle
    of radius r centred at X is tangent to an edge of the polygonal window). 
    
    o rownames, rownames<-, colnames, colnames<-
    These operations now work for hyperframes.
    
    o quadrat.test
    Improved labelling of test when argument 'CR' is given.

    o plot.pppmatching
    This existing function now has a help file.
    New argument 'adjust'.

    o solist, is.sob, lintess
    Objects of class 'lintess' are now recognised as 2D spatial objects
    for the purposes of solist() and is.sob().
    
    o as.linfun.lintess
    Functions created by as.linfun.lintess() now generate better output
    when the function is printed.

BUG FIXES

    o densityVoronoi.lpp
    Did not correctly handle patterns containing duplicated points.
    Fixed.

    o quadrat.test
    Argument 'CR' was ignored when method="MonteCarlo".
    Fixed.
    
    o localKcross.inhom, localLcross.inhom
    Argument lambdaX was ignored.
    Fixed.

    o "[.linim"
    Factor values were erroneously converted to integers, in some cases.
    Fixed.

    o "[<-.hyperframe"
    Did not handle some classes of objects correctly.
    Fixed.

    o effectfun
    In a multitype point process model, effectfun() ignored any
    user-specified value of 'marks'.
    Fixed.

    o as.linim.linfun
    Additional arguments (other than spatial coordinates) were ignored.
    Fixed.

    o plot.solist
    Display output was mangled if one entry in the list was
    an object that would normally generate multiple panels of graphics,
    such as an 'lpp' or 'tess' object with multiple columns of marks,
    or a marked 'msr', 'leverage.ppm' or 'influence.ppm' object.
    Fixed.

    o plot.lpp
    Return value was mangled when x had multiple columns of marks.
    Fixed.
    
    o colourtable
    Crashed in some cases when 'breaks' was given.
    Fixed.
    
    o rLGCP
    Crashed if 'win' was not a rectangle and 'mu' was not a constant.
    Fixed.

    o intersect.tess
    Crashed if 'Y' was a window object and 'keepmarks=TRUE'.
    Fixed.

    o envelope.lppm
    Crashed if argument 'simulate' was given.
    Fixed.

    o unstack.solist
    Did not correctly handle objects of class 'lintess'.
    
    o unstack.solist
    Did not correctly handle objects of class 'tess' if they had multiple
    columns of marks.
    
    o plot.pppmatching
    Issued spurious warnings about unrecognised plot arguments.
    Fixed.

    o plot.lintess
    Issued spurious warnings about unrecognised plot arguments.
    Fixed.

    o shift.lpp, rotate.lpp
    Issued spurious warnings if argument 'origin' was given.
    Fixed.

        CHANGES IN spatstat VERSION 1.60-1

OVERVIEW

    o Version number incremented for administrative reasons.

        CHANGES IN spatstat VERSION 1.60-0

OVERVIEW

    o We thank Ottmar Cronie, Tilman Davies, Andrew Hardegen,
    Tom Lawrence, Robin Milne, Mehdi Moradi, Gopalan Nair,
    Tim Pollington and Suman Rakshit for contributions.
    
    o Random thinning and random labelling of spatial patterns
    extended to different types of pattern.

    o Confidence intervals for multitype K functions.

    o Envelopes for balanced two-stage test
    
    o Accelerated some code.

    o Minor bug fixes and improvements.

    o Package built under R 3.6.0.
    
    o Version nickname: 'Swinging Sixties'

NEW FUNCTIONS

    o bits.envelope
    Global simulation envelope corresponding to bits.test,
    the balanced independent two-stage Monte Carlo test.
    
    o extrapolate.psp
    Extrapolate line segments to obtain infinite lines.
    
    o uniquemap
    Map duplicate points to unique representatives.
    Generic with methods for ppp, lpp, ppx
    
    o uniquemap.data.frame
    Map duplicate rows to unique representatives

    o localKcross, localLcross, localKdot, localLdot,
    localKcross.inhom, localLcross.inhom
    Multitype local K functions.
    
SIGNIFICANT USER-VISIBLE CHANGES

    o lohboot
    Now works for multitype K functions Kcross, Kdot, Lcross, Ldot,
    Kcross.inhom, Lcross.inhom.
    
    o Kinhom, pcfinhom
    Leave-one-out calculation is implemented when 'lambda' is a fitted model
    of class 'dppm'.
    
    o Kcross.inhom, Kdot.inhom, Lcross.inhom, Ldot.inhom
    Leave-one-out calculation is implemented when 'lambdaX' is a fitted model
    of class 'dppm'.
    
    o rthin, rlabel
    These functions now work on point patterns of all classes
    (ppp, lpp, pp3, ppx) and line segment patterns (psp).

    o bw.abram
    New argument 'smoother' determines how the pilot estimate is computed.
    Formal arguments rearranged. 
    
    o plot.im
    New argument 'riblab'.
    
    o rlabel
    New arguments 'nsim' and 'drop'.

    o localK, localKinhom
    New argument 'rmax'.
    
    o rLGCP
    Accelerated.

    o anyDuplicated.ppp
    Accelerated.
    
    o duplicated.ppp
    Accelerated, in most cases.
    
    o simulate.kppm
    Accelerated, for LGCP models. 

    o predict.ppm
    Accelerated, for models fitted with method="VBlogi"

    o print.rmhmodel
    Output improved.
    
BUG FIXES

    o plot.linim, plot.linfun
    Not all the entries of 'leg.args' were passed to text.default.
    Fixed.

    o densityVoronoi.ppp
    Did not correctly handle patterns containing duplicated points.
    Fixed.

    o markcorr
    The argument 'correction="none"' did not generate any results.
    [Spotted by Tim Pollington.]
    Fixed.
    
    o names<-.fv
    Did not adjust the plotting formula, so that a subsequent call to plot.fv
    would complain about missing variables.
    Fixed.
    
    o im.apply
    Crashed if 'FUN' returned factor values.
    Fixed.

    o stienenSet
    Crashed if the data contained duplicated points.
    Fixed.

    o predict.ppm, effectfun
    Crashed in some cases, with the message 'ncol(x)=nrow(v) is not TRUE'.
    Fixed.

    o parres
    Crashed in some cases, with the message 'logical subscript too long'.
    Fixed.

    o dclf.test, mad.test, dg.test, bits.test
    Crashed in some cases if the summary function values were infinite or NA.
    Fixed.
    
        CHANGES IN spatstat VERSION 1.59-0

OVERVIEW

    o We thank Lucia Cobo Sanchez, Tilman Davies, Maximilian Hesselbarth,
    Kassel Hingee, Mehdi Moradi, Suman Rakshit, Jan Sulavik
    and Luke Yates for contributions.
    
    o Extensions to adaptive intensity estimators.

    o 'Dartboard' tessellation using polar coordinates.

    o Performance improvements.
    
    o Minor improvements and bug fixes.

    o Version nickname: "J'ai omis les oeufs de caille"
    
NEW FUNCTIONS

    o polartess
    Tessellation using polar coordinates.
    
    o bw.abram
    Variable bandwidths for adaptive smoothing, using Abramson's Rule.
    
    o densityAdaptiveKernel
    Calculates adaptive estimate of point process intensity
    using variable-bandwidth kernel estimation.
    
    o densityVoronoi, densityVoronoi.ppp
    Calculates adaptive estimate of point process intensity
    using tessellation methods. This is an extension of the
    old function adaptive.density.

    o densityVoronoi.lpp
    Voronoi or smoothed Voronoi estimator of intensity
    for point pattern on a linear network.

    o coords.quad
    New method for 'coords', to extract the coordinates of the points
    in a quadrature scheme.
    
    o lineartileindex
    Low-level function to classify points on a linear network
    according to which tile of a tessellation they fall inside.
    
SIGNIFICANT USER-VISIBLE CHANGES

    o latest.news
    Now prints news documentation for the current major version, by default.
    New argument 'major'.

    o quantess
    The covariate Z can now be "rad" or "ang" representing polar coordinates.
    New argument 'origin' specifies the origin of polar coordinates.
    New argument 'eps' controls accuracy of calculation.
    
    o envelope
    The argument 'simulate' can now be a function (such as 'rlabel').
    The function will be applied repeatedly to the original data Y,
    and should yield point patterns of the same kind.
    
    o adaptive.density
    This function can now perform adaptive estimation by two methods: either
    tessellation-based methods or variable-bandwidth kernel estimation.
    The calculations are performed by either 'densityVoronoi' or
    'densityAdaptiveKernel'.

    o densityVoronoi
    This performs the calculations of the old function 'adaptive.density'.
    New argument 'fixed' specifies the subsampling.
    New argument 'method' allows a choice between the original algorithm
    and the recently described 'smoothed Voronoi' estimator.
    Default value of 'f' changed to 'f=1'.

    o pcf.ppp
    Now accepts correction="none".
    
    o pairorient
    Default edge corrections now include 'bord.modif'.

    o funxy
    Functions of class 'funxy' can now be applied to quadrature schemes.

    o lohboot
    Computation accelerated when the window is a rectangle.

    o nncorr, nnmean, nnvario
    New argument 'na.action'.

    o pp3
    New argument 'marks'.

    o clusterfit
    New argument 'verbose'.
    
    o beachcolours, beachcolourmap
    Improved positioning of the yellow colour band.

    o linearK, linearpcf, linearKdot, linearKcross, linearpcfcross, linearpcfdot
    Computation accelerated for networks which are not connected.
    
    o as.linnet.psp
    Computation accelerated.

    o as.linfun.lintess
    Computation accelerated.
    
    o selfcut.psp
    Computation accelerated.
    The result now has an attribute "camefrom"
    indicating the provenance of each segment in the result.

    o bw.stoyan
    The rule has been modified so that, if the pattern is empty,
    it is now treated as if it contained 1 point,
    so that a finite bandwidth value is returned.

    o rebound.owin
    Now preserves unitnames of the objects.

    o rescale.owin, rescale.ppp, rescale.psp
    The geometrical type of the window is now preserved in all cases
    (previously if the window was polygonal but was equivalent to a rectangle,
    the rescaled window was a rectangle).

    o shift.im, shift.owin, shift.ppp, shift.psp
    More options for the argument 'origin'.

    o nnwhich.ppp, nnwhich.default
    Accelerated, in the case k > 1.
    
    o is.subset.owin
    Improved robustness against numerical error.

    o plot.im
    Improved behaviour when the pixel values are almost constant.

    o Finhom, Ginhom, Jinhom
    A warning is issued if bias is likely to occur because of undersmoothing.
    New arguments 'warn.bias' and 'savelambda'.
    
    o plot.colourmap
    Now handles a colourmap defined on an interval of length zero.

    o ewcdf
    Computation accelerated.
    New arguments 'normalise' and 'adjust'.
    The result does not inherit class 'ecdf' if normalise=FALSE.
    
    o spatialcdf
    Computation accelerated.
    The result does not inherit class 'ecdf' if normalise=FALSE.

    o effectfun
    New argument 'nvalues'.

    o parres
    The argument 'covariate' may be omitted if the model involves
    only one covariate.

    o alltypes
    If 'envelope=TRUE' and the envelope computation reaches the
    maximum permitted number of errors (maxnerr) in evaluating
    the summary function for the simulated patterns, then instead
    of triggering a fatal error, the envelope limits will be set to NA.

    o simulate.kppm
    Additional arguments '...' are now passed to
    the function that performs the simulation.
    
BUG FIXES

    o spatialcdf
    The argument 'weights' was ignored in some cases.
    Fixed.
    
    o ppp
    Points inside the window were erroneously rejected as lying outside
    the window, if the window was a polygon equivalent to a rectangle
    with sides longer than 10^6 units.
    Fixed.
    
    o inside.owin
    All results were FALSE if the window was
    a polygon equivalent to a rectangle
    with sides longer than 10^6 units.
    Fixed.

    o sumouter
    Result was incorrect (all entries were zero)
    if 'w' was missing and 'y' was given.
    Fixed.

    o extractbranch.lpp
    Point pattern coordinates were sometimes erroneously set to NA.
    Fixed.

    o beachcolours, beachcolourmap
    The number of colours was not always equal to 'ncolours'.
    [Spotted by Tilman Davies.]
    Fixed.

    o is.subset.owin
    Sometimes gave the wrong answer for polygonal windows
    due to numerical rounding error.
    Fixed.
    
    o update.kppm
    Crashed if the updating information was a point pattern
    and the original model call did not include a formula.
    Spotted by Luke Yates.
    Fixed.
    
    o incircle, inpoint
    Crashed if the window was extremely thin.
    Fixed.

    o effectfun
    Crashed in some obscure cases.
    Fixed.

    o closepairs.pp3
    Crashed if distinct=FALSE and what="all".
    Fixed.

    o update.ippm
    Crashed if the model was fitted using method="logi".
    Fixed.
    
    o plot.msr
    Crashed sometimes if x was multitype and multiplot=FALSE.
    Fixed.
    
    o anova.mppm
    Crashed if applied to a single model, unless the current environment
    was the global environment.
    Fixed.

    o lurking.mppm
    If 'covariate' was a list of images, the code crashed sometimes
    with message 'Fisher information is singular'.
    Fixed.
    
    o im
    Crashed if 'mat' was a 1-dimensional table (class 'table').
    Fixed.

    o dirichlet
    Crashed if the pattern was empty or contained only 1 point.
    Fixed.

    o rjitter
    Crashed if the pattern contained 0 or 1 points and
    the argument 'radius' was not specified.
    Fixed.

    o quantess.owin
    Crashed if Z was a function(x,y).
    Fixed.

    o quadrat.test
    The p-value was NA if one of the observed counts was zero,
    for the Cressie-Read tests with CR not equal to 1 or -1.
    Fixed.
    
    o quadratcount.ppp
    Sometimes issued an incorrect warning that data points were
    outside the tessellation, when 'tess' was a tessellation
    represented by a pixel image.
    Fixed.

    o as.linim.linfun
    Factor-valued functions were converted to integer-valued images.
    Spotted by Suman Rakshit.
    Fixed.

    o plot.linfun
    Did not display factor-valued functions correctly.
    Spotted by Suman Rakshit.
    Fixed.

    o dclf.test, mad.test
    Crashed, in rare cases, when applied to an 'envelope' object.
    Spotted by Jan Sulavik.
    Fixed.

    o plot.spatialcdf, plot.ewcdf
    A horizontal line was plotted at height 1, even if the CDF was unnormalised.
    Fixed.

    o plot.tess
    The names of the tiles were sometimes re-ordered in the legend.
    Fixed.

    o rThomas, rMatClust, rCauchy, rVarGamma
    If the simulation window was not a rectangle,
    the attribute 'Lambda' was a numeric vector, rather than a pixel image.
    Fixed.

        CHANGES IN spatstat VERSION 1.58-2

OVERVIEW

    o Venn diagram tessellation

    o Internal bug fixes.
    
NEW FUNCTIONS

    o venn.tess
    Venn diagram tessellation.

        CHANGES IN spatstat VERSION 1.58-1

OVERVIEW

    o Bug fixes.

    o Version nickname: "Compliment Sandwich"
    
BUG FIXES

    o lpp
    Did not correctly detect some situations where the input data are invalid.
    Fixed.

    o lurking.ppp, lurking.ppm
    Did not correctly detect some situations where the input data are invalid.
    Fixed.
    
        CHANGES IN spatstat VERSION 1.58-0

OVERVIEW

    o We thank Andrew Bevan, Hamidreza Heydarian and Andrew P Webster
    for contributions.
    
    o Mark-mark scatter plot.

    o Standard error calculation for inverse-distance weighting
    
    o Minor improvements and extensions.

    o Version nickname: 'Drop Bear'

NEW FUNCTIONS

    o markmarkscatter
    Mark-mark scatterplot
    
SIGNIFICANT USER-VISIBLE CHANGES

    o idw
    Standard errors can now be calculated by setting 'se=TRUE'.

    o im.apply
    Computation accelerated, especially when NA's are absent.
    New arguments 'fun.handles.na' and 'check'.
    
    o kppm, dppm, clusterfit
    Changed precedence rule for handling the algorithm parameters
    in the minimum contrast algorithm. Individually-named arguments
    'q,p,rmax,rmin' now take precedence over entries
    with the same names in the list 'ctrl'.

    o rotmean
    Improved algorithm stability
    
    o summary.kppm
    Prints more information about algorithm convergence.

    o closepairs.pp3, crosspairs.pp3
    Argument 'what' can take the value "ijd"

    o plot.onearrow
    Graphical parameters, specified when the object was created,
    are now taken as the defaults for graphical parameters to the plot.

BUG FIXES

    o rotmean
    When result="im" the resulting image did not have the same dimensions
    as the input. [Spotted by Hamidreza Heydarian.]
    Fixed.

    o rotmean
    If argument 'origin' was given, and if result="im" was specified,
    the resulting image was wrongly displaced.
    Fixed.

    o runifpointx
    Result was mangled when n=0 or n=1.
    Fixed.

        CHANGES IN spatstat VERSION 1.57-1

OVERVIEW

    o Bug fixes.

    o Version nickname: 'Cartoon Physics'
   
BUG FIXES

    o multiplicity.default
    Some entries of the result were incorrectly set to 1.
    Fixed.
    
    o anova.ppm
    Crashed if adjust=TRUE and the models were fitted with use.gam=TRUE.
    Fixed.

        CHANGES IN spatstat VERSION 1.57-0

OVERVIEW

    o We thank Corey Anderson, Ryan Arellano, Hadrien Commenges,
    Ottmar Cronie, Tilman Davies, Maximilian Hesselbarth, Kassel Hingee,
    Tomas Lazauskas, Marie-Colette van Lieshout, Rasmus Waagepetersen
    and 'daitakahashi' for contributions.

    o Cronie-van Lieshout bandwidth selection.
    
    o Smoothing functions handle non-Gaussian kernels.

    o Infinite smoothing bandwidths permitted.
    
    o Positive confidence limits for rhohat.

    o Improved bivariate interpolation.
    
    o subset() method for line segment patterns.
    
    o Important bug fixes in rthin and density.ppp

    o Minor bug fixes and improvements.

    o Version nickname: 'Zombie apocalypse'

NEW FUNCTIONS

    o bw.CvL
    Cronie-Van Lieshout bandwidth selection for density estimation.
    [Contributed by Ottmar Cronie and Marie-Colette van Lieshout.]
    
    o subset.psp
    Method for 'subset' for line segment patterns.
    
SIGNIFICANT USER-VISIBLE CHANGES

    o densityfun.ppp, Smoothfun.ppp, Smooth.ppp
    These commands now handle non-Gaussian kernels.

    o density.ppp, relrisk.ppp, Smooth.ppp, densityfun.ppp, Smoothfun.ppp
    Argument 'sigma' can be infinite.
    
    o interp.im
    New argument 'bilinear' specifies the choice of interpolation rule.

    o rhohat
    Methods for rhohat have a new argument 'positiveCI'
    specifying whether confidence limits should be positive.

    o plot.colourmap
    New argument 'increasing' specifies whether the colours are
    displayed in order left-to-right/bottom-to-top.
    Changed default behaviour for discrete colour maps when vertical=FALSE.

    o split.ppx
    Argument 'f' can be a logical vector.

    o relrisk.ppp
    If se=TRUE and at="pixels", the result belongs to class 'solist'.

    o imcov, setcov, convolve.im
    The name of the unit of length is preserved.

    o density.ppp
    Slightly accelerated for non-Gaussian kernels.

    o bw.scott
    The two bandwidth values in the result
    now have names ('sigma.x' and 'sigma.y').

    o pairdist.default
    Now checks whether the data are valid 2-dimensional coordinates.

    o pixellate.ppp
    New argument 'savemap'

    o rtemper
    New argument 'track'.
    Code runs slightly faster.
    
    o eval.im, eval.linim
    New argument 'warn'.

    o Kres, Kcom, Gcom, psstG
    If any of the calculated weights for the summary function
    are infinite or NA, they are reset to zero, with a warning,
    instead of a fatal error.
    
BUG FIXES

    o rthin
    If P was close to 1, the result was sometimes an empty point pattern
    when it should have been identical to X.
    [Spotted by Maximilian Hesselbarth.]
    Fixed.

    o density.ppp
    Standard error calculations were incorrect
    when sigma was a single numeric value.
    The output was equal to 'sqrt(sigma)' times the correct answer.
    Fixed.
    
    o density.ppp
    Result was incorrect for non-Gaussian kernels when
    at="points" and leaveoneout=FALSE.
    Fixed.

    o density.ppp
    Did not pass additional arguments "..." to a user-supplied
    kernel function, in some cases.
    Fixed.

    o as.im.function, as.im.funxy
    If the function values were factor values and the window was
    not a rectangle, the result was an image with all pixel values NA.
    [Spotted by Corey Anderson.]
    Fixed.
    
    o plot.funxy
    If the function values were factor values and the window was
    not a rectangle, the plot was empty.
    [Spotted by Corey Anderson.]
    Fixed.

    o nnorient
    Crashed if the border correction did not retain any data points.
    [Spotted by Tomas Lazauskas.]
    Fixed.
    
    o linim
    Crashed in some cases with a message about unitnames.
    Fixed.
    
    o density.lpp
    Default value of 'dx' was sometimes incorrect.
    Fixed.
    
    o rMatClust, rThomas, rCauchy, rVarGamma
    Issued a spurious warning about bandwidth selection
    when saveLambda=TRUE.
    Fixed.

    o density.ppp
    Issued a spurious warning about bandwidth selection
    when 'kernel' was a user-supplied function.
    Fixed.

    o clusterfield.function
    Issued a spurious warning about bandwidth selection.
    Fixed.

   o relrisk.ppp
   Issued a spurious warning if the argument 'case' or 'control'
   was given, for a bivariate point pattern.
   Fixed.

   o superimpose.ppp
   If 'W' was a character string or function, the behaviour was
   not exactly as described in the help file. 
   Fixed.

   o plot.psp
   If the marks were factor values, the colour map was displayed upside down.
   Fixed.

   o eval.fv
   If one of the 'fv' objects included ratio information (class 'rat')
   then this was erroneously retained, in some cases.
   Fixed.

   o linearKcross
   Crashed (with a message about a missing value of 'correction')
   if there were no pairs of points to count.
   Fixed.

   o envelope.lpp
   Crashed (randomly) when fix.n=TRUE and fix.marks=TRUE.
   Fixed.
   
        CHANGES IN spatstat VERSION 1.56-1

OVERVIEW

    o We thank Agustin Lobo for contributions.

    o Improvements to infrastructure.
    
    o Bug fixes.

    o Version nickname: "Invisible Friend"

NEW FUNCTIONS

    o as.im.expression
    New method for 'as.im' for expressions.

    o flipxy.tess
    Method for 'flipxy' for tessellations.
    
SIGNIFICANT USER-VISIBLE CHANGES

    o sdr
    This is now a generic function, with a method for class 'ppp'.
    
    o pointsOnLines
    The result now has an attribute named "map"
    which maps each point to its parent line segment.
    
    o summary.lpp
    Improved output.

    o intersect.owin
    Argument 'fatal' now defaults to FALSE.

    o quadrature schemes (class "quad" and "logiquad")
    Improved print and summary methods.
    
BUG FIXES

    o cut.lpp
    Crashed if the marks were a data frame or hyperframe.
    Fixed.
    
    o summary.lpp, print.summary.lpp
    Output was garbled if the marks were a data frame or hyperframe.
    Fixed.

    o integral.linim
    Crashed if the function had NA values.
    Fixed.

    o Tstat
    Crashed if ratio=TRUE.
    Fixed.

    o intersect.owin
    Ignored argument 'fatal' in some cases.
    [Spotted by Agustin Lobo.]
    Fixed.

    o plot.tess
    Crashed if do.col=TRUE and 'values' was a factor.
    Fixed.

    o pcf.ppp
    Crashed if 'domain' was given and ratio=TRUE.
    Fixed.
    
    o "[<-.sparse3Darray"
    Crashed if 'value' was one-dimensional
    and the indices i, j, k specified a two-dimensional subset of x.
    Fixed.
    
    o plot.quad
    Crashed if tiles=TRUE for a quadrature scheme
    created by quadscheme(method="dirichlet", exact=TRUE).
    Fixed.

    o bugtable
    Crashed if there were no bugs!
    Fixed.
    
    o sparse array code
    An array bounds violation (segmentation fault) could occur.
    Fixed.
    
    o internal code
    Numerous internal bugs have been fixed.


        CHANGES IN spatstat VERSION 1.56-0

OVERVIEW

    o We thank Sebastian Meyer and Suman Rakshit for contributions.
    
    o Kernel estimate of intensity as a function(x,y)

    o Extract discrete and continuous components of a measure.

    o Improvements and extensions to leverage and influence code.

    o Plot a line segment pattern using line widths.

    o Find connected components of each tile in a tessellation.

    o Geometrical operations on 'distfun' objects.

    o Join vertices in a linear network.
    
    o Distance map and contact distribution for rectangular structuring element.
    
    o An infinite number of infinitesimal bugs has been detected and fixed.

    o Version nickname: "Bondi Tram"

NEW FUNCTIONS

    o densityfun, densityfun.ppp
    Compute a kernel estimate of intensity of a point pattern
    and return it as a function of spatial location.

    o as.im.densityfun
    Convert function(x,y) to a pixel image.

    o measureDiscrete, measureContinuous
    Extract the discrete and continuous components of a measure.

    o connected.tess
    Find connected components of each tile in a tessellation
    and make a new tessellation composed of these pieces.

    o dffit.ppm
    Effect change diagnostic DFFIT for spatial point process models.

    o shift.distfun, rotate.distfun, reflect.distfun, flipxy.distfun,
    affine.distfun, scalardilate.distfun
    Methods for geometrical operations on 'distfun' objects.

    o rescale.distfun
    Change the unit of length in a 'distfun' object.

    o plot.indicfun
    Plot method for indicator functions created by as.function.owin.

    o Smooth.leverage.ppm, Smooth.influence.ppm
    Smooth a leverage function or an influence measure.

    o integral.leverage.ppm, integral.influence.ppm
    Compute the integral of a leverage function or an influence measure.

    o mean.leverage.ppm
    Compute the mean value of a leverage function.

    o rectdistmap
    Distance map using rectangular metric.
    
    o rectcontact
    Contact distribution function using rectangular structuring element.

    o joinVertices
    Join specified vertices in a linear network.
    
SIGNIFICANT USER-VISIBLE CHANGES

    o plot.psp
    Segments can be plotted with widths proportional to their mark values.
    New argument 'style'.

    o msr
    Infinite and NA values are now detected (if check=TRUE)
    and are reset to zero, with a warning.
    
    o leverage.ppm, influence.ppm, dfbetas.ppm
    Faster computation in some cases.

    o as.im.nnfun, as.im.smoothfun
    New argument 'approx' chooses between a fast, approximate algorithm
    and a slow, exact algorithm.

    o cdf.test
    More jittering is applied when jitter=TRUE.
    Warnings about tied values should not occur any more.
    
    o plot.im
    Improved behaviour when all pixel values are NA.

    o plot.tess
    Now generates a separate plot panel for each column of marks,
    if do.col=TRUE.
    New argument 'multiplot'.
    
    o pcfinhom
    Now handles correction='good'

    o solist
    New argument '.NameBase'

    o runifpointOnLines, rpoisppOnLines
    New argument 'drop'

    o plot.studpermutest
    This existing function now has a help file.

    o bdist.points
    Accelerated, for polygonal windows (thanks to Sebastian Meyer).

    o linnet
    When argument 'edges' is specified, the code now checks whether
    any edges are duplicated.
    
BUG FIXES

    o kernel.moment
    Result was incorrect for kernel="cosine" and kernel="optcosine".
    Fixed.
    
    o "[.msr"
    Format was mangled if the subset contained exactly one quadrature point.
    Fixed.

    o tess
    If a list of tiles was given, and the tiles were pixel images or masks,
    their pixel resolutions were ignored, and reset to the default 128x128.
    Fixed.
    
    o plot.linim
    Ignored argument 'legend' when style="colour".
    [Spotted by Suman Rakshit.]
    Fixed.

    o leverage.ppm, influence.ppm, dfbetas.ppm
    Crashed sometimes if the model was fitted by method="logi".
    Fixed.

    o Smooth.ppp
    Crashed with some combinations of the arguments varcov and weights
    when X had several columns of marks.
    Fixed.

    o plot.tess
    Crashed sometimes when do.col=TRUE and values=NULL.
    Fixed.

    o dilation.ppp
    Crashed if polygonal=FALSE.
    
    o plot.tess
    Ignored the marks of a tessellation defined by a pixel image.
    Fixed.
    
    o predict.ppm
    Crashed when computing a confidence interval or prediction interval
    if 'window' was a tessellation.
    Fixed.

    o tiles
    names(tiles(x)) was not always identical to tilenames(x).
    Fixed.

    o model.images.lppm
    Crashed in many cases.
    Fixed.
    
    o model.images.lppm
    Names or dimnames were missing in some cases.
    Fixed.

    o nncross.ppp
    Result had the wrong format if npoints(X) = 0 and length(what) = 1.
    (Spotted by Sebastian Meyer).
    Fixed.
    
    o plot.colourmap
    Crashed if the colourmap was defined on an interval of dates or times.
    Fixed.

    o StraussHard, leverage.ppm, influence.ppm, dfbetas.ppm
    Leverage and influence calculations generated an error 
    when applied to models fitted with the StraussHard interaction.
    Fixed.

    o "[.ppp"
    Crashed if there were several columns of marks,
    some of which were factors, and drop=TRUE.
    Fixed.
    
        CHANGES IN spatstat VERSION 1.55-1

OVERVIEW

    o We thank Jens Astrom, Ines Moncada, Mehdi Moradi and Nicholas Read
    for contributions.
    
    o More support for tessellations.

    o Improved support for linear networks.

    o Fixed longstanding bug in leverage and influence diagnostics.
    
    o Minor improvements and bug fixes.

    o Version nickname: "Gamble Responsibly"

NEW FUNCTIONS

    o summary.ssf
    Summary method for a spatially sampled function (class 'ssf').

    o unstack.tess
    Given a tessellation with multiple columns of marks,
    take the columns one at a time, and return a list of tessellations,
    each carrying only one of the original columns of marks.
    
SIGNIFICANT USER-VISIBLE CHANGES

    o plot.tess
    This plot method can now fill each tile with a different colour.
    New arguments 'do.col', 'values', 'col' and 'ribargs'.
    Old argument 'col' has been renamed 'border' for consistency.

    o integral.linim, integral.linfun
    Argument 'domain' can now be a tessellation.
    
    o integral.ssf
    Argument 'domain' can now be a tessellation.

    o as.owin.default
    Now accepts a structure with entries named 'xmin,ymin,xmax,ymax'
    in any order. This handles objects of class 'bbox' in the 'sf' package.

    o as.owin.default
    Now detects objects of class "SpatialPolygons"
    and issues a more helpful error message.
    
    o pseudoR2.ppm, pseudoR2.lppm
    The null model now includes any offset terms, by default.
    [Suggested by Jens Astrom.]
    New argument 'keepoffset'.
    
    o closepairs.ppp
    New argument 'periodic'
    
    o fitted.ppm
    New argument 'ignore.hardcore'.
    
    o predict.ppm
    New argument 'ignore.hardcore'.
    
    o leverage.ppm, influence.ppm, dfbetas.ppm
    Computation has been vastly accelerated for models with Geyer interaction
    fitted using isotropic or translation edge corrections.
    
    o leverage.ppm, influence.ppm, dfbetas.ppm
    Virtually all models and edge corrections are now supported,
    using a "brute force" algorithm. This can be slow in some cases.

    o cdf.test
    Monte Carlo test runs faster.

    o summary.distfun, summary.funxy
    Pixel resolution can now be controlled.

    o persp.funxy
    Improved z-axis label.

    o plot.ppp
    Improved placement of symbol legend when argument 'symap' is given.
    
    o plot.msr
    Changed the default rule for bandwidth for smoothing the density.
    
BUG FIXES

    o nnmark, as.im.ssf
    if marks(X) was a matrix rather than a data frame, 
    the results were completely incorrect (and had completely wrong format).
    Fixed.

    o predict.mppm
    If the model included random effects, and if the library 'MASS' was not loaded,
    the predictions were on the log scale (i.e. they were logarithms of the correct values).
    [Spotted by Nicholas Read.]
    Fixed.
    
    o leverage.ppm, influence.ppm, dfbetas.ppm
    Calculations were slightly incorrect for models with a hard core.
    Fixed.

    o leverage.ppm
    The mean leverage value (shown as a contour line in plot.leverage.ppm)
    was slightly incorrect for Gibbs models.
    Fixed.
    
    o Ops.msr
    If the input data contained an auxiliary pixel image of
    the density component of the measure (attribute "smoothdensity")
    this image was not updated; it was copied to the output unchanged.
    Plots of the resulting measure were incorrect, but calculations
    with the measure were correct.
    Fixed.
    
    o integral.msr
    If the result was a matrix, it was the transpose of the correct answer.
    Fixed.

    o "[.linim"
    The result sometimes had the wrong class.
    Fixed.

    o "[.linnet"
    In calculating L[W] where W is a window, the code ignored
    segments of L that crossed W without having a vertex in W.
    Fixed.

    o nnmap
    Crashed if W = NULL.
    Fixed.

    o density.lpp, nncross.lpp
    Crashed sometimes with an obscure message about "z$which".
    [Spotted by Ines Moncada.]
    Fixed.
    
    o as.im.distfun
    Crashed, for the distfun of a point pattern, if approx=FALSE.
    Fixed.

    o as.solist
    Crashed when x was a 'layered' object.
    Fixed.
    
    o linnet
    Crashed in some trivial cases where there were no points or lines.
    Fixed.
    
        CHANGES IN spatstat VERSION 1.55-0

OVERVIEW

    o We thank 'AdriMaz' and Nicholas Read for contributions.
    
    o Lurking variable plot for models fitted to several point patterns.

    o Improvements to code for class 'mppm'.

    o Improvements to leverage and influence diagnostics.

    o Improved summary information for funxy and distfun objects.
    
    o Bug fixes and improvements.

    o Removed old warnings and deprecated functions.
    
    o Nickname: "Stunned Mullet"

NEW FUNCTIONS

    o contour.leverage.ppm
    Method for 'contour' for leverage functions of class 'leverage.ppm'
    
    o lurking
    New generic function for lurking variable plots.

    o lurking.ppp, lurking.ppm
    These are equivalent to the original function 'lurking'.
    They are now methods for the new generic 'lurking'.

    o lurking.mppm
    New method for class 'mppm'
    Lurking variable plot for models fitted to several point patterns.

    o print.lurk
    Prints information about the object returned by the function 'lurking'
    representing a lurking variable plot.

    o model.matrix.mppm
    Method for 'model.matrix' for models of class 'mppm'.

    o test.crossing.psp,  test.selfcrossing.psp
    Previously undocumented functions for testing whether segments cross.
    
SIGNIFICANT USER-VISIBLE CHANGES

    o predict.ppm
    Now recognises the arguments 'dimyx' and 'eps' for specifying the
    resolution of the grid of prediction points.

    o leverage.ppm, dfbetas.ppm
    Increased the default resolution of the pixel images.
    Spatial resolution can now be controlled by the arguments 'dimyx', 'eps'.

    o ppmInfluence
    The result now belongs to class 'ppmInfluence', for which there are
    methods for 'leverage', 'influence', 'dfbetas' which extract the
    desired component.

    o plot.leverage.ppm
    New argument 'what'.
    
    o persp.leverage.ppm
    New arguments 'zlab' and 'what'.
    
    o as.im.leverage.ppm
    New argument 'what'.
    
    o summary.funxy, summary.distfun
    Printed information now includes a summary of the function values.
    
    o lurking.ppm
    Accelerated.

    o "[.psp"
    Accelerated.
    
    o clf.test, conspire, bounding.box, ksmooth.ppp, mpl, superimposePSP,
    eval.hyper, smooth.fv, smooth.ppp, smooth.msr, rtoro, plot.kstest
    These deprecated functions have now been removed.

    o bermantest
    This deprecated function has now been removed.
    Use berman.test instead.
    
    o kstest
    This deprecated function has now been removed.
    Use cdf.test instead.

    o plot.ppp
    A very old warning, about the interpretation of the mark scale
    as the circle diameter, is no longer printed.

BUG FIXES

    o nnmap, nnmark
    Values were incorrect if the resulting pixel image
    had unequal numbers of rows and columns.
    Fixed.

    o vcov.mppm
    Format was incorrect (rows/columns were omitted) in some cases.
    Fixed.

    o model.matrix.ppm, model.frame.ppm
    Values were sometimes incorrect when applied to the result of subfits().
    To be precise, if 'fit' was an mppm object fitted to a hyperframe
    that included 'design covariates' (covariates that take a constant value
    in each row of the hyperframe), and if 'futs <- subfits(fit)', then
    model.matrix(futs[[i]]) gave incorrect values in the columns
    corresponding to the design covariates. 
    Fixed.

    o model.matrix.ppm
    The attribute 'assign' was omitted, in some cases.
    Fixed.

    o simulate.dppm, simulate.detpointprocfamily
    In dimensions higher than 2, the result was shifted so that
    it was centred at the origin.
    Fixed.
    
    o Smooth.ppp
    Crashed if geometric=TRUE and there were several columns of marks.
    Fixed.
    
    o simulate.dppm, simulate.detpointprocfamily
    Crashed if nsim > 1 and the spatial dimension was not equal to 2.
    Fixed.

    o plot.leverage.ppm
    Contour line was annotated, which was not intended.
    Fixed.


    o leverage.ppm
    The leverage function was oversmoothed, when the model was fitted
    with method="logi".
    Fixed.
    
        CHANGES IN spatstat VERSION 1.54-0

OVERVIEW

    o We thank Rochelle Constantine, Lily Kozmian-Ledward,
    Ian Renner and Leigh Torres for contributions.

    o New dataset 'cetaceans'.
    
    o Gamma correction for colour maps and image plots.

    o Class 'units' has been renamed 'unitname' to avoid package collision.

    o Bug fix in leverage code

    o Tighter bounding box for psp, lpp, linnet objects.
    
    o Improved layout in plot.solist

    o Tools to increase colour saturation.

    o Connected components of a 3D point pattern.
    
    o Accelerated computations on linear networks.

    o Accelerated simulation of determinantal point processes.

    o Improved printing of 3D point patterns.
    
    o Minor corrections to handling of unitnames.
    
    o Nickname: 'Vacuous Mission Statement' 

NEW DATASETS

    o cetaceans
    Nine replicates of a marine survey in New Zealand,
    consisting of recorded sightings of dolphins, whales and other species.
    Generously contributed by Lily Kozmian-Ledward, Rochelle Constantine
    and Leigh Torres.
    
NEW FUNCTIONS

    o to.saturated
    Convert a colour value to the corresponding fully-saturated colour.

    o intensity.psp
    Compute the average total length of segments per unit area.

    o boundingbox.psp
    Bounding box for line segment patterns.
    This produces a tighter bounding box than the previous default behaviour.

    o boundingbox.lpp
    Bounding box for point patterns on a linear network.
    This produces a tighter bounding box than the previous default behaviour.

    o boundingbox.linnet
    Bounding box for a linear network.
    This produces a tighter bounding box than the previous default behaviour.

    o "Frame<-.default"
    New default method for assigning bounding frame to a spatial object.

    o connected.pp3
    Connected components of a 3D point pattern.

    o colouroutputs, "colouroutputs<-"
    Extract or assign colour values in a colour map.
    (Documented a previously-existing function)
    
SIGNIFICANT USER-VISIBLE CHANGES

    o plot.im
    New argument 'gamma' supports gamma correction of colour maps.
    New argument 'ncolours' specifies the default number of colours.

    o colourmap, lut
    New argument 'gamma' supports gamma correction of colour maps.
    
    o plot.solist, plot.anylist
    New argument 'panel.vpad' controls vertical space for panel title
    when equal.scales=FALSE.

    o class 'units'
    The class 'units' has been renamed 'unitname' to avoid a clash with
    other packages.

    o unitname
    The generic function 'unitname' now returns an object of class 'unitname'. 
    
    o print.units, summary.units, print.summary.units, as.character.units,
    compatible.units
    These methods are now called print.unitname, summary.unitname,
    print.summary.unitname, as.character.unitname and compatible.unitname.

    o as.units
    This function has been renamed 'as.unitname' and now returns
    an object of class 'unitname'.

    o rescale.units
    This method has been renamed 'rescale.unitname' and now returns
    an object of class 'unitname'.

    o profilepl
    New argument 'fast' controls the use of shorcuts.

    o reload.or.compute
    New argument 'force'.

    o pixellate.ppp, pixellate.owin, pixellate.psp
    New argument 'DivideByPixelArea'.

    o density.psp
    New argument 'at' determines locations where the density is evaluated.
    
    o as.solist
    as.solist(x) always returns an object of class 'solist',
    removing any additional classes.

    o lineardirichlet
    Accelerated.

    o integral.linim
    Accelerated.
    
    o "[.ppp", "[.lpp", "[.psp"
    In the expression X[W] where W is a window,
    if X has a unitname but W does not, 
    the result now inherits the unitname of X.
    
    o distfun.ppp
    New argument 'undef'.
    
    o print.pp3
    More informative output when x is marked.
    
BUG FIXES

    o leverage.ppm, influence.ppm, dfbetas.ppm
    Calculations were slightly incorrect for models fitted using the
    border correction.
    Fixed.

    o integral.linim
    Gave incorrect value in some extreme cases
    (where many network segments were shorter than one pixel width).
    Fixed.
    
    o update.kppm
    Did not function correctly when several additional arguments were given.
    Fixed.

    o plot.solist
    Panel titles were cut off, when equal.scales=FALSE (the default).
    Fixed.

    o intersection.owin, union.owin, setminus.owin
    The result sometimes did not inherit the correct 'unitname'.
    Fixed.
    
        CHANGES IN spatstat VERSION 1.53-2

OVERVIEW

    o We thank Christophe Biscio and Rasmus Waagepetersen for contributions.

    o Correction to 'lohboot'

    o Improvements to ppm and update.ppm

    o Bug fixes and minor improvements.
    
    o Nickname: "Quantum Entanglement"

NEW FUNCTIONS

    o fitin.profilepl
    Extract the fitted interaction from a model fitted by profile likelihood.
    
SIGNIFICANT USER-VISIBLE CHANGES

    o lohboot
    Algorithm has been corrected and extended
    thanks to Christophe Biscio and Rasmus Waagepetersen.
    New arguments 'block', 'basicboot', 'Vcorrection'.

    o ppm.ppp, ppm.quad
    New argument 'clipwin'

    o update.ppm
    For the case 'update(model, X)' where X is a point pattern,
    if the window of X is different from the original window,
    then the model is re-fitted from scratch (i.e. use.internal=FALSE).
    
    o plot.leverage.ppm
    A contour line showing the average value of leverage
    is now drawn on the colour ribbon, as well as on the main image.
    New argument 'args.contour'.
    
BUG FIXES

    o lohboot
    Implementation was completely incorrect.
    [Spotted and fixed by Christophe Biscio and Rasmus Waagepetersen.]
    Fixed.
    
    o update.ppm
    Did not always work correctly with formulae that included 'polynom()' terms.
    Fixed.

        CHANGES IN spatstat VERSION 1.53-1

OVERVIEW

    o We thank Suman Rakshit for contributions.
    
    o Bug fix in plot.linim

    o Nickname: "Drongo"

BUG FIXES

    o plot.linim
    Colour map was mangled if log=TRUE.
    Fixed.
    
        CHANGES IN spatstat VERSION 1.53-0

OVERVIEW

    o We thank Tilman Davies and Mehdi Moradi for contributions.

    o Numerous bug fixes for linear networks code.

    o spatstat now requires the sub-package 'spatstat.data'
    which contains the datasets.
    
    o Minor enhancements and bug fixes.

    o Nickname: "Tinfoil Hat"

NEW FUNCTIONS

    o "[<-.linim"
    Subset assignment method for pixel images on a linear network.

    o nnfromvertex
    Given a point pattern on a linear network,
    find the nearest data point from each vertex of the network.
    
    o tile.lengths
    Calculate the length of each tile in a tessellation on a network.

    o text.ppp, text.lpp, text.psp
    Methods for 'text' for spatial patterns.

SIGNIFICANT USER-VISIBLE CHANGES

    o datasets
    All datasets installed in 'spatstat' have now been moved
    into the sub-package 'spatstat.data'. This should not have any effect
    on normal use. The 'spatstat.data' package is automatically loaded
    when spatstat is loaded, and the datasets are lazy-loaded so that
    they are available in the usual way. To list all datasets you now need
    to type 'data(package="spatstat.data")'
    
    o nbfires
    This dataset now includes information about the different 
    land and sea borders of New Brunswick.

    o rhohat
    New argument 'subset' allows computation for a subset of the data.

    o predict.lppm
    Argument 'locations' can now be an 'lpp' object.

    o ewcdf
    Argument 'weights' can now be NULL.

    o plot.msr
    New arguments 'equal.markscale' and 'equal.ribbon'.

    o plot.im
    The number of tick marks in the colour ribbon can now be controlled
    using the argument 'nint' in 'ribargs'.

    o plot.symbolmap
    New argument 'nsymbols' controls the number of symbols plotted.

    o square
    Handles a common error in the format of the arguments.

    o [.linim
    More robust against artefacts.
    
    o [.linnet
    More robust against artefacts when the subset index is a pixel mask.

    o linim
    The image Z is now automatically restricted to the network.
    New argument 'restrict'.

    o plot.linim
    When style="width", negative values are plotted in red (by default).
    New argument 'negative.args' controls this.

    o plot.linim
    New argument 'zlim' specifies the range of values to be mapped.

    o Summary.linim
    Recognises the argument 'finite' so that range(x, finite=TRUE)
    works for a linim object x.
    
    o identify.psp
    Improved placement of labels.
    Arguments can be passed to text.default to control the plotting of labels.
    
    o as.polygonal
    Accelerated when w is a pixel mask.

    o density.lpp
    Accelerated in the default case.
    
    o Kinhom
    Stops gracefully if 'lambda' contains any zero values.
    
    o print.linim
    Prints more information.

BUG FIXES

    o with.msr
    The value of 'atommass' was incorrect, due to a coding error.
    Fixed.

    o [.linim
    Internal data was sometimes corrupted.
    Fixed.
    
    o as.linim
    The result had incorrect internal format when Window(X) was a mask
    and one of the arguments 'eps', 'dimyx', 'xy' was present.
    Fixed.

    o as.im.im
    If W was a rectangle or polygonal window, the pixel resolution of the 
    result was determined by the spatstat defaults, rather than being
    determined by the image argument X. This was contrary to the
    rule advertised in help(as.im). 
    Fixed.

    o density.lpp
    In the 'slow' case (kernel not Gaussian, or continuous=FALSE),
    occasionally a pixel could incorrectly be assigned the value 1.
    [Spotted by Mehdi Moradi.]
    Fixed.
    
    o "[.solist"
    Ignored the "..." arguments in some cases.
    Fixed.

    o density.lpp
    Ignored the resolution arguments 'eps', 'dimyx' in the default case.
    Fixed.

    o plot.msr
    Plotted the panel titles on top of each other, if how="contour".
    Fixed.
    
    o contour.im
    Plotted the title text at the wrong place when add=TRUE and show.all=TRUE.
    Fixed.
    
    o predict.lppm
    Crashed if 'locations' was an 'lpp' object.
    Fixed.

    o plot.ppp
    Crashed if the window had height 0 and width 0
    and the pattern had several columns of marks.
    Fixed.
    
    o plot.solist
    Crashed if all panels had windows of height 0 and width 0.
    Fixed.

    o linearK, linearKinhom, linearpcf, linearpcfinhom
    Crashed if the linear network was disconnected and one component
    of the network contained fewer than 2 points.
    Fixed.

    o integral.linim
    Crashed in some cases.
    Fixed.
    
    o "[.linim"
    Crashed in some cases.
    Fixed.

        CHANGES IN spatstat VERSION 1.52-1

OVERVIEW

    o Bug fix to satisfy the development version of R.
    
    o Nickname: "Apophenia"

SIGNIFICANT USER-VISIBLE CHANGES

    o Ops.imlist
    Improved the 'names' of the result.

BUG FIXES

    o bw.smoothppp
    Crashes in R-devel.
    Fixed.

        CHANGES IN spatstat VERSION 1.52-0

OVERVIEW

    o We thank Nicholas Read, Abdollah Jalilian, Suman Rakshit,
    Dominic Schuhmacher and Rasmus Waagepetersen for contributions.

    o Important bug fixes.
    
    o Now handles disconnected linear networks.

    o Effect function is now available for all types of fitted model.

    o A model can be fitted or re-fitted to a sub-region of data.

    o More support for measures.

    o 'Pool' operations improved.

    o Geometric-mean smoothing.
    
    o Changed algorithm defaults in ippm.

    o Version nickname: "Rudimentary Lathe"

NEW FUNCTIONS

    o as.data.frame.envelope
    Extract function data from an envelope object,
    including the functions for the simulated data ('simfuns')
    if they were saved.

    o is.connected, is.connected.default, is.connected.linnet
    Determines whether a spatial object consists of
    one topologically connected piece, or several pieces.

    o is.connected.ppp
    Determines whether a point pattern is connected after
    all pairs of points closer than distance R are joined.

    o hist.funxy
    Histogram of values of a spatial function.

    o model.matrix.ippm
    Method for 'model.matrix' which allows computation of
    regular and irregular score components.

    o harmonise.msr
    Convert several measures (objects of class 'msr')
    to a common quadrature scheme.
    
SIGNIFICANT USER-VISIBLE CHANGES

    o Smooth.ppp
    New argument 'geometric' supports geometric-mean smoothing.
    
    o Kinhom
    New argument 'ratio'.
    
    o linearKinhom, linearpcfinhom
    Changed default behaviour when 'lambda' is a fitted model.
    New arguments 'update' and 'leaveoneout'.
    
    o linearK, linearKinhom, linearpcf, linearpcfinhom, compilepcf
    Ratio calculations are now supported.
    New argument 'ratio'.
    
    o effectfun
    Now works for 'ppm', 'kppm', 'lppm', 'dppm', 'rppm' and 'profilepl' objects.

    o ppm, kppm
    The argument 'subset' can now be a window (class 'owin')
    specifying the subset of data to which the model should be fitted.

    o fitted.lppm
    New argument 'leaveoneout' allows leave-one-out computation of fitted value.

    o pool.rat
    New arguments 'relabel' and 'variance'.

    o density.lpp
    The return value is a pixel image of class 'linim' in all cases.
    
    o plot.linim, plot.linfun
    A scale bar is now plotted when style="width".
    New argument 'legend'.

    o ippm
    Default values for the parameters of the optimisation algorithm (nlm.args)
    have changed.

    o ippm
    The internal format of the result has been extended slightly.
    
    o bind.fv
    New argument 'clip'.

    o as.im.distfun
    New argument 'approx' specifies the choice of algorithm.

    o "[.psp"
    New argument 'fragments' specifies whether to keep fragments of
    line segments that are cut by the new window, or only to retain
    segments that lie entirely inside the window.

    o predict.rhohat
    New argument 'what' determines which value should be calculated:
    the function estimate, the upper/lower confidence limits, or the
    standard error.

    o pool.fv
    New arguments 'relabel' and 'variance'
    
    o pool.rat
    New argument 'weights'.
    
    o plot.msr
    New argument 'massthresh'.

    o Ops.msr
    Calculations like A+B can now be performed even when the measures A and B
    are not defined on the same quadrature scheme.
    
    o density.ppp
    New argument 'verbose'.

    o bw.pcf
    New argument 'verbose'.
    
    o hist.im
    New argument 'xname'.

    o [.leverage.ppm
    New argument 'update'.
    
    o [.layered
    Additional arguments '...' are now passed to other methods.
    
    o logLik.ppm
    The warning about pseudolikelihood ('log likelihood not available')
    is given only once, and is not repeated in subsequent calls,
    within a spatstat session.

    o kppm
    Refuses to fit a log-Gaussian Cox model with anisotropic covariance.

    o plot.linim, plot.linfun
    The return value has a different format.
    Arguments have been renamed and reorganised.

    o density.lpp
    New argument 'old'.

    o ippm
    Accelerated.

    o Smooth.ppp
    Now exits gracefully if any mark values are NA, NaN or Inf.

    o timeTaken
    Now exits gracefully if there is no timing information.

    o nbfires
    The unit of length for the coordinates is now specified in this dataset.
    
BUG FIXES

    o bw.pcf
    Results were totally incorrect due to a typo.
    [Spotted by Abdollah Jalilian and Rasmus Waagepetersen.]
    Fixed.

    o predict.rho2hat
    Results were incorrect for a rho2hat object computed from a point pattern.
    Fixed.
    
    o density.ppp
    If the smoothing bandwidth was very small (e.g.\ smaller than pixel width),
    results were inaccurate if the default resolution was used,
    and completely wrong if another resolution was specified.
    [Spotted by Dominic Schuhmacher.]
    Fixed.
    
    o linearK, linearKinhom, linearpcf, linearpcfinhom, linearKcross,
    linearKdot, linearpcfcross, linearpcfdot, linearKcross.inhom,
    linearKdot.inhom, linearpcfcross.inhom, linearpcfdot.inhom
    Crashed if the network was disconnected.
    Fixed.

    o crossdist.lpp
    Crashed if the network was disconnected.
    Fixed.

    o countends
    Crashed if the network was disconnected.
    Fixed.

    o model.images.ppm
    Crashed for models fitted using 'covfunargs'.
    Fixed.

    o model.matrix.ppm
    Crashed for models fitted using 'covfunargs',
    if argument 'Q' was given.
    Fixed.

    o polynom
    Expansion of some polynomials caused an error message
    about 'invalid model formula'.
    Fixed.
    
    o plot.ppp
    The argument 'type="n"' did not suppress plotting of the legend,
    for marked point patterns.
    Fixed.

    o plot.psp
    Ignored 'show.all' when 'add=TRUE'.
    Fixed.

    o intensity.ppm
    Result had incorrect 'names' attribute in some cases.
    Fixed.

    o marks<-.ppx
    The assignment marks(X) <- a, where 'a' is a single atomic value,
    caused an error if 'X' contained zero points.
    Fixed

    o model.depends
    Crashed when applied to regression models fitted by 'gam',
    or point process models fitted by 'ppm' with 'use.gam=TRUE'.
    Fixed.
    
    o pool.fv
    Crashed sometimes, if the arguments did not have the same set of
    column names.
    Fixed.

    o pool.rat
    Crashed with an error message from 'fmt'
    if there were more than 20 objects to be pooled.
    Fixed.

    o linearK
    The 'theo' column was missing if npoints(X) < 2 and correction="Ang".
    Fixed.
    
    o model.matrix.ppm
    Result was malformed if the model was fitted with 'use.gam=TRUE'.
    Fixed.
    
    o effectfun
    Crashed if 'covname' was omitted,
    if the model was fitted with 'use.gam=TRUE'.
    Fixed.
    
    o nncross.lpp
    Result had incorrect format if Y was empty, in some cases.
    Fixed.

    o linearKinhom
    Plot label for y axis was incorrect.
    [Spotted by Suman Rakshit.]
    Fixed.

    o plot.solist
    If the entries were 'linim' objects, they were plotted using image()
    so arguments like 'style="w"' were ignored.
    Fixed.

    o as.ppp.data.frame
    Crashed if X was an object of class 'tbl_df' from the dplyr package.
    Fixed.
    
    o plot.lpp
    Crashed if there were multiple columns of marks.
    Fixed.
    
        CHANGES IN spatstat VERSION 1.51-0

OVERVIEW

    o We thank Greg McSwiggan, Mehdi Moradi and Tammy L Silva for contributions.

    o New fast algorithm for kernel smoothing on a linear network.

    o Leverage and influence diagnostics extended to Poisson/Gibbs models
      fitted by logistic composite likelihood.
      
    o Two-stage Monte Carlo test.
    
    o Dirichlet/Voronoi tessellation on a linear network.

    o Thinning of point patterns on a linear network.

    o More support for functions and tessellations on a linear network.

    o Improvements and bug fixes.

    o Version nickname: 'Poetic Licence'

NEW FUNCTIONS

    o bits.test:
    Balanced Independent Two-Stage Monte Carlo test,
    an improvement on the Dao-Genton test.

    o lineardirichlet
    Computes the Dirichlet-Voronoi tessellation associated with a
    point pattern on a linear network.

    o domain.lintess, domain.linfun
    Extract the linear network from a 'lintess' or 'linfun' object.

    o summary.lintess
    Summary of a tessellation on a linear network.

    o clicklpp
    Interactively add points on a linear network.
    
    o envelopeArray
    Generate an array of envelopes using a function that returns 'fasp' objects.
    
SIGNIFICANT USER-VISIBLE CHANGES

    o density.lpp
    New fast algorithm (up to 1000 times faster) for the default case
    where kernel="gaussian" and continuous=TRUE.
    Generously contributed by Greg McSwiggan.
    
    o leverage.ppm, influence.ppm, dfbetas.ppm
    These methods now work for models that were fitted by logistic
    composite likelihood (method='logi'). 
    
    o rthin
    Argument X can now be a point pattern on a linear network (class 'lpp').

    o fitted.ppm
    New option: type = "link"
    
    o update.kppm
    New argument 'evaluate'.

    o integral.linfun
    New argument 'delta' controls step length of approximation to integral.

    o as.linim.default
    New argument 'delta' controls spacing of sample points in internal data.

    o as.linfun.lintess
    New argument 'values' specifies the function value for each tile.
    New argument 'navalue'.

BUG FIXES

    o leverage.ppm, influence.ppm, dfbetas.ppm
    Results for Gibbs models were incorrect due to a mathematical error.
    (Results for Poisson models were correct). 
    Fixed.
    
    o leverage.ppm, influence.ppm, dfbetas.ppm, ppmInfluence
    Calculations were incorrect for a Geyer model fitted using
    an edge correction other than "border" or "none".
    Fixed.
    
    o step, kppm, update.kppm
    'step' did not work for kppm objects in some cases
    due to a scoping problem in update.kppm.
    Fixed.
    
    o improve.kppm
    Crashed if the window was not a rectangle.
    Fixed.

    o pcf.ppp, pcfinhom
    Crashed if kernel="epa" rather than "epanechnikov".
    Fixed.

    o alltypes
    Crashed if envelope=TRUE and reuse=FALSE.
    Fixed.

    o pairdist.lpp, nndist.lpp, nnwhich.lpp, nncross.lpp
    Crashed if the network was disconnected.
    Fixed.

    o as.im.linim, as.linim.linim
    Additional arguments such as 'eps' and 'dimyx' were ignored.
    Fixed.
    
    o as.im.default
    Arguments 'eps and 'xy' were ignored if X was a single numeric value.
    Fixed.
    
    o 'timed' class
    Printing of these objects did not work in some locales.
    Fixed.

    o runifpoint
    Ignored 'drop' argument if the window was a rectangle.
    Fixed.
    
        CHANGES IN spatstat VERSION 1.50-0

OVERVIEW

    o We thank Richard Cotton, Adrian Heyner, Abdollah Jalilian,
    Dominic Schuhmacher and Rasmus Waagepetersen for contributions.

    o spatstat now 'Imports' the package 'spatstat.utils'.

    o Bandwidth selection for pair correlation function.

    o Improvements and bug fixes.

    o Version nickname: 'Bunyip Aristocracy'

NEW PACKAGE STRUCTURE

    o spatstat is being split into several sub-packages, to satisfy
    the requirements of CRAN. This should not affect the user:
    existing code will continue to work in the same way.
    Currently there are two sub-packages, called 'spatstat.utils'
    and 'spatstat'. Typing 'library(spatstat)' will load the familiar
    'spatstat' package which can be used as before, and will silently
    import the 'spatstat.utils' package. The 'spatstat.utils' package
    contains utility functions that were originally written for 'spatstat':
    they were undocumented internal functions in 'spatstat', but are now
    documented and accessible in a separate package because they may be
    useful for other purposes. To access these functions, you need to
    type 'library(spatstat.utils)'. 
    

NEW FUNCTIONS

    o bw.pcf
    Bandwidth selection for pair correlation function.
    Original code contributed by Abdollah Jalilian and Rasmus Waagepetersen.

    o grow.box3
    Expand a three-dimensional box.

SIGNIFICANT USER-VISIBLE CHANGES

    o as.owin
    Now refuses to convert a 'box3' to a two-dimensional window.

    o pixellate.ppp
    If the pattern is empty, the result is an integer-valued image
    (by default) for consistency with the results for non-empty patterns.

    o ppp
    If the coordinate vectors x and y contain NA, NaN or infinite values,
    these points are deleted with a warning, instead of causing a fatal error.

    o ppm
    Argument 'interaction' can now be a function that makes an interaction,
    such as Poisson, Hardcore, MultiHard.

    o pcf, pcfinhom
    New argument 'close' for advanced use.

    o runifpointx, rpoisppx
    New argument 'drop'.

    o shapley, ponderosa
    In these installed datasets, the functions shapley.extra$plotit
    and ponderosa.extra$plotit have changed slightly (to accommodate the
    dependence on the package spatstat.utils).

    o kppm
    Improved printed output.

BUG FIXES

    o rMaternI, rMaternII
    If 'win' was a three-dimensional box of class 'box3', 
    the result was a two-dimensional point pattern.
    [Spotted by Adrian Heyner.]
    Fixed.

    o rmhmodel.ppm, simulate.ppm
    Crashed when applied to a fitted Lennard-Jones model.
    [Spotted by Dominic Schuhmacher.]
    Fixed.
    
    o leverage.ppm, influence.ppm, dfbetas.ppm
    Crashed when applied to some hard-core models.
    Fixed.

    o "[.ppx"
    The format of the result was slightly malformed 
    if exactly one point was selected.
    Fixed.

    o unmark.lpp, marks<-.lpp
    The result had class c("lpp", "lpp", "ppx") instead of c("lpp", "ppx").
    Fixed.

        CHANGES IN spatstat VERSION 1.49-0

OVERVIEW

    o We thank Tilman Davies, Kassel Hingee, Abdollah Jalilian,
    Brian Ripley and Dominic Schuhmacher for contributions.

    o spatstat now 'Suggests' the package 'fftwtools'.

    o Operations on signed measures.

    o Operations on lists of pixel images.

    o Improved pixellation of point patterns.

    o Stieltjes integral extended.

    o Subset operators extended.

    o Greatly accelerated 'rmh' when using 'nsave'

    o Some computations accelerated.

    o Size of namespace reduced, for efficiency.

    o Bug fixes.

    o Version nickname: 'So-Called Software'

NEW DEPENDENCIES

    o fftwtools
    spatstat now 'Suggests' the package 'fftwtools'.
    This package provides a very fast implementation of 
    the Fast Fourier Transform, leading to much faster computation
    in the spatstat functions 'density.ppp', 'relrisk.ppp', 'convolve.im',
    'blur', 'scan.test' and many other functions.
    The 'fftwtools' package requires the external software library 'fftw'.
    We strongly recommend installing this library if possible.

NEW FUNCTIONS

    o hexagon, regularpolygon
    Create regular polygons.

    o Ops.msr
    Arithmetic operations for measures.

    o Math.imlist, Ops.imlist, Summary.imlist, Complex.imlist
    Arithmetic operations for lists of pixel images.

    o measurePositive, measureNegative, measureVariation, totalVariation
    Positive and negative parts of a measure, and variation of a measure.

    o as.function.owin
    Convert a spatial window to a function (x,y), the indicator function.

    o as.function.ssf
    Convert an object of class 'ssf' to a function(x,y)

    o as.function.leverage.ppm
    Convert an object of class 'leverage.ppm' to a function(x,y)

SIGNIFICANT USER-VISIBLE CHANGES

    o stieltjes
    Argument 'M' can be a stepfun object (such as an empirical CDF).

    o quantile.ewcdf
    The function is now normalised to the range [0,1]
    before the quantiles are computed. 
    This can be suppressed by setting normalise=FALSE.

    o pixellate.ppp
    New arguments 'fractional' and 'preserve' for more accurate discretisation.

    o "[.layered"
    Subset index i can now be an 'owin' object.

    o "[.solist"
    Subset index i can now be an 'owin' object.

    o plot.solist, plot.imlist, plot.anylist
    Result is now an (invisible) list containing the result
    from executing the plot of each panel.

    o ppp
    New argument 'checkdup'.

    o Summary.im
    Argument 'na.rm' is no longer ignored.

    o cdf.test 
    The methods for classes ppp, ppm, lpp, lppm, slrm
    have a new argument 'interpolate'.

    o as.solist
    The argument x can now be a spatial object;
    as.solist(cells) is the same as solist(cells).

    o bw.diggle, bw.ppl, bw.relrisk, bw.smoothppp
    These functions now extract and store the name of the unit of length
    from the point pattern dataset. When the bandwidth selection criterion
    is plotted, the name of the unit of length is shown on the x-axis.
    
    o polynom
    This function now has a help file.

    o rmhcontrol
    New parameter 'pstage' determines when to generate random proposal points.

    o rmh
    Accelerated, in the case where multiple patterns are saved using 'nsave'.

    o bdist.pixels
    Accelerated for polygonal windows. New argument 'method'.

    o spatstat namespace
    The namespace of the spatstat package has been shortened
    (by internally registering the native routines) which should
    make the package run faster.

    o sum.im, range.im, max.im, min.im
    These functions have been removed, as they are now subsumed in Summary.im.

BUG FIXES

    o plot.msr
    If one of 'nrows' or 'ncols' was specified, but not both,
    an obscure error occurred.
    Fixed.

    o plot.solist, plot.imlist, plot.anylist
    Crashed if 'nrows' and 'ncols' were given values implying
    that some rows or columns would not contain any plots.
    Fixed.

    o as.ppp.lpp
    Crashed if there was more than one column of marks.
    Fixed.

    o has.close.pp3
    Results were incorrect, or a crash occurred, when argument 'Y' was given.
    Fixed.

    o rmpoispp
    If 'lambda' was a list of images, 'names(lambda)' was ignored,
    rather than serving as the default value of 'types'.
    Fixed.

    o bugfixes
    Output was garbled, in rare cases.
    Fixed.

    o kppm
    Result was malformed when clusters="VarGamma" and method="clik2".
    Spotted by Abdollah Jalilian.
    Fixed.

    o QQversion
    Plotting labels were malformed.
    Fixed.

        CHANGES IN spatstat VERSION 1.48-0

OVERVIEW

    o We thank Kim Colyvas, Yongtao Guan, Gopalan Nair, 
    Nader Najari, Suman Rakshit, Ian Renner and Hangsheng Wang 
    for contributions.

    o Sufficient Dimension Reduction for point processes.

    o Alternating Gibbs Sampler for point process simulation.

    o Intensity approximation for area-interaction and Geyer models.

    o New class of spatially sampled functions.

    o ROC and AUC extended to other types of point patterns and models.

    o More support for linear networks.

    o More support for infinite straight lines.

    o Simulation of 'rhohat' objects.

    o Kernel smoothing accelerated.

    o Methods for 'head' and 'tail' for spatial patterns.

    o More low-level functionality.

    o Improvements and bug fixes.

    o spatstat now has more than 1000 help files.

    o Nickname: 'Model Prisoner'

NEW CLASSES

    o ssf
    Class of spatially sampled functions.

NEW FUNCTIONS

    o sdr, dimhat
    Sufficient Dimension Reduction for point processes.
    Matlab code contributed by Yongtao Guan, translated by Suman Rakshit.

    o rags, ragsAreaInter, ragsMultiHard
    Alternating Gibbs Sampler for point processes.

    o psib
    Sibling probability (index of clustering strength in a cluster process).

    o bugfixes    
    List all bug fixes in recent versions of a package.

    o roc.kppm, roc.lppm, roc.lpp
    Methods for 'roc' (receiver operating characteristic curve)
    for fitted models of class 'kppm' and 'lppm'
    and point patterns of class 'lpp'

    o auc.kppm, auc.lppm, auc.lpp
    Methods for 'auc' (area under the ROC curve)
    for fitted models of class 'kppm' and 'lppm'
    and point patterns of class 'lpp'

    o rlpp
    Random points on a linear network with a specified probability density.

    o cut.lpp
    Method for 'cut' for point patterns on a linear network.

    o crossing.linnet
    Find crossing points between a linear network and another set of lines.

    o ssf
    Create a spatially sampled function

    o print.ssf, plot.ssf, contour.ssf, image.ssf
    Display a spatially sampled function

    o as.im.ssf, as.ppp.ssf, marks.ssf, marks<-.ssf, unmark.ssf, [.ssf, with.ssf
    Manipulate data in a spatially sampled function

    o Smooth.ssf
    Smooth a spatially sampled function 

    o integral.ssf
    Approximate integral of spatially sampled function

    o simulate.rhohat
    Generate a Poisson random point pattern with intensity that is
    a function of a covariate, given by a 'rhohat' object.

    o head.ppp, head.ppx, head.psp, head.tess, 
    tail.ppp, tail.ppx, tail.psp, tail.tess
    Methods for 'head' and 'tail' for spatial patterns.

    o as.data.frame.tess
    Convert a tessellation to a data frame.

    o timeTaken
    Extract the timing data from a 'timed' object or objects.

    o rotate.infline, shift.infline, reflect.infline, flipxy.infline
    Geometrical transformations for infinite straight lines.

    o whichhalfplane
    Determine which side of an infinite line a point lies on.

    o points.lpp
    Method for 'points' for point patterns on a linear network.

    o pairs.linim
    Pairs plot for images on a linear network.

    o has.close
    Faster way to check whether a point has a close neighbour.

    o closetriples
    Low-level function to find all close triples of points.

    o matrixpower, matrixsqrt, matrixinvsqrt
    Raise a matrix to any power.

SIGNIFICANT USER-VISIBLE CHANGES

    o intensity.ppm
    Intensity approximation is now available for the Geyer saturation process
    and the area-interaction process (results of research with Gopalan Nair).

    o envelope.lpp, envelope.lppm
    New arguments 'fix.n' and 'fix.marks' allow envelopes to be computed
    using simulations conditional on the observed number of points.

    o "[.im"
    The subset index "i" can now be a linear network (object of class 'linnet').
    The result of "x[i, drop=FALSE]" is then a pixel image of class 'linim'.

    o cut.ppp
    Argument z can be "x" or "y" indicating one of the spatial coordinates.

    o rThomas, rMatClust, rCauchy, rVarGamma, rPoissonCluster, rNeymanScott
    New argument 'saveparents'.

    o lintess
    Argument 'df' can be missing or NULL, 
    resulting in a tesellation with only one tile.

    o lpp
    X can be missing or NULL, resulting in an empty point pattern.

    o plot.lintess
    Improved plot method, with more options.

    o rpoisline
    Also returns information about the original infinite random lines.

    o density.ppp, Smooth.ppp
    Accelerated.

    o density.psp
    New argument 'method' controls the method of computation.
    New faster option 'method="FFT"'    

    o nndist.lpp
    Accelerated.

BUG FIXES

    o F3est
    Estimates of F(r) for the largest value of r were wildly incorrect.
    Fixed.

    o clip.infline
    Results were incorrect unless the midpoint of the window
    was the coordinate origin.
    Fixed.

    o integral.linim
    Results were inaccurate if many of the segment lengths were 
    shorter than the width of a pixel.
    Fixed.

    o predict.lppm
    Bizarre error messages about 'class too long' or 'names too long'
    occurred if the model was multitype.
    Fixed.

    o superimpose
    Point patterns containing 0 points were ignored
    when determining the list of possible marks.
    Fixed.

    o chop.tess
    Vertical lines were not handled correctly 
    with pixellated tessellations.
    Fixed.

    o timed
    Argument 'timetaken' was ignored.
    Fixed.    

    o ppm
    Crashed if method="logi" and the 'covariates' were a data frame.
    [Spotted by Kim Colyvas and Ian Renner.]
    Fixed.

    o rpoislpp, runiflpp
    Crashed if nsim > 1.
    Fixed.

    o rpoisline
    Crashed if zero lines were generated.
    Fixed.

    o model.frame.ppm
    Crashed if the original model was fitted to a data frame of covariates
    and there were NA's amongst the covariate values.
    [Spotted by Kim Colyvas.]
    Fixed.

    o any, all
    When applied to pixel images (objects of class 'im') the result 
    was sometimes NA when a finite value should have been returned.
    Fixed.    
   
    o predict.rhohat
    When the original data were on a linear network,
    the result of predict.rhohat did not belong to the correct class 'linim'.
    Fixed.
 
        CHANGES IN spatstat VERSION 1.47-0

OVERVIEW

    o We thank Marcel Austenfeld, Guy Bayegnak, Tilman Davies, Cenk Icos, 
    Jorge Mateu, Frederico Mestre, Mehdi Moradi, Virginia Morera Pujol,
    Suman Rakshit and Sven Wagner for contributions.

    o Non-Gaussian smoothing kernels.

    o Important bug fix in linearK, linearpcf

    o Changed internal format of linnet and lpp objects.

    o Faster computation in linear networks.

    o Bias correction techniques.

    o Bounding circle of a spatial object.

    o Minkowski sum also applicable to point patterns and line segment patterns.

    o Option to plot marked points as arrows.

    o Kernel smoothing accelerated.

    o Workaround for bug in some graphics drivers affecting image orientation.

    o Bug fixes and improvements.

    o Version nickname: 'Responsible Gambler'

NEW FUNCTIONS

    o anyNA.im
    Method for 'anyNA' for pixel images.

    o bc
    Bias correction (Newton-Raphson) for fitted model parameters. 
    See also 'rex'.

    o boundingcircle, boundingcentre
    Find the smallest circle enclosing a window or point pattern.

    o "[.linim"
    Subset operator for pixel images on a linear network.

    o mean.linim, median.linim, quantile.linim
    The mean, median, or quantiles of pixel values in a 
    pixel image on a linear network.

    o rex
    Richardson extrapolation for numerical integrals and 
    statistical model parameter estimates. 

    o weighted.median, weighted.quantile
    Median or quantile of numerical data with associated weights.

SIGNIFICANT USER-VISIBLE CHANGES

    o linear networks
    The internal format of a 'linnet' (linear network) object
    has been changed. Existing datasets of class 'linnet' and 'lpp'
    are still supported. However, computation will be faster if they
    are converted to the new format. To convert a linnet object L
    to the new format, use L <- as.linnet(L). To convert an lpp object X 
    to the new format, use X <- as.lpp(X).

    o density.ppp, Smooth.ppp
    New argument 'kernel' allows the user to specify the smoothing kernel.

    o density.ppp, Smooth.ppp
    Argument 'weights' can now be a pixel image.

    o MinkowskiSum, %(+)%
    Now accepts arguments which are point patterns or line segment patterns
    as well as windows.

    o plot.im
    New argument 'workaround' to avoid a bug in some device drivers
    that causes the image to be displayed in the wrong spatial orientation.
    [Thanks to Marcel Austenfeld for drawing attention to this.]

    o sumouter
    New argument 'y' allows computation of asymmetric outer products.

    o linearKinhom, linearpcfinhom
    New argument 'normpower'.

    o rmh.default, rmh.ppm
    New arguments 'nsim', 'saveinfo'.

    o symbolmap, plot.ppp, plot.lpp
    New option: shape="arrows" 

    o rcellnumber
    New argument 'mu'.

    o lengths.psp
    New argument 'squared'.

    o plot.linfun
    Now passes arguments to the function being plotted.

    o as.linnet.psp
    If the line segment pattern has marks, then the resulting linear network
    also carries these marks in the $lines component.

    o summary.owin, summary.im
    The fraction of frame area that is occupied by the window/image
    is now reported.

    o density.ppp, Smooth.ppp
    Computation accelerated by about 15% 
    in the case where at='points' and kernel='gaussian'.

    o linearK, linearpcf
    Accelerated by about 40%.

    o pixellate.ppp
    Accelerated in the case where weights are given

    o density.ppp
    Accelerated in the cases where weights are given or 'diggle=TRUE'
    
    o dilation.ppp
    Improved geometrical accuracy.
    Now accepts arguments to control resolution of polygonal approximation.

    o discs
    New argument 'npoly'. 
    Accelerated in some cases. 

    o plot.pp3
    New arguments 'box.front', 'box.back' control plotting of the box.

    o grow.rectangle
    New argument 'fraction'.

    o nnfun.lpp
    New argument 'k'.

    o bw.ppl
    New argument 'sigma'.

    o lppm
    New argument 'random' controls placement of dummy points.

    o rhohat.lpp
    New argument 'random' controls placement of dummy points.

    o quadrat.test.ppm
    Accelerated in the case where the original window is a rectangle.

    o kppm, mincontrast, cauchy.estpcf, lgcp.estpcf, matclust.estpcf,
    thomas.estpcf, vargamma.estpcf
    A warning about infinite values of the summary function 
    no longer occurs when the default settings are used.

    o circumradius
    This function is now deprecated, in favour of 'boundingradius'

    o print.quad
    More information is printed.

BUG FIXES

    o linearK, linearpcf, and relatives:
    These functions were sometimes greatly underestimated
    when the network had segments shorter than 10 coordinate units.
    [Bug introduced in spatstat 1.44-0, december 2015.]
    Fixed.

    o integral.linim, integral.linfun
    Results were slightly inaccurate because of a bias in the
    distribution of sample points.
    [Bug introduced in spatstat 1.41-0, february 2015.]
    Fixed.

    o intensity.ppm
    Result was incorrect for Gibbs models if the model was *exactly* 
    equivalent to a Poisson process (i.e. if all interaction
    coefficients were exactly zero).
    [Bug introduced in spatstat 1.28-1, june 2012.]
    Fixed.

    o rSSI
    Sometimes terminated prematurely.
    [Spotted by Frederico Mestre.]
    Fixed.

    o perspPoints
    Crashed if the image Z contained NA 
    (i.e. if Z was only defined on a subset of the bounding frame).
    Spotted by Guy Bayegnak.
    Fixed.

    o plot.ppp, plot.lpp
    Crashed if the argument 'shape' was given.
    Fixed.

    o plot.kppm
    Crashed if the model was not fitted by minimum contrast.
    Fixed.

    o superimpose
    Crashed if the argument was a 'solist' containing line segment patterns.
    Fixed.

    o Jest
    Crashed sometimes, depending on the shape of the observation window.
    [Spotted by Cenk Icos.]
    Fixed.

    o plot.studpermutest
    Crashed when the summary statistic was a multitype pair correlation 
    function or multitype K function. [Spotted by Sven Wagner.]
    Fixed.

    o pool.anylist
    Crashed with a message about buffer size,
    if the list was longer than about 100 items.
    Fixed.

    o diagnose.ppm, plot.diagppm
    Crashed in some cases when cumulative=FALSE.
    Fixed.

    o leverage.ppm, influence.ppm, dfbetas.ppm
    Crashed sometimes with a message about wrong replacement length.
    [Spotted by Virginia Morera Pujol.]
    Fixed.

    o as.linnet.psp
    Crashed with marked segment patterns, if any segments were very short.
    [Spotted by Suman Rakshit.]
    Fixed.

    o stieltjes
    Returned NA if some values of f were not finite.
    Fixed.

    o plot.symbolmap
    If a new plot window was initialised, it was sometimes too small
    to contain the geometric figures (circles, squares etc) in the symbol map.
    Fixed.

    o plot.ppp, plot.im
    Ignored xlim, ylim. 
    Fixed.

    o rhohat.lpp
    Ignored nd, eps.
    Fixed.

    o nnfun.lpp
    Print method gave incorrect information about the point pattern.
    Fixed.

    o "[.fv"
    The default plot formula was not updated.
    Fixed.

    o fitted.ppm
    The result was sometimes a 1-dimensional array rather than a numeric vector.
    Fixed.

        CHANGES IN spatstat VERSION 1.46-1

OVERVIEW

    o Important bug fix.

    o Version nickname: 'Spoiler Alert'

BUG FIXES

    o density.ppp, Smooth.ppp
    The results of density(X, at="points") and Smooth(X, at="points")
    were incorrect in some cases. The contribution from the 
    left-most data point (the point with the smallest x coordinate) 
    was omitted.   [Bug introduced in spatstat 1.26-0, April 2012.]
    Fixed.

        CHANGES IN spatstat VERSION 1.46-0

OVERVIEW

    o We thank Corey Anderson and Sebastian Meyer for contributions.

    o spatstat now depends on R 3.3.0 or later.

    o Improvements to inhomogeneous multitype K and L functions.

    o Variance approximation for pair correlation function.

    o Leverage and influence for multitype point process models.

    o Functions for extracting components of vector-valued objects.

    o Important bug fix in Smooth.ppp

    o Minor improvements and bug fixes.

    o Version nickname: 'Multidimensional Toothbrush'

NEW FUNCTIONS

    o split.msr
    Decompose a measure into parts.

    o unstack.msr
    Decompose a vector-valued measure into its component measures.

    o unstack.ppp, unstack.psp, unstack.lpp
    Given a spatial pattern with several columns of marks,
    separate the columns and return a list of spatial patterns, 
    each having only one column of marks.

    o kernel.squint
    Integral of squared kernel, for the kernels used in density estimation.

SIGNIFICANT USER-VISIBLE CHANGES

    o Kcross.inhom, Kdot.inhom, Kmulti.inhom, Ldot.inhom, Lcross.inhom
    These functions now allow intensity values to be given by
    a fitted point process model.
    New arguments 'update', 'leaveoneout', 'lambdaX'.

    o diagnose.ppm
    Infinite values of 'rbord' are now ignored and treated as zero.
    This ensures that diagnose.ppm has a sensible default
    when the fitted model has infinite reach.

    o pcf.ppp
    Now calculates an analytic approximation to the variance of
    the estimate of the pair correlation function (when var.approx=TRUE).
    Now returns the smoothing bandwidth used, as an attribute of the result.
    
    o plot.ppp
    When 'clipwin' is given, any parts of the boundary of the window of x
    that lie inside 'clipwin' will also be plotted.

    o plot.msr
    Now handles multitype measures.
    New argument 'multiplot'.

    o plot.anylist
    If a list entry x[[i]] belongs to class 'anylist', it will be expanded
    so that each entry x[[i]][[j]] will be plotted as a separate panel.

    o influence.ppm, leverage.ppm
    These can now be applied to multitype point process models
    and the results can be plotted.

    o plot.influence.ppm, plot.leverage.ppm
    New argument 'multiplot'.

    o plot.anylist, plot.solist, plot.listof
    New arguments panel.begin.args, panel.end.args

    o influence.ppm, leverage.ppm, dfbetas.ppm
    For Gibbs models, memory usage has been dramatically reduced, 
    so the code can handle larger datasets and finer quadrature schemes.

BUG FIXES

    o Smooth.ppp
    Results were incorrect when at='points' and leaveoneout=FALSE.
    [Bug introduced in spatstat 1.20-5, October 2010.]
    Fixed.

    o funxy
    Did not correctly handle one-line functions:
    the resulting objects evaluated the wrong function in some cases.
    [Spotted by Sebastian Meyer. Bug introduced in spatstat 1.45-0]
    Fixed.

    o mppm
    Did not recognise the variable 'marks' in a formula.
    Fixed.

    o Smooth.ppp, bw.smoothppp
    Crashed if X had two columns of marks and one column was constant.
    [Bug introduced in spatstat 1.38-0, October 2014]
    Fixed.

    o Smooth.ppp
    Results for 'at="points"' were garbled, for some values of 'sigma',
    if X had more than one column of marks.
    [Bug introduced in spatstat 1.38-0, October 2014]
    Fixed.

    o plot.layered
    Crashed if one layer was a point pattern with several columns of marks.
    Fixed. 

    o plot.ppm
    Sometimes gave a spurious warning about a singular matrix.
    Fixed.

    o setminus.owin
    Gave wrong or strange answer if the correct answer was empty.
    Fixed.

    o parameters.dppm
    Crashed, due to a typo.
    Fixed.

    o progressreport
    Crashed if n = 1. 
    Fixed.

        CHANGES IN spatstat VERSION 1.45-2

OVERVIEW

    o We thank Ottmar Cronie, Virginia Morera Pujol,
    Sven Wagner and Marie-Colette van Lieshout for contributions.

    o Recursive-partition point process models.

    o Minkowski sum, morphological dilation and erosion with any shape.

    o Important bug fix in spatial CDF tests.

    o More bug fixes for replicated patterns.

    o Simulate a model fitted to replicated point patterns.

    o Inhomogeneous multitype F and G functions.

    o Summary functions recognise correction="all"

    o Leverage and influence code handles bigger datasets.

    o More support for pixel images.

    o Improved progress reports.

    o New dataset 'redwood3'

    o spatstat now Depends on the package 'rpart'

    o Version nickname: 'Caretaker Mode'

NEW DATASETS

    o redwood3
    A more accurate version of the 'redwood' data.

NEW FUNCTIONS

    o as.im.data.frame
    Build a pixel image from a data frame of coordinates and pixel values.

    o covering
    Cover a window using discs of a given radius.

    o dilationAny, erosionAny, %(-)%
    Morphological dilation and erosion by any shape.

    o FmultiInhom, GmultiInhom
    Inhomogeneous multitype/marked versions of the summary functions Fest, Gest.

    o kernel.moment
    Moment or incomplete moment of smoothing kernel.

    o MinkowskiSum, %(+)%
    Minkowski sum of two windows: A %(+)% B, or MinkowskiSum(A,B)

    o nobjects
    New generic function for counting the number of 'things' in a dataset.
    There are methods for ppp, ppx, psp, tess.

    o parameters.interact, parameters.fii
    Extract parameters from interpoint interactions.
    [These existing functions are now documented.]

    o ppmInfluence
    Calculate leverage.ppm, influence.ppm and dfbetas.ppm efficiently.

    o rppm, plot.rppm, predict.rppm, prune.rppm
    Recursive-partition point process models

    o simulate.mppm
    Simulate a point process model fitted to replicated point patterns.

    o update.interact
    Update the parameters of an interpoint interaction.
    [This existing function is now documented.]

    o where.max, where.min
    Find the spatial location(s) where a pixel image achieves its
    maximum or minimum value.

SIGNIFICANT USER-VISIBLE CHANGES

    o cdf.test.mppm
    Now handles Gibbs models.
    Now recognises covariate="x" or "y".

    o leverage.ppm, influence.ppm, dfbetas.ppm
    For Gibbs models, memory usage has been dramatically reduced, 
    so the code can handle larger datasets and finer quadrature schemes.

    o plot.im
    Now handles complex-valued images.

    o connected.im
    Now handles a logical-valued image properly.

    o qqplot.ppm
    Argument 'expr' can now be a list of point patterns,
    or an envelope object containing a list of point patterns.

    o as.layered
    Default method now handles a (vanilla) list of spatial objects.

    o summary functions
    The argument 'correction="all"' is now recognised: it selects
    all the available options. 
        This applies to Fest, F3est, Gest, Gcross, Gdot, Gmulti, G3est, Gfox,
    	Gcom, Gres, Hest, Jest, Jmulti, Jcross, Jdot, Jfox,
	Kest, Kinhom, Kmulti, Kcross, Kdot, Kcom, Kres, 
	Kmulti.inhom, Kcross.inhom, Kdot.inhom, Kscaled, Ksector, Kmark, 
	K3est, Lscaled, markcorr, markcrosscorr,
	nnorient, pairorient, pcfinhom, pcfcross.inhom, pcfcross, pcf, Tstat.

    o clarkevans
    The argument 'correction="all"' is now recognised: it selects
    all the available options. [This is also the default.]

    o predict.mppm
    The argument 'type="all"' is now recognised: it selects
    all the available options. [This is also the default.]

    o plot.kppm
    The argument 'what="all"' is now recognised: it selects
    all the available options. [This is also the default.]

    o connected.im, connected.owin
    Arguments '...' now determine pixel resolution.

    o anova.mppm
    New argument 'fine'

    o as.owin.data.frame
    New argument 'step'

    o discs
    Now accepts a single numeric value for 'radii'.

    o plot.ppp, plot.profilepl, plot.quadratcount, plot.quadrattest, plot.tess
    Now recognise graphics parameters for text, such as 'family' and 'srt'

    o as.function.tess
    New argument 'values' specifies the function values.

    o cdf.test
    Calculations are more robust against numerical rounding effects.

    o progressreport
    Behaviour improved. New arguments 'tick', 'showtime'.

    o simulate.ppm
    New argument 'verbose'

    o compileK, compilepcf
    These internal functions are now documented.

BUG FIXES

    o cdf.test.ppm
    Calculation of p-values was incorrect for Gibbs models: 
    1-p was computed instead of p.
    [Spotted by Sven Wagner.]
    Fixed.

    o subfits
    The interaction coefficients of the submodels were incorrect
    for Gibbs models with a multitype interaction (MultiStrauss, etc).
    [Spotted by Sven Wagner.]
    Fixed.

    o subfits
    Crashed when a Gibbs model included factor-valued spatial covariates
    and not all levels of the factor were present in each row of the data.
    [Spotted by Sven Wagner.]
    Fixed.

    o subfits
    For Gibbs models with a multitype interaction (MultiStrauss, etc),
    computation of the conditional intensity caused an error.
    [Spotted by Sven Wagner.]
    Fixed.

    o diagnose.ppm
    Crashed if what="smooth", when the original window was a rectangle.
    [Spotted by Virginia Morera Pujol.]
    Fixed.

    o mppm
    The x and y coordinates were not permitted in the 
    random-effects formula 'random'.
    [Spotted by Sven Wagner.]
    Fixed.

    o vcov.ppm
    The result had no 'dimnames', if the model was fitted using method="ho".
    Fixed.

        CHANGES IN spatstat VERSION 1.45-1

OVERVIEW

    o This version was never released.

        CHANGES IN spatstat VERSION 1.45-0

OVERVIEW

    o We thank Monsuru Adepeju, Mario D'Antuono, Markus Herrmann, 
    Paul Hewson, Kassel Hingee, Greg McSwiggan, Suman Rakshit and Sven Wagner 
    for contributions.

    o Important bug fix in leverage/influence diagnostics for Gibbs models.

    o Numerous bug fixes in code for replicated point patterns.

    o Surgery on linear networks.

    o Tessellations on a linear network.

    o Laslett's Transform.

    o Colour maps for point patterns with continuous marks are easier to define.

    o Pair correlation function estimates can be pooled.

    o Stipulate a particular version of a package.

    o Fixed namespace problems arising when spatstat is not loaded.

    o Bug fixes and performance improvements.

    o spatstat now contains 100,000 lines of R code. 

    o Version nickname: 'One Lakh'

NEW FUNCTIONS

    o laslett
    Laslett's Transform.
    [Thanks to Kassel Hingee]

    o lintess
    Tessellation on a linear network.

    o divide.linnet 
    Divide a linear network into pieces demarcated by a point pattern.

    o insertVertices
    Insert new vertices in a linear network.

    o thinNetwork
    Remove vertices and/or segments from a linear network etc

    o connected.linnet
    Find connected components of a linear network.

    o nvertices, nvertices.linnet, nvertices.owin
    Count the number of vertices in a linear network 
    or vertices of the boundary of a window.

    o as.data.frame.linim, as.data.frame.linfun
    Extract a data frame of spatial locations and function values
    from an object of class 'linim' or 'linfun'.

    o as.linfun, as.linfun.linim, as.linfun.lintess
    Convert other kinds of data to a 'linfun' object.

    o requireversion
    Require a particular version of a package
    (for use in stand-alone R scripts).

SIGNIFICANT USER-VISIBLE CHANGES

    o [.linnet, [.lpp
    New argument 'snip' determines what to do with segments of the network
    that cross the boundary of the window. 
    Default behaviour has changed.

    o pcfinhom
    Default behaviour is changed when 'lambda' is a fitted model.
    The default is now to re-fit the model to the data before computing pcf.
    New arguments 'update' and 'leaveoneout' control this.

    o envelope methods
    New argument 'funYargs' contains arguments to the summary function
    when applied to the data pattern only.

    o plot.ppp, plot.lpp
    For a point pattern with continuous marks ('real numbers')
    the colour arguments 'cols', 'fg', 'bg' can now be vectors of 
    colour values, and will be used to determine the default colour map
    for the marks.

    o symbolmap
    Now accepts a vector of colour values for the arguments 'col', 'cols',
    'fg', 'bg' if argument 'range' is given.

    o closepairs.ppp, closepairs.pp3
    New arguments 'distinct' and 'neat' allow more options.

    o closepairs.ppp, closepairs.pp3
    Argument 'ordered' has been replaced by 'twice'
    (but 'ordered' is still accepted, with a warning).

    o closepairs.ppp, closepairs.pp3
    Performance improved (computation time and memory requirements reduced.)
    This should improve the performance of many functions in spatstat.

    o Geyer
    The saturation parameter 'sat' can now be less than 1.

    o lpp, as.lpp
    These functions now handle the case where 'seg' and 'tp' are given
    but 'x' and 'y' are missing.

    o linnet
    If the argument 'edges' is given, then this argument now determines the
    ordering of the sequence of line segments. For example, the i-th row
    of 'edges' specifies the i-th line segment in as.psp(L).

    o funxy, distfun
    The functions created by funxy and distfun have arguments (x,y).
    The user may now give a ppp or lpp object for the argument 'x',
    instead of giving two coordinate vectors 'x' and 'y'.

    o crossing.psp
    New argument 'details' gives more information about the intersections
    between the segments.

    o subset.ppp, subset.lpp, subset.pp3, subset.ppx
    The argument 'subset' can now be any argument acceptable to the "[" method.
    
    o density.lpp
    New argument 'weights'.

    o pcf.ppp
    New argument 'ratio' allows several estimates of pcf to be pooled.

    o summary.ppm
    New argument 'fine' selects the algorithm for variance estimation.

    o texturemap
    Argument 'textures' can be missing or NULL.

    o plot.lpp
    New argument 'show.network'

    o linnet
    New argument 'warn'

    o mppm
    Performs more checks for consistency of the input data.
    
    o mppm
    New arguments 'gcontrol' and 'reltol.pql' control the fitting algorithm.

    o edge.Trans
    New argument 'gW' for efficiency.

    o pool.fv
    The default plot of the pooled function no longer includes 
    the variance curves.

    o clickpoly
    The polygon is now drawn progressively as the user clicks new vertices.
    
    o Kest 
    Accelerated computation (for translation and rigid corrections)
    when window is an irregular shape.

    o vcov.ppm, leverage.ppm, influence.ppm, dfbetas.ppm
    Performance slightly improved, for Gibbs models.

    o Internal code
    Performance slightly improved.

    o Fest, Hest
    Additional checks for errors in input data.

BUGS

   o leverage.ppm, influence.ppm, parres.ppm, addvar.ppm
   Calculations were completely incorrect for Gibbs models, 
   due to a coding error. 
   Fixed.

   o update.kppm
   If the call to 'update' did not include a formula argument
   or a point pattern argument, then all arguments were ignored. 
   Example: update(fit, improve.type="quasi") was identical to 'fit'.
   Fixed.

   o diagnose.ppm
   When applied to a model obtained from subfits(), 
   in the default case (oldstyle=FALSE) 
   the variance calculations were incorrect.
   Consequently the dotted lines representing significance bands were 
   incorrect. An error or warning about negative variances occurred sometimes.
   However, calculations with oldstyle=TRUE were correct.
   The default has now been changed to oldstyle=TRUE for such models.

   o [.lpp
   The local coordinate 'seg' was completely incorrect,
   when 'i' was a window.
   Fixed.

   o leverage.ppm, influence.ppm, parres.ppm, addvar.ppm
   Crashed for Gibbs models in which the coefficient vector had length 1,
   such as the stationary Hardcore model.
   Fixed.

   o subfits
   Crashed if the model included factor-valued spatial covariates.
   [Spotted by Sven Wagner]
   Fixed.

   o subfits
   If the model included factor-valued spatial covariates, and if
   not all levels of the factor were present in each row of the data,
   the resulting objects were malformed and caused errors in other code.
   [Spotted by Sven Wagner]
   Fixed.

   o subfits
   Crashed with some random-effects formulas.
   [Spotted by Sven Wagner]
   Fixed.

   o improve.kppm
   An error message about a missing object 'gminus1' occurred
   when vcov=TRUE, fast.vcov=FALSE and type="clik1" or "wclik1".
   Fixed.

   o plot.profilepl
   Failed with a message about a missing object 'finite'.
   Fixed.

   o selfcut.psp
   Gave an error if marks(A) was a vector rather than a data frame.
   [Spotted by Paul Hewson.]
   Fixed.

   o suffstat
   Gave an error for point process models with Geyer interaction.
   Fixed.

   o nncross.lpp, distfun.lpp
   Crashed with obscure errors if Y consisted of a single point.
   Fixed.

   o scan.test, scanmeasure
   Crashed sometimes with an error message from 'grow.mask'.
   Fixed.

   o dppm
   Crashed sometimes with a message that the point pattern could not be found.
   [Scoping bug.]
   Fixed.

   o mppm, profilepl
   Crashed, with a message about 'SpatstatVersion',
   if the 'spatstat' package was neither loaded nor attached.
   [Spotted by Markus Herrmann.]
   Fixed.

   o qqplot.ppm
   Crashed sometimes when applied to a model obtained from subfits().
   Fixed.

   o anova.mppm
   Crashed sometimes with a message about mismatched coefficients.
   [Spotted by Sven Wagner.]
   Fixed.

   o anova.mppm
   Crashed sometimes with a message about unrecognised option 'type="score"'.
   [Spotted by Sven Wagner.]
   Fixed.

   o split.ppx
   Crashed if 'f' was not a factor.
   Fixed.

   o idw
   The result was a pixel image defined in the rectangle Frame(X)
   instead of Window(X). 
   Fixed.

   o ppm
   Parameter estimates were slightly inaccurate 
   when the model included the Geyer() interaction 
   and the "isotropic" edge correction was used.
   Fixed. 

   o [.ppx
   Crashed if the number of points selected was less than 2.
   Fixed.

   o linnet
   Crashed if there were no line segments at all.
   Fixed.

   o kppm, improve.kppm
   Crashed if the model was stationary and improve.type != "none".
   Fixed.

   o as.linim.default
   Did not correctly handle factor-valued data.
   Fixed.

   o texturemap
   Crashed if no graphical arguments were specified.
   Fixed.

   o vcov.mppm
   Ignored "..." arguments.
   Fixed.

   o Kest
   If ratio=TRUE and correction=c('border', 'none') 
   the result did not contain ratio information.
   Fixed.
   
   o plot.ppp, plot.lpp
   Arguments 'chars' and 'cols' were ignored in some cases.
   Fixed.

   o ppm
   Ignored argument 'emend'.
   Fixed.

   o plot.dppm
   Gave warnings about unrecognised argument 'objectname'.
   Fixed.

   o overlap.owin
   Sometimes returned a very small negative value, 
   when the correct answer was 0.
   Fixed.

        CHANGES IN spatstat VERSION 1.44-1

OVERVIEW

    o We thank Brian Ripley for contributions.

    o Urgent bug fix.

    o More support for replicated point patterns.

    o More support for tessellations.

    o Version nickname: 'Gift Horse'

NEW FUNCTIONS

   o as.function.tess
   Convert a tessellation to a function(x,y). The function value
   indicates which tile of the tessellation contains the point (x,y).

   o tileindex
   Determine which tile of a tessellation contains a given point (x,y).

   o persp.leverage.ppm
   Method for persp plots for objects of class leverage.ppm

   o AIC.mppm, extractAIC.mppm
   AIC for point process models fitted to replicated point patterns.

   o nobs.mppm, terms.mppm, getCall.mppm
   Methods for point process models fitted to replicated point patterns.

SIGNIFICANT USER-VISIBLE CHANGES

   o anova.mppm
   Now handles Gibbs models, and performs the
   adjusted composite likelihood ratio test.

   o update, step
   These functions now work for models of class 'mppm'.

   o textureplot
   Argument x can now be something acceptable to as.im

   o logLik.mppm
   New argument 'warn'.

BUGS

  o nncross.lpp, nnwhich.lpp, distfun.lpp
  Caused a segmentation fault.
  [Spotted by Brian Ripley.]
  Fixed.

  o anova.ppm
  If a single 'object' was given, and the object was a Gibbs model,
  then 'adjust' was effectively set to FALSE.
  Fixed.

        CHANGES IN spatstat VERSION 1.44-0

OVERVIEW

   o We thank Jonas Geldmann, Andrew Hardegen, Kassel Hingee,
     Tom Lawrence, Robin Milne, Gopalan Nair, Suman Rakshit, Peijian Shi
     and Rasmus Waagepetersen for contributions.
  
   o More support for multidimensional point patterns and point processes.

   o More options for envelopes and related Monte Carlo tests.

   o More support for model comparison.

   o k-th nearest neighbours on a linear network.

   o Penttinen process can be simulated (by Metropolis-Hastings or CFTP).

   o Calculate the predicted variance of number of points.

   o Convexifying operation for sets.

   o Subdivide a linear network.

   o Accelerated algorithms for linear networks.

   o Quadrat counting accelerated, in some cases.

   o Version nickname: 'The Sound of One Hand Typing'

NEW FUNCTIONS

   o rPenttinen
     Simulate the Penttinen process using perfect simulation.

   o varcount
     Given a point process model, compute the predicted variance
     of the number of points falling in a window.

   o inside.boxx
     Test whether multidimensional points lie inside a specified 
     multidimensional box.

   o lixellate
     Divide each segment of a linear network into smaller segments.

   o nsegments.linnet, nsegments.lpp
     Count the number of line segments in a linear network.

   o grow.boxx
     Expand a multidimensional box.

   o deviance.ppm, deviance.lppm
     Deviance for a fitted point process model.

   o pseudoR2
     Pseudo-R-squared for a fitted point process model.

   o tiles.empty
     Checks whether each tile of a tessellation is empty or nonempty.

   o summary.linim
     Summary for a pixel image on a linear network.

SIGNIFICANT USER-VISIBLE CHANGES

   o rMaternI, rMaternII
     These functions can now generate random patterns in 
     three dimensions and higher dimensions, when the argument
     'win' is of class 'box3' or 'boxx'.

   o "[.ppx"
     The subset index 'i' may now be a spatial domain
     of class 'boxx' or 'box3'.

   o rmh.ppm, rmhmodel.ppm, simulate.ppm
   A model fitted using the 'Penttinen' interaction can now be simulated.

   o rmh.default, rmhmodel.default
   These functions now recognise cif='penttinen' for the Penttinen interaction.

   o envelope
   New argument 'clamp' gives greater control over one-sided envelopes.

   o dclf.test, mad.test, dclf.progress, mad.progress, 
     dclf.sigtrace, mad.sigtrace
   New argument 'clamp' determines the test statistic for one-sided tests.

   o dclf.progress, mad.progress, dclf.sigtrace, mad.sigtrace,
    mctest.progress, mctest.sigtrace, dg.progress, dg.sigtrace
   New argument 'rmin' determines the left endpoint of the test interval.

   o dclf.test, mad.test, dg.test, dg.progress, dg.sigtrace, dg.envelope
    (also accepted by dclf.progress, mad.progress, dclf.sigtrace, mad.sigtrace)
   New argument 'leaveout' specifies how to calculate the deviation
   between the observed summary function and nominal reference value.

   o envelope
   New argument 'funargs'

   o Hest
   Argument X can now be a pixel image with logical values.
   New argument 'W'. [Based on code by Kassel Hingee.]

   o nncross.lpp, distfun.lpp
   New argument 'k' allows calculation of k-th nearest neighbour.
   Computation accelerated.

   o logLik.ppm
   New argument 'absolute'.

   o plot.kppm
   New arguments 'pause' and 'xname'.

   o tess
   Argument 'window' is ignored when xgrid, ygrid are given.

   o as.polygonal
   Can now repair errors in polygon data, if repair=TRUE.

   o rStrauss, rHardcore, rStraussHard, rDiggleGratton, rDGS, rPenttinen
   New argument 'drop'.

   o Kest.fft
   Now has '...' arguments allowing control of spatial resolution.

   o lppm
   Computation accelerated.

   o quadratcount.ppp
   Computation accelerated in some cases.

   o dg.test
   Computation accelerated.

BUGS

   o runifpointx, rpoisppx
   Crashed if nsim > 1.
   Fixed.

   o triangulate.owin
   Results were incorrect in some special cases.
   Fixed.

   o quadrat.test, clarkevans.test
   In rare cases, the computed Monte Carlo p-value could have been
   greater than 1. This could have occurred only when nsim was an even number
   and when the correct p-value was equal to 1.
   Fixed.

   o linearmarkequal
   Result was a data frame instead of an 'fv' object.
   Fixed.

   o point-in-polygon test
   The function inside.owin could take a very long time to check
   whether points are inside a polygonal window, if the coordinates
   were very large numbers. This was due to numerical overflow.
   (Fixed??)

   o as.fv.kppm	
   Crashed if the model was not fitted by minimum contrast.
   Fixed.

   o plot.fv
   Crashed in some obscure cases.
   Fixed.

   o collapse.fv
   Did not allow 'same=NULL'.
   Fixed.

   o dclf.progress, mad.progress, dg.progress, 
     dclf.sigtrace, mad.sigtrace, dg.sigtrace
   The results could not be re-plotted using a plot formula,
   because the internal data were slightly corrupted.
   Fixed.

   o Kest.fft
   Result was incorrectly normalised.
   Fixed.

   o crosspairs
   If X and Y were identical point patterns,
   the result was not necessarily symmetric
   (on some machines) due to numerical artifacts.
   Fixed.

   o plot.fv
   Lines were not correctly clipped to the plot region when 'ylim' was given.
   Fixed.

   o pool.envelope
   The 'scale' argument was not handled correctly.
   Fixed.

        CHANGES IN spatstat VERSION 1.43-0

OVERVIEW

   o We thank Leanne Bischof, Christophe Biscio, Belarmain Fandohan,
   Andrew Hardegen, Frederic Lavancier, Tom Lawrence, Martin Maechler, 
   Greg McSwiggan, Robin Milne, Gopalan Nair, Tuomas Rajala, 
   Suman Rakshit, Ben Ramage, Francois Semecurbe and Ida-Maria Sintorn 
   for contributions.

   o spatstat now depends on the package 'nlme'.

   o spatstat now depends on R 3.2.2 or later.

   o Simulation algorithms have been accelerated; simulation outcomes 
   are *not* identical to those obtained from previous versions of spatstat. 

   o Determinantal point process models.

   o Random-effects and mixed-effects models for replicated patterns.

   o Dao-Genton test, and corresponding simulation envelopes.

   o Simulated annealing and simulated tempering.

   o spatstat colour tools now handle transparent colours.

   o Improvements to "[" and subset() methods

   o Extensions to kernel smoothing on a linear network.

   o Support for one-dimensional smoothing kernels.

   o Bug fix in Metropolis-Hastings simulation.

   o Mark correlation function may include weights.

   o Cross-correlation version of the mark correlation function.

   o Variance calculations for replicated patterns.

   o Penttinen pairwise interaction model.

   o Contour plots with colours determined by a colour map.

   o New dataset: Australian states and territories.

   o More support for multi-dimensional point patterns.

   o Minor improvements and bug fixes.

   o Version nickname: "Mixed Effects"

NEW DATASET

   o austates
   The states and large mainland territories of Australia
   represented as polygonal regions forming a tessellation.

NEW FUNCTIONS

   o dppm
   Fit a determinantal point process model to point pattern data.

   o fitted.dppm, predict.dppm, intensity.dppm
   Predict a fitted dppm object.

   o logLik.dppm, AIC.dppm, extractAIC.dppm, nobs.dppm
   Likelihood and AIC for determinantal point process models
   (enabling the use of 'step')

   o coef.dppm, formula.dppm, print.dppm, terms.dppm, labels.dppm,
   model.frame.dppm, model.matrix.dppm, model.images.dppm,
   is.stationary.dppm, reach.dppm, unitname.dppm, unitname<-.dppm, Window.dppm
    Various methods for dppm objects.

   o parameters.dppm
   Extract meaningful list of model parameters

   o objsurf.dppm
   Objective function surface of a dppm object

   o residuals.dppm
   Residual measure for a dppm object.

   o dppBessel, dppCauchy, dppGauss, dppMatern,	dppPowerExp
   Determinantal Point Process models.

   o update.dppmodel            
   Set parameter values in a dpp model.

   o is.stationary.dppmodel, print.dppmodel, reach.dppmodel, valid.dppmodel    
   Basic information about a dpp model

   o rdpp, simulate.dppmodel		 
   Simulation of a dpp model.

   o intensity.dppmodel, Kmodel.dppmodel, pcfmodel.dppmodel
   Moments of a dpp model

   o dim.dppmodel, dppapproxkernel, dppapproxpcf, dppeigen, dppfamily,
   dppkernel, dppparbounds, dppspecdenrange, dppspecden
   Helper functions for dpp models.

   o dclf.sigtrace, mad.sigtrace, mctest.sigtrace
   Significance trace of Monte Carlo test

   o dg.test
   Dao-Genton adjusted Monte Carlo goodness-of-fit test.

   o dg.envelope
   Simulation envelopes corresponding to Dao-Genton test.

   o dg.sigtrace
   Significance trace for Dao-Genton test

   o dg.progress
   Progress plot for Dao-Genton test

   o markcrosscorr
   Mark cross-correlation function for point patterns with
   several columns of marks

   o fixef.mppm, ranef.mppm
   Extract fixed effects and random effects from a point process model
   fitted to replicated point patterns.

   o rtemper
   Simulated annealing or simulated tempering.

   o to.opaque, to.transparent
   Change transparency value in colours

   o rgb2hsva
   Convert RGB to HSV data, like rgb2hsv, but preserving transparency.

   o superimpose.ppplist, superimpose.splitppp
   New methods for 'superimpose' for lists of point patterns.

   o dkernel, pkernel, qkernel, rkernel
   Probability density, cumulative probability, quantiles
   and random generation from distributions used in basic one-dimensional
   kernel smoothing.

   o kernel.factor
   Auxiliary calculations for one-dimensional kernel smoothing.

   o PPversion, QQversion
   Transformation of a summary function to its P-P or Q-Q counterpart.

   o spatdim
   Spatial dimension of any object in the spatstat package.

   o as.boxx
   Convert data to a multi-dimensional box.

   o intensity.ppx
   Method for 'intensity' for multi-dimensional space-time point patterns.

   o fourierbasis
   Evaluate Fourier basis functions in any number of dimensions.

   o valid
   New generic function, with methods valid.ppm, valid.lppm, valid.dppmodel
   
   o emend, emend.ppm, emend.lppm
   New generic function with methods for ppm and lppm.
   emend.ppm is equivalent to project.ppm

   o Penttinen
   New pairwise interaction model.

   o quantile.density
   Calculates quantiles from kernel density estimates.

   o CDF.density
   Calculates cumulative distribution function from kernel density estimates.

SIGNIFICANT USER-VISIBLE CHANGES

   o simulation
   Several basic simulation algorithms have been accelerated.
   Consequently, simulation outcomes are not identical to 
   those obtained with previous versions of spatstat, even when the
   same random seed is used. To ensure compatibility with previous
   versions of spatstat, revert to the slower code by setting
   spatstat.options(fastthin=FALSE, fastpois=FALSE).

   o mppm
   Now handles models with a random effect component.
   New argument 'random' is a formula specifying the random effect.

   o vcov.mppm
   Now handles models with Gibbs interactions.

   o [.ppp
   New argument 'clip' determines whether the window is clipped.

   o [.ppp
   The previously-unused argument 'drop' now determines whether 
   to remove unused levels of a factor.

   o [.pp3, [.lpp, [.ppx, subset.ppp, subset.pp3, subset.lpp, subset.ppx
   These methods now have an argument 'drop' which determines
   whether to remove unused levels of a factor.

   o density.lpp
   Now supports both the 'equal-split continuous' and 
   'equal-split discontinuous' smoothers. New argument 'continuous' 
   determines the choice of smoother.

   o envelope
   New argument 'scale' allows global envelopes to have 
   width proportional to a specified function of r,
   rather than constant width.

   o dclf.test, mad.test, dclf.progress, mad.progress, mctest.progress
   New argument 'scale' allows summary function values to be rescaled
   before the comparison is performed.

   o dclf.test, mad.test
   New argument 'interpolate' supports interpolation of p-value.

   o dclf.progress, mad.progress, mctest.progress
   New argument 'interpolate' supports interpolation of critical value of test.

   o simulate.ppm
   New argument 'w' controls the window of the simulated patterns.

   o default.rmhcontrol, default.rmhexpand
   New argument 'w'.

   o markcorr
   New argument 'weights' allows computation of the weighted version
   of the mark correlation function.

   o density.lpp
   New argument 'kernel' specifies the smoothing kernel.
   Any of the standard one-dimensional smoothing kernels can be used.

   o contour.im
   New argument 'col' specifies the colour of the contour lines.
   If 'col' is a colour map, then the contours are drawn in different colours.

   o plot.ppp
   The default colour for the points is now a transparent grey,
   if this is supported by the plot device.

   o rgbim, hsvim
   New argument 'A' controls the alpha (transparency) channel.

   o rgb2hex, col2hex, paletteindex, is.colour, samecolour,
   complementarycolour, is.grey, to.grey
   These colour tools now handle transparent colours.

   o rgb2hex
   New argument 'maxColorValue'

   o to.grey
   New argument 'transparent'.

   o progressreport
   New argument 'state'
   New option: style="tk"

   o rLGCP
   This function no longer requires the package 'RandomFields'
   to be loaded explicitly. 

   o kppm
   Fitting a model with clusters="LGCP" no longer requires the
   package 'RandomFields' to be loaded explicitly.

   o rpoispp
   Accelerated, when 'lambda' is a pixel image.

   o rthin
   Accelerated, when 'P' is a single number.

   o spatstat.options
   New options 'fastthin' and 'fastpois' enable fast simulation algorithms.
   Set these options to FALSE to reproduce results obtained with
   previous versions of spatstat.

   o split.ppp
   The splitting variable 'f' can now be a logical vector.

   o collapse.fv
   This is now treated as a method for the 'nlme' generic 'collapse'.
   Its syntax has been adjusted slightly.

   o diagnose.ppm, plot.diagppm
   New arguments col.neg, col.smooth control the colour maps.

   o valid.ppm
   This is now a method for the generic function 'valid'.

   o ppm.ppp, ppm.quad
   New argument 'emend', equivalent to 'project'.

   o "[<-.im"
   Accepts an array for 'value'.

   o as.im.function
   New argument 'strict'.

   o bw.ppl
   New argument 'weights'.

   o plot.mppm
   New argument 'se'.
   
   o dclf.test, mad.test
   Formal arguments 'use.theo' and 'internal' have been removed.

   o predict.kppm, residuals.kppm
   Now issues a warning when the calculation ignores the 
   cluster/Cox component and treats the model as if it were Poisson.
   (This currently happens in predict.kppm when se=TRUE or interval != "none",
   and in residuals.kppm when type != "raw").

BUG FIXES

   o lpp
   Crashed if X was a 4-column matrix.
   Fixed.

   o plot.fv
   Crashed with some graphics devices, if legend=TRUE.
   Fixed.

   o effectfun
   Crashed if 'covname' was missing.
   Fixed.

   o rVarGamma, rMatClust, rThomas, rCauchy, rNeymanScott
   Crashed if 'kappa' was a function or image instead of a single number.
   [Spotted by Ben Ramage.]
   Fixed.

   o plot.mppm
   Crashed with a message about "figure margins too large"
   unless the argument se=FALSE was given explicitly.
   Fixed.

   o opening.owin, closing.owin
   Crashed sometimes, with a message about a rectangle not containing a window.
   Fixed.

   o persp.im
   Crashed if all pixel values were equal to zero (unless zlim was given).
   Fixed.

   o predict.ppm
   Crashed sometimes if the model was fitted with use.gam=TRUE.

   o as.linim.linfun
   Generated an error ('L must be a linear network')
   if extra arguments were given.

   o as.function.fv
   Generated an error when executed in the 'covr' package.
   Fixed.

   o rmh, simulate.ppm
   Results were incorrect for inhomogeneous multitype models
   simulated with fixall=TRUE (i.e. prescribing a fixed number of
   points of each type) if the model was segregated 
   (i.e. if different types of points had different first order trend).
   Fixed.

   o dclf.progress, mad.progress
   Ignored the argument 'alternative'. 
   Fixed.
   
   o $<-.hyperframe, [<-.hyperframe
   Result was garbled if 'value' was a hyperframe with one column.

   o rmh.ppm
   Argument 'w' was ignored in some cases.
   Fixed.

   o Hest
   There was an artefact at r=0 when conditional=TRUE.
   Fixed.

   o [.msr
   The result of M[W] where W is a window
   was a measure with window W, instead of intersect.owin(W, Window(M)).
   Fixed.

   o pool.envelope
   Did not always respect the value of 'use.theory'.
   Fixed.

   o envelope, pool.envelope
   If 'ginterval' was given, the results were in a slightly incorrect format.
   Fixed.

   o pool.envelope
   Did not check for compatible values of 'ginterval'.
   Fixed.

        CHANGES IN spatstat VERSION 1.42-2

OVERVIEW

   o We thank Bob Klaver and Harold-Jeffrey Ship for contributions.

   o Improvements to simulation of Neyman-Scott processes.

   o Improvements to fitting of Neyman-Scott models.

   o Extended functionality for pixel images.

   o Fitted intensity on linear network

   o Triangulation of windows.

   o Corrected an edge correction.

   o Bug fixes and performance improvements.

   o Nickname: 'Barking at Balloons'

NEW FUNCTIONS

   o triangulate.owin
   Decompose a spatial window into triangles.

   o fitted.lppm
   Fitted intensity values for a point process on a linear network.

SIGNIFICANT USER-VISIBLE CHANGES

   o rThomas, rMatClust, rCauchy, rVarGamma
   When the model is approximately Poisson, it is simulated using rpoispp. 
   This avoids computations which would require huge amounts of memory. 
   New argument 'poisthresh' controls this behaviour.

   o update.kppm
   Now handles additional arguments in any order, with or without names.
   Changed arguments. Improved behaviour.

   o kppm, clusterfit
   New argument 'algorithm' specifies the choice of optimisation algorithm.

   o kppm
   Left hand side of formula can now involve entries in the list 'data'.

   o rotmean
   New argument 'padzero'. 
   Default behaviour has changed.

   o rose.default
   New argument 'weights'.

   o rose
   New arguments 'start' and 'clockwise' specify the convention
   for measuring and plotting angles.

   o padimage 
   New argument 'W' allows an image to be padded out to fill any window.

   o union.owin
   Improved behaviour when there are more than 2 windows.

   o clusterset
   Improved behaviour.

   o affine.owin
   Allows transformation matrix to be singular, if the window is polygonal.

BUG FIXES

   o spatstat
   spatstat could not be installed on some 64-bit VM systems
   because of an apparent bug in R.
   Fixed.

   o rThomas, rMatClust, rCauchy, rVarGamma
   Large values of the scale parameter could cause the algorithm to freeze
   or require huge amounts of memory.
   Fixed.

   o pcf, pcfinhom
   Crashed if the point pattern was empty.
   Fixed.

   o plot.fv
   Gave an error message if all 'y' values were equal, when legend=TRUE.
   Fixed.

   o rose.default
   Display was incorrect when unit="radian".
   Fixed.

   o Kest
   Ohser-Stoyan rigid motion correction (correction='rigid')
   was calculated incorrectly at large distances.
   Fixed.

   o summary.im
   Issued a warning about numerical overflow in some cases.
   [Spotted by Bob Klaver.]
   Fixed.

   o plot.im
   Sometimes warned that 'box' is not a graphical parameter.
   Fixed.

        CHANGES IN spatstat VERSION 1.42-1

OVERVIEW

   o We thank Andrew Hardegen, Tom Lawrence, Robin Milne, Suman Rakshit,
   and Brian Ripley for contributions.

   o Urgent bug fix.

   o More robust simulation of cluster processes.

   o Slightly accelerated.

   o Version nickname: 'Vogon Poetry'

NEW FUNCTIONS

   o boundingbox.solist
   Method for boundingbox for lists of spatial objects.

SIGNIFICANT USER-VISIBLE CHANGES

   o rThomas, rMatClust, rCauchy, rVarGamma, rNeymanScott
   New faster algorithm which is more robust against extreme values of
   the parameters.

   o rNeymanScott
   New argument 'nonempty' controls choice of algorithm.

   o solist, as.solist
   Accelerated. 

   o as.list.hyperframe
   Accelerated. 

BUG FIXES

   o residuals.mppm
   Brought some computers to a grinding halt, due to the bug in solist().
   Fixed.

   o solist, as.solist
   In rare cases, the format was corrupted, or the algorithm never terminated.
   Fixed.

        CHANGES IN spatstat VERSION 1.42-0

OVERVIEW

   o We thank Anders Bilgrau, Ute Hahn, Jack Hywood, Tuomas Rajala,
   Cody Schank, Olivia Semboli and Ben Taylor for contributions.

   o Version nickname: 'Life, The Universe and Everything'

   o Permutation test for difference between groups of point patterns.

   o Variational Bayes estimation for point process models.

   o Score test in anova.ppm

   o ROC curve, and discrimination index AUC, for fitted models.
   
   o Interactive text editor for spatial datasets.

   o Tools for analysing data on a tree. 

   o Kernel density/intensity estimation on a linear network.

   o Random pixel noise.

   o Improved behaviour of polygon geometry operations.

   o Improved support for cluster and Cox models.

   o Improved basic support for owin objects.

   o Improved support for tessellations.

   o More hierarchical Gibbs interactions.

   o Modifications to Kest.

   o summary method for Cox and cluster models.

   o class 'listof' is almost completely replaced by 'anylist' and 'solist'.

   o Improvements and bug fixes.

   o spatstat now depends on R version 3.2.0 or later.

NEW FUNCTIONS

   o studpermu.test
   Studentised permutation test for difference between groups of point patterns.
   Generously contributed by Ute Hahn.

   o AIC.kppm, extractAIC.kppm, logLik.kppm, nobs.kppm
   Methods for computing AIC for fitted Cox and cluster models.

   o transmat
   Convert pixel arrays between different display conventions.

   o roc
   Receiver Operating Characteristic curve.

   o auc
   Discrimination index AUC (area under the ROC curve) 

   o edit.ppp, edit.psp, edit.im
   Interactive text editor works for spatial datasets.

   o edit.hyperframe
   Interactive text editor works for hyperframes.

   o parameters
   Extract all parameters from a fitted model.

   o density.lpp
   Kernel estimation of point process intensity on a linear network.

   o extractbranch, deletebranch, treeprune, treebranchlabels, begins
   Tools for analysing data on a tree.

   o rnoise
   Random pixel noise.

   o as.data.frame.owin
   Convert a window to a data frame.

   o harmonise.owin
   Convert several binary mask windows to a common pixel grid.

   o copyExampleFiles
   Copy the raw data files from an installed dataset
   to a chosen folder, for use in a practice exercise.

   o density.ppplist
   Method for 'density' for lists of point patterns.

   o inradius
   Radius of largest circle inside a window.

   o mergeLevels
   Merge different levels of a factor.
   
   o relevel.im, relevel.ppp, relevel.ppx
   Change the reference level of a factor.

   o simulate.profilepl
   simulation method for models fitted by profile maximum pseudolikelihood.

   o predict.rho2hat
   Prediction method for class rho2hat

   o with.msr
   Evaluate (an expression involving) components of a measure. 

   o summary.kppm, print.summary.kppm, coef.summary.kppm
   Methods for 'summary' and 'coef(summary(..))' for Cox and cluster models.

   o as.im.funxy
   Method for as.im for class funxy.

   o shift.linim, scalardilate.linim, affine.linim
   Geometrical transformations for 'linim' objects.

   o Smooth.solist
   Smooth method for a list of spatial objects.

   o unitname.tess, unitname<-.tess
   Tessellations now keep track of the name of the unit of length.

   o dirichletAreas
   Faster algorithm for tile.areas(dirichlet(X)).

   o identify.lpp
   Method for 'identify' for point patterns on a linear network.

   o HierStraussHard, HierHard
   Hierarchical interactions for Gibbs models.

   o delaunayDistance, delaunayNetwork, dirichletEdges, 
   dirichletNetwork, dirichletVertices, dirichletWeights
      These functions will replace delaunay.distance, delaunay.network, 
   dirichlet.edges, dirichlet.network, dirichlet.vertices and
   dirichlet.weights respectively.
   The latter are now 'deprecated'.

SIGNIFICANT USER-VISIBLE CHANGES

   o ppm
   Now supports Variational Bayes fitting method.

   o kppm
   'AIC' and 'step' now work for kppm objects
   fitted using maximum Palm likelihood.

   o kppm
   The default for the weight function 'weightfun' has been changed, 
   for better performance.

   o envelope
   envelope methods now have argument 'use.theory' specifying whether
   to use the 'theoretical' value of the summary function when constructing
   simultaneous envelopes.

   o anova.ppm
   Now performs the Score Test, for Poisson models only,
   if argument test="Rao" or test="score".

   o Kest
   New argument 'rmax' controls maximum value of argument 'r'

   o diagnose.ppm
   Now computes and prints the null standard deviation of the
   smoothed Pearson residual field, when appropriate.

   o nncorr, nnmean, nnvario
   New argument 'k' specifies k-th nearest neighbour.

   o quadrat.test.ppp, quadrat.test.quadratcount
   New argument 'lambda' supports a test of the Poisson process 
   with given intensity 'lambda'.

   o clickpoly, clickbox
   These functions now handle graphical arguments to polygon()
   when drawing the resulting polygon or rectangle.

   o owin, as.owin, as.mask
   owin(mask=D) or as.owin(D) or as.mask(D) will produce a binary mask window
   if D is a data frame with two columns of (x,y) coordinates
   or a data frame with three columns containing (x,y,logical).

   o as.owin.data.frame
   W can now be a data frame with only two columns,
   giving the spatial coordinates of the pixels that are inside the window.

   o rose
   Tick marks now have labels showing the angle (in degrees or radians).

   o distcdf
   New argument 'regularise' determines whether values at short distances
   will be smoothed to avoid discretisation artefacts.

   o rpoislinetess
   Return value now has an attribute 'lines' giving the 
   realisation of the Poisson line process.

   o intersect.owin, union.owin, setminus.owin
   New argument 'p' controls resolution of polygon clipping algorithm.

   o intersect.owin, union.owin
   Arguments may be lists of windows, of class 'solist'.
   Formal arguments A and B have been removed.

   o superimpose
   Now handles lists of point patterns 
   (objects of class 'ppplist' or 'splitppp')

   o density.ppp
   New argument 'positive' allows the user to stipulate that
   density values must be positive (avoiding numerical errors
   which occasionally produce small negative values).

   o adaptive.density
   Now accepts f = 0 (uniform intensity estimate) and
   f = 1 (Voronoi intensity estimate) as well as 0 < f < 1.
   Algorithm accelerated.

   o rSSI
   Can now generate inhomogeneous patterns.

   o effectfun
   Now works for 'kppm' and 'lppm' objects as well.

   o integral.im, integral.msr
   Argument 'domain' can now be a tessellation;
   the integral over each tile of the tessellation is returned.

   o allstats, compareFit, markcorr, split.ppx, by.ppp
   Result is now of class 'anylist'.

   o by.im, density.splitppp, idw, model.images, nnmark, pixellate.ppp,
   predict.lppm, predict.ppm, quadratcount.splitppp, quadratresample, relrisk, 
   Smooth.msr, split.im, tiles
   Result is now of class 'solist'.

   o split.ppp
   New argument 'reduce'.
   Result now inherits class 'ppplist' and 'solist', as well as 'splitppp'

   o rLGCP
   New argument 'nsim' allows multiple patterns to be generated.

   o alltypes
   New argument 'reuse' determines whether all simulation envelopes
   are based on the same set of simulated patterns, or on independent sets.

   o rpoispp, runifpoint
   New argument 'ex' makes it possible to generate a random pattern
   similar to an example point pattern.

   o effectfun
   Argument 'covname' is not needed if the model has only one covariate.

   o quadratcount
   Argument 'tess' can now be anything acceptable to as.tess.

   o tess
   New argument 'unitname' specifies the name of the unit of length.
   If it is missing, unitname information will be extracted from the
   other data.

   o intersect.tess, chop.tess, quadrats
   Results of these functions now have the same 'unitname' as their input.

   o persp.im, nnclean, plot.qqppm, plot.bw.optim
   These plotting functions now obey spatstat.options('monochrome')

   o lurking
   Now returns an object of class 'lurk' which has a plot method.
   Two-standard-deviation limits are now plotted using grey shading.

   o marktable
   New argument 'N' for studying the N nearest neighbours.   
   New argument 'collapse' for manipulating the contingency table.

   o harmonise.fv
   Now discards columns with names which do not match.

   o eval.fv
   New argument 'equiv' can be used to declare that two columns
   with different names in different objects are equivalent.

   o quantile.ewcdf
   New argument 'type' controls the type of quantile.
   
   o plot.imlist
   New argument 'plotcommand' specifies how to plot each image.

   o persp.im
   The lower extent of the apron can now be controlled by 'zlim'.

   o quadscheme
   Argument 'method' is partially matched.

   o Kdot, Ldot
   New argument 'from' is an alternative to 'i'.

   o Kcross, Lcross
   New arguments 'from' and 'to' are alternatives to 'i' and 'j' respectively.

   o varblock
   Changed the ordering (and therefore default colours/styles) 
   of curves in the plot, to match other functions like lohboot.

   o bw.diggle
   New argument 'nr' controls accuracy.

   o textureplot
   Now accepts a pixel image, a tessellation, or anything acceptable to as.tess.

   o textureplot
   Line spacing in legend now matches line spacing in main display.
   
   o [.tess
   Subset index can now be a window.

   o plot.tess
   Can now plot a text label in each tile.

   o plot.tess
   New argument 'do.plot'.

   o MultiHard, MultiStrauss, MultiStraussHard, HierStrauss
   Printed output of fitted model now respects spatstat.options('terse').

   o print.ppm
   Reduced redundancy in output in some cases.

   o print.msr
   Responds better to spatstat.options('terse').

   o print.ppm, print.fii, print.interact
   Irregular parameters are now printed to the number of significant figures
   specified by options("digits").

   o square
   New argument 'unitname'.

   o plot.fv
   Return value is now invisible.

   o delaunay.distance, delaunay.network, dirichlet.edges, 
   dirichlet.network, dirichlet.vertices
      These functions are now 'deprecated', and will be replaced by
      delaunayDistance, delaunayNetwork, dirichletEdges, 
      dirichletNetwork and dirichletVertices respectively.

   o data(residualspaper)
   In the real datasets (Fig1 and Fig11), the name of the unit of length
   has now been recorded.

   o rLGCP
   This function now requires the package 'RandomFields'
   to be loaded explicitly by library(RandomFields) or require(RandomFields), 
   unless model="exp".

   o iplot, istat
   These functions now require the package 'rpanel' 
   to be loaded explicitly by library(rpanel) or require(rpanel).

   o ppm, quadscheme
   Improved calculation of Dirichlet weights.

   o countends
   New argument 'toler' controls numerical errors

   o diagnose.ppm
   Improved handling of additional graphics arguments.

   o pcf3est
   Mathematical labels changed.

   o plot.hyperframe
   Default margin spacing has been increased.

BUG FIXES

   o Kinhom, Linhom
   The value of 'theo' was erroneously rescaled 
   by a small amount, when renormalise=TRUE (the default).
   Fixed.

   o Kmark
   Values were erroneously rescaled.
   Fixed.

   o union.owin
   Strange results were sometimes obtained when taking the union 
   of more than two windows.
   Fixed.

   o rpoispp3 
   Implementation was incorrect for nsim > 1.
   (Results may have been incorrect.)
   Spotted by Jack Hywood.
   Fixed.
   
   o as.owin.data.frame
   Crashed if the window was not connected.
   Fixed.

   o Frame<-
   Crashed when applied to a binary mask.
   Fixed.

   o rho2hat
   Crashed if cov1="x" and cov2="y".
   Fixed.

   o as.mask
   Crashed sometimes when only the argument 'xy' was given.
   Fixed.

   o ppm
   Crashed (rarely) when method='ho' if the simulated pattern was empty.
   Fixed.

   o istat, iplot
   Crashed in recent versions of rpanel.
   Fixed.

   o convexhull
   Crashed if applied to a 'psp' object.
   Fixed.

   o plot.ppm
   Crashed with message about 'variable lengths differ'.
   Fixed.

   o plot.solist
   Crashed when applied to a list of point patterns
   if some patterns had more than one column of marks.
   Fixed.

   o Smooth.ppp
   Crashed if applied to a point pattern with several columns of marks
   if some of the columns were factors.
   Fixed.

   o runifpoint3, rpoispp3
   Crashed if nsim > 1.
   Spotted by Jack Hywood.
   Fixed.

   o hist.im
   Crashed if argument 'freq' was given.
   Fixed.

   o MultiStraussHard
   Generated misleading error messages (e.g. 'model is invalid') 
   when arguments 'iradii' and 'hradii' did not have the same pattern of NA's.
   Fixed.

   o plot.solist
   Figures were sometimes aligned incorrectly 
   when the argument 'panel.args' was given.
   Fixed.

   o scaletointerval
   Results sometimes fell slightly outside the desired interval
   due to numerical error.
   Fixed.

   o plot.solist
   Behaved incorrectly when plotcommand='persp'.
   Fixed.

   o "[.hyperframe"
   Sometimes returned an 'anylist' when it should have returned a 'solist'.
   Fixed.

   o plot.im
   Did not plot surrounding frame box when ribbon=FALSE.
   Fixed.

   o envelope
   The functions stored when savefuns=TRUE did not inherit 
   the correct name for the unit of length.
   Fixed.

   o print.ppm, print.fii, print.interact
   Layout was misaligned.
   Fixed.

   o plot.plotppm
   Paused for input when it was not appropriate.
   Fixed.

   o plot.fv
   On png devices, the legend box was drawn with a white background,
   obscuring the main plot. 
   Fixed.

   o plot.owin, plot.ppp, plot.im
   There was unnecessary extra space above the main title.
   Fixed.

   o plot.rho2hat
   Colour map ribbon was drawn but not annotated.
   Fixed.

   o density.splitppp, density.ppplist
   Format was out of order if se=TRUE.
   Fixed.

   o MultiStraussHard
   project.ppm sometimes yielded a model that was still invalid.
   Fixed.

        CHANGES IN spatstat VERSION 1.41-1

OVERVIEW

   o This is identical to the major release 1.41-0 except for
    minor bug fixes. The change log for 1.41-0 is repeated here
    with minor modifications.

   o Version nickname: 'Ides of March'

   o We thank Ahmed El-Gabbas, Ute Hahn, Aruna Jammalamadaka,
   Ian Renner, Brian Ripley, Torben Tvedebrink and Sasha Voss 
   for contributions.

   o Fixed a bug causing a segmentation fault.

   o Standard errors for kernel estimates of intensity.

   o Test for segregation.

   o Tessellations may now have marks.

   o Nested splitting.

   o More support for cluster models. Reorganised parametrisation.

   o Sparse data representation of linear networks.

   o More support for data on a linear network.

   o New datasets: 'spiders' and 'dendrite'.

   o Improvements and bug fixes.

   o spatstat no longer uses Fortran.

   o spatstat no longer depends on the package 'scatterplot3d'.

   o spatstat now imports (rather than 'suggests') the Matrix package.

NEW DATASETS

   o dendrite
   Dendritic spines on the dendrite network of a neuron.
   A point pattern on a linear network.
   Generously contributed by Aruna Jammalamadaka.

   o spiders
   Spider webs on the mortar lines of a brick wall.
   A point pattern on a linear network.
   Generously contributed by Sasha Voss.

NEW FUNCTIONS

   o segregation.test
   Test of spatial segregation of types in a multitype point pattern.

   o clusterfield, clusterkernel
   Compute the cluster kernel (offspring density) of a cluster process model,
   or compute the cluster field generated by superimposing copies 
   of the cluster kernel at specified locations.

   o clusterradius
   Compute the radius of the support of the offspring density
   of a cluster process model. 

   o as.linnet.psp
   Convert a line segment pattern to a linear network
   by guessing the connectivity using a distance threshold.

   o iplot.linnet, iplot.lpp
   Methods for interactive plotting 'iplot' for objects of class lpp and linnet.

   o Mathematical operations are now supported for pixel images
   on a linear network. See help(Math.linim)

   o dirichlet.network, delaunay.network
   The linear networks formed by the Dirichlet tessellation 
   and Delaunay triangulation.

   o dirichlet.edges
   The edges of the Dirichlet tessellation.

   o selfcut.psp
   Cut line segments where they cross each other.

   o vertices.linnet
   Extract the vertices (nodes) of the linear network.

   o vertexdegree
   Compute the degree of each vertex in a linear network.

   o pixellate.linnet
   Pixellate a linear network.

   o subset.hyperframe
   'subset' method for class 'hyperframe'.

   o head.hyperframe, tail.hyperframe
   'head' and 'tail' methods for hyperframes.

   o clickdist
   Measures the distance between two spatial locations clicked by the user.

   o solapply, anylapply
   wrappers for 'lapply' which return a list of class 'solist' or 'anylist'.

   o Kmark
   Weighted K-function. 
   Identical to 'markcorrint' and will eventually replace it.

   o marks.tess, marks<-.tess, unmark.tess:
   Extract or change the marks associated with the tiles of a tessellation.

   o quantess
   Quantile tessellation: divide space into pieces which contain
   equal amounts of 'stuff'.

   o nestsplit
   Nested split

   o integral
   New generic function for integrating functions,
   with methods for 'im', 'msr', 'linim' and 'linfun'.

   o selfcut.psp
   Cut line segments where they cross each other

   o as.function.im
   Convert a pixel image to a function(x,y).

   o as.linnet.linim
   Extract the linear network from a 'linim' object.

   o pool.fv, pool.anylist
   New methods for 'pool' 

   o Window.linnet
   Extract the two-dimensional window containing a linear network.

SIGNIFICANT USER-VISIBLE CHANGES

   o linnet, lpp
   A linear network can now be built in 'sparse matrix' form
   which requires much less memory. 

   o chicago
   The Chicago street crimes data are now stored in 'sparse matrix' form.
   To convert them to non-sparse form, use as.lpp(chicago, sparse=FALSE)

   o kppm
   The parametrisation of cluster models has been reorganised.
   The scale parameter is now always called 'scale'.
   Results should be backward-compatible.

   o cauchy.estK, cauchy.estpcf, matclust.estK, matclust.estpcf, 
   thomas.estK, thomas.estpcf, vargamma.estK, vargamma.estpcf
    The parametrisation of cluster models has been reorganised.
    The scale parameter is now always called 'scale'.
   
   o plot.kppm 
   Also plots the cluster kernel.

   o density.ppp
   New argument 'se' allows calculation of standard errors as well.

   o plot.pp3
   Now produces a genuine perspective view.
   New arguments control the eye position for the perspective view.

   o Emark, Vmark
   These functions can now work with multiple columns of marks.

   o pixellate.psp
   Can now count the number of segments that intersect each pixel, 
   instead of the total length of intersection.

   o linfun
   If  g = linfun(f, L),
   the function f will always be called as f(x,y,seg,tp, ...)
   It is no longer expected to handle the case where 'seg' and 'tp' are absent.
   The resulting function g can now be called as g(X) where X is an lpp object,
   or as g(x,y) or g(x,y,seg,tp) where x,y,seg,tp are coordinates.

   o tess
   New argument 'marks' allows marks to be associated with tiles.

   o anova.lppm
   Outdated argument 'override' has been removed.

   o split<-.ppp
   Preserves the original ordering of the data, if possible.

   o MultiHard, MultiStrauss, MultiStraussHard, HierStrauss
   Zero values in the interaction radii are now treated as NA.
   Improved handling of missing arguments.
   Printed output now respects options('width')

   o linearKinhom, linearKcross.inhom, linearKdot.inhom,
     linearpcfinhom, linearpcfcross.inhom, linearpcfdot.inhom
   If the intensity argument lambda, lambdaI, lambdaJ, lambdadot
   is a fitted point process model, the model is first updated
   by re-fitting it to the data, before computing the fitted intensity.

   o solutionset
   The expression will be evaluated using pixel arithmetic (Math.im)
   if it cannot be evaluated using eval.im.

   o to.grey
   Now uses better weights for the R, G, B channels.

   o rVarGamma
   Accelerated.

   o summary.mppm, print.mppm
   These functions now respect options('width') and spatstat.options('terse').

   o print.quadrattest
   Now respects options('width') and spatstat.options('terse').

   o print.pp3
   Now respects options('width')

   o print.lpp
   Now respects options('width') and options('digits').

   o print.owin, print.im, print.summary.owin, print.summary.im
   Now respect options('width').

   o nnmean
   Now yields a vector, instead of a 1-column matrix,
   when there is only a single column of marks.

   o pairdist.psp, crossdist.psp, nndist.psp
   The option 'method="Fortran"' is no longer supported.
   The default is 'method="C"'.
 
   o [.hyperframe:
   When a row of data is extracted with drop=TRUE, the result
   belongs to class 'anylist'.

   o installation of spatstat
   A Fortran compiler is no longer needed to compile spatstat from source.

   o hyperframe class
   The internal structure of hyperframes has changed slightly:
   columns of objects are now stored and returned as
   lists of class 'anylist' or 'solist'.
   There should be no change in behaviour.

   o datasets
   Internal format of the datasets 
   	    bdspots, bei, clmfires, demohyper, flu, gorillas, heather, 
	    Kovesi, murchison, osteo, pyramidal, waterstriders
   has changed slightly to use the classes 'anylist' and 'solist'.
   There should be no change in behaviour.

   o K3est
   New argument 'ratio'.

   o spatstat.options
   New option 'par.points3d' sets default arguments for plot.pp3. 

   o diagnose.ppm
   New arguments 'xlab', 'ylab', 'rlab' determine the labels
   in the 4-panel plot, and new argument 'outer' controls their position.
   The confusing default value for 'compute.sd' has been changed.

   o iplot.layered
   New argument 'visible' controls which layers are initially visible.

   o plot.lpp
   New argument 'show.window' controls whether to plot the containing window.
   
   o textstring
   Any number of spatial locations (x,y) can be specified,
   with a corresponding vector of text strings.

   o plot.hyperframe
   New argument 'mar' 

   o plot.linnet
   New argument 'do.plot'

   o summary.hyperframe
   Improved output.

   o eval.linim
   Improved scoping rules.

   o pixellate.owin
   Accelerated.

   o summary.linnet
   Now prints more information, and respects options('digits').

   o rmpoispp, rmpoint
   The vector of possible types of points will default to the 'names' vector
   of the argument 'lambda', 'n', or 'f' where appropriate.

   o rpoislpp
   Argument 'L' can be omitted when lambda is a 'linim' or 'linfun'

   o simulate.ppm, simulate.kppm, simulate.lppm, simulate.slrm
   New argument 'drop': if nsim = 1 and drop=TRUE, the result is a point pattern
   rather than a list containing one point pattern.

   o runifdisc, runifpoint, rpoint, rpoispp, rmpoint, rmpoispp, 
   rMaternI, rMaternII, rSSI, rPoissonCluster, rGaussPoisson,
   rstrat, rsyst, rcell, rthin, rNeymanScott, rMatClust, rThomas,
   rCauchy, rVarGamma, rpoispp3, runifpoint3
   New argument 'drop': if nsim = 1 and drop=TRUE, the result is a point pattern
   rather than a list containing one point pattern.

   o spatstat.options
   New option 'units.paren' controls the type of parenthesis
   enclosing the explanatory text about the unit of length,
   in print.ppm, plot.fv, etc.

   o closepairs, crosspairs
   New option: what="ijd" returns only the indices i, j and the distance d

   o rCauchy, rMatClust, rNeymanScott, rPoissonCluster, rThomas, rVarGamma
   Argument names have changed.

BUG FIXES

   o sumouter
   A segmentation fault could occur if any data were NA.
   Fixed.

   o simulate.kppm
   Simulation failed for log-Gaussian Cox processes (in simulate.kppm only) 
   with an error message from the RandomFields package.
   Fixed.

   o ppm,  predict.ppm, profilepl
   Crashed sometimes with message 
   "interaction evaluator did not return a matrix".
   Fixed.

   o lppm
   step() did not work correctly on 'lppm' objects.
   Fixed.

   o quadscheme
   If quadscheme() was called explicitly, with the stipulated number of tiles
   exceeding the number of dummy points given, then the quadrature weights 
   were sometimes vastly inflated - total quadrature weight was
   much larger than window area. Spotted by Ian Renner. 
   Fixed.   

   o predict.rhohat
   Result was incorrect for data on a non-rectangular window 
   (and a warning was issued about incorrect vector length).
   Fixed.

   o Math.im
   Unary operators did not work (e.g."-x")
   Fixed.
   
   o density.ppp
   Crashed when at="points" if the dataset had exactly 1 point.
   Fixed.

   o rSSI
   Crashed if nsim > 1.
   Fixed.

   o influence.ppm, leverage.ppm, dfbetas.ppm
   Crashed or issued a warning if any quadrature points had 
   conditional intensity zero under the model (negative infinite values
   of the sufficient statistic).
   Fixed.

   o clickppp, clickpoly
   Did not work correctly in the RStudio display device.
   Fixed.

   o Iest
   Ignored the arguments 'r' and 'eps'.
   Fixed.

   o markvario
   Result was garbled, when X had more than one column of marks.
   Fixed.

   o rMatClust, rVarGamma, rCauchy, rNeymanScott
   Result was a list, but not a 'solist', when nsim > 1.
   Fixed.

   o print.mppm, summary.mppm, subfits
   Crashed if a Poisson interaction was implied but not given explicitly.
   Fixed.

   o Kest
   Crashed if ratio=TRUE and the window was a rectangle.
   Fixed.

   o anova.ppm
   Crashed sometimes with message 'models were not all fitted
   to the same size of dataset'. 
   (This occurred if there were quadrature points with
   conditional intensity equal to zero in some models but not in all models.)
   Fixed.

   o vcov.kppm
   Occasionally ran out of memory.
   Fixed.

   o as.linim.linfun
   Erroneously converted the pixel values to numeric values.
   Fixed.

   o as.owin.layered
   Ignored layers with zero area.
   Fixed.

   o plot.ppm
   Paused the plot between frames even when there was only one frame.
   Fixed.

   o plot.layered
   Did not allocate space for legends of 'lpp' objects.
   Fixed.

   o plot.lpp
   Ignored symbolmap arguments like 'cex'
   and confused the arguments 'col' and 'cols'.
   Fixed.

   o plot.diagppm
   Ignored add=TRUE in some cases.
   Fixed.

   o iplot.layered
   Did not handle 'diagramobj' objects correctly.
   Fixed.

   o plot.yardstick
   Changed arguments.

      CHANGES IN spatstat VERSION 1.41-0

OVERVIEW

   o We thank Ahmed El-Gabbas, Ute Hahn, Aruna Jammalamadaka,
   Ian Renner, Brian Ripley, Torben Tvedebrink and Sasha Voss 
   for contributions.

   o Fixed a bug causing a segmentation fault.

   o Standard errors for kernel estimates of intensity.

   o Test for segregation.

   o Tessellations may now have marks.

   o Nested splitting.

   o More support for cluster models. Reorganised parametrisation.

   o Sparse data representation of linear networks.

   o More support for data on a linear network.

   o New datasets: 'spiders' and 'dendrite'.

   o Improvements and bug fixes.

   o spatstat no longer uses Fortran.

   o spatstat no longer depends on the package 'scatterplot3d'.

   o spatstat now imports (rather than 'suggests') the Matrix package.

   o Nickname: 'Team Australia'

NEW DATASETS

   o dendrite
   Dendritic spines on the dendrite network of a neuron.
   A point pattern on a linear network.
   Generously contributed by Aruna Jammalamadaka.

   o spiders
   Spider webs on the mortar lines of a brick wall.
   A point pattern on a linear network.
   Generously contributed by Sasha Voss.

NEW FUNCTIONS

   o segregation.test
   Test of spatial segregation of types in a multitype point pattern.

   o clusterfield, clusterkernel
   Compute the cluster kernel (offspring density) of a cluster process model,
   or compute the cluster field generated by superimposing copies 
   of the cluster kernel at specified locations.

   o clusterradius
   Compute the radius of the support of the offspring density
   of a cluster process model. 

   o as.linnet.psp
   Convert a line segment pattern to a linear network
   by guessing the connectivity using a distance threshold.

   o iplot.linnet, iplot.lpp
   Methods for interactive plotting 'iplot' for objects of class lpp and linnet.

   o Mathematical operations are now supported for pixel images
   on a linear network. See help(Math.linim)

   o dirichlet.network, delaunay.network
   The linear networks formed by the Dirichlet tessellation 
   and Delaunay triangulation.

   o dirichlet.edges
   The edges of the Dirichlet tessellation.

   o selfcut.psp
   Cut line segments where they cross each other.

   o vertices.linnet
   Extract the vertices (nodes) of the linear network.

   o vertexdegree
   Compute the degree of each vertex in a linear network.

   o pixellate.linnet
   Pixellate a linear network.

   o subset.hyperframe
   'subset' method for class 'hyperframe'.

   o head.hyperframe, tail.hyperframe
   'head' and 'tail' methods for hyperframes.

   o clickdist
   Measures the distance between two spatial locations clicked by the user.

   o solapply, anylapply
   wrappers for 'lapply' which return a list of class 'solist' or 'anylist'.

   o Kmark
   Weighted K-function. 
   Identical to 'markcorrint' and will eventually replace it.

   o marks.tess, marks<-.tess, unmark.tess:
   Extract or change the marks associated with the tiles of a tessellation.

   o quantess
   Quantile tessellation: divide space into pieces which contain
   equal amounts of 'stuff'.

   o nestsplit
   Nested split

   o integral
   New generic function for integrating functions,
   with methods for 'im', 'msr', 'linim' and 'linfun'.

   o selfcut.psp
   Cut line segments where they cross each other

   o as.function.im
   Convert a pixel image to a function(x,y).

   o as.linnet.linim
   Extract the linear network from a 'linim' object.

   o pool.fv, pool.anylist
   New methods for 'pool' 

   o Window.linnet
   Extract the two-dimensional window containing a linear network.

SIGNIFICANT USER-VISIBLE CHANGES

   o linnet, lpp
   A linear network can now be built in 'sparse matrix' form
   which requires much less memory. 

   o chicago
   The Chicago street crimes data are now stored in 'sparse matrix' form.
   To convert them to non-sparse form, use as.lpp(chicago, sparse=FALSE)

   o kppm
   The parametrisation of cluster models has been reorganised.
   The scale parameter is now always called 'scale'.
   Results should be backward-compatible.

   o cauchy.estK, cauchy.estpcf, matclust.estK, matclust.estpcf, 
   thomas.estK, thomas.estpcf, vargamma.estK, vargamma.estpcf
    The parametrisation of cluster models has been reorganised.
    The scale parameter is now always called 'scale'.
   
   o plot.kppm 
   Also plots the cluster kernel.

   o density.ppp
   New argument 'se' allows calculation of standard errors as well.

   o plot.pp3
   Now produces a genuine perspective view.
   New arguments control the eye position for the perspective view.

   o Emark, Vmark
   These functions can now work with multiple columns of marks.

   o pixellate.psp
   Can now count the number of segments that intersect each pixel, 
   instead of the total length of intersection.

   o linfun
   If  g = linfun(f, L),
   the function f will always be called as f(x,y,seg,tp, ...)
   It is no longer expected to handle the case where 'seg' and 'tp' are absent.
   The resulting function g can now be called as g(X) where X is an lpp object,
   or as g(x,y) or g(x,y,seg,tp) where x,y,seg,tp are coordinates.

   o tess
   New argument 'marks' allows marks to be associated with tiles.

   o anova.lppm
   Outdated argument 'override' has been removed.

   o split<-.ppp
   Preserves the original ordering of the data, if possible.

   o MultiHard, MultiStrauss, MultiStraussHard, HierStrauss
   Zero values in the interaction radii are now treated as NA.
   Improved handling of missing arguments.
   Printed output now respects options('width')

   o linearKinhom, linearKcross.inhom, linearKdot.inhom,
     linearpcfinhom, linearpcfcross.inhom, linearpcfdot.inhom
   If the intensity argument lambda, lambdaI, lambdaJ, lambdadot
   is a fitted point process model, the model is first updated
   by re-fitting it to the data, before computing the fitted intensity.

   o solutionset
   The expression will be evaluated using pixel arithmetic (Math.im)
   if it cannot be evaluated using eval.im.

   o to.grey
   Now uses better weights for the R, G, B channels.

   o rVarGamma
   Accelerated.

   o summary.mppm, print.mppm
   These functions now respect options('width') and spatstat.options('terse').

   o print.quadrattest
   Now respects options('width') and spatstat.options('terse').

   o print.pp3
   Now respects options('width')

   o print.lpp
   Now respects options('width') and options('digits').

   o print.owin, print.im, print.summary.owin, print.summary.im
   Now respect options('width').

   o nnmean
   Now yields a vector, instead of a 1-column matrix,
   when there is only a single column of marks.

   o pairdist.psp, crossdist.psp, nndist.psp
   The option 'method="Fortran"' is no longer supported.
   The default is 'method="C"'.
 
   o [.hyperframe:
   When a row of data is extracted with drop=TRUE, the result
   belongs to class 'anylist'.

   o installation of spatstat
   A Fortran compiler is no longer needed to compile spatstat from source.

   o hyperframe class
   The internal structure of hyperframes has changed slightly:
   columns of objects are now stored and returned as
   lists of class 'anylist' or 'solist'.
   There should be no change in behaviour.

   o datasets
   Internal format of the datasets 
   	    bdspots, bei, clmfires, demohyper, flu, gorillas, heather, 
	    Kovesi, murchison, osteo, pyramidal, waterstriders
   has changed slightly to use the classes 'anylist' and 'solist'.
   There should be no change in behaviour.

   o K3est
   New argument 'ratio'.

   o spatstat.options
   New option 'par.points3d' sets default arguments for plot.pp3. 

   o diagnose.ppm
   New arguments 'xlab', 'ylab', 'rlab' determine the labels
   in the 4-panel plot, and new argument 'outer' controls their position.
   The confusing default value for 'compute.sd' has been changed.

   o iplot.layered
   New argument 'visible' controls which layers are initially visible.

   o plot.lpp
   New argument 'show.window' controls whether to plot the containing window.
   
   o textstring
   Any number of spatial locations (x,y) can be specified,
   with a corresponding vector of text strings.

   o plot.hyperframe
   New argument 'mar' 

   o plot.linnet
   New argument 'do.plot'

   o summary.hyperframe
   Improved output.

   o eval.linim
   Improved scoping rules.

   o pixellate.owin
   Accelerated.

   o summary.linnet
   Now prints more information, and respects options('digits').

   o rmpoispp, rmpoint
   The vector of possible types of points will default to the 'names' vector
   of the argument 'lambda', 'n', or 'f' where appropriate.

   o rpoislpp
   Argument 'L' can be omitted when lambda is a 'linim' or 'linfun'

   o simulate.ppm, simulate.kppm, simulate.lppm, simulate.slrm
   New argument 'drop': if nsim = 1 and drop=TRUE, the result is a point pattern
   rather than a list containing one point pattern.

   o runifdisc, runifpoint, rpoint, rpoispp, rmpoint, rmpoispp, 
   rMaternI, rMaternII, rSSI, rPoissonCluster, rGaussPoisson,
   rstrat, rsyst, rcell, rthin, rNeymanScott, rMatClust, rThomas,
   rCauchy, rVarGamma
   New argument 'drop'

   o spatstat.options
   New option 'units.paren' controls the type of parenthesis
   enclosing the explanatory text about the unit of length,
   in print.ppm, plot.fv, etc.

   o closepairs, crosspairs
   New option: what="ijd" returns only the indices i, j and the distance d

   o rCauchy, rMatClust, rNeymanScott, rPoissonCluster, rThomas, rVarGamma
   Argument names have changed.

BUG FIXES

   o sumouter
   A segmentation fault could occur if any data were NA.
   Fixed.

   o simulate.kppm
   Simulation failed for log-Gaussian Cox processes (in simulate.kppm only) 
   with an error message from the RandomFields package.
   Fixed.

   o ppm,  predict.ppm, profilepl
   Crashed sometimes with message 
   "interaction evaluator did not return a matrix".
   Fixed.

   o lppm
   step() did not work correctly on 'lppm' objects.
   Fixed.

   o quadscheme
   If quadscheme() was called explicitly, with the stipulated number of tiles
   exceeding the number of dummy points given, then the quadrature weights 
   were sometimes vastly inflated - total quadrature weight was
   much larger than window area. Spotted by Ian Renner. 
   Fixed.   

   o predict.rhohat
   Result was incorrect for data on a non-rectangular window 
   (and a warning was issued about incorrect vector length).
   Fixed.

   o Math.im
   Unary operators did not work (e.g."-x")
   Fixed.
   
   o density.ppp
   Crashed when at="points" if the dataset had exactly 1 point.
   Fixed.

   o rSSI
   Crashed if nsim > 1.
   Fixed.

   o influence.ppm, leverage.ppm, dfbetas.ppm
   Crashed or issued a warning if any quadrature points had 
   conditional intensity zero under the model (negative infinite values
   of the sufficient statistic).
   Fixed.

   o clickppp, clickpoly
   Did not work correctly in the RStudio display device.
   Fixed.

   o Iest
   Ignored the arguments 'r' and 'eps'.
   Fixed.

   o markvario
   Result was garbled, when X had more than one column of marks.
   Fixed.

   o rMatClust, rVarGamma, rCauchy, rNeymanScott
   Result was a list, but not a 'solist', when nsim > 1.
   Fixed.

   o print.mppm, summary.mppm, subfits
   Crashed if a Poisson interaction was implied but not given explicitly.
   Fixed.

   o Kest
   Crashed if ratio=TRUE and the window was a rectangle.
   Fixed.

   o anova.ppm
   Crashed sometimes with message 'models were not all fitted
   to the same size of dataset'. 
   (This occurred if there were quadrature points with
   conditional intensity equal to zero in some models but not in all models.)
   Fixed.

   o vcov.kppm
   Occasionally ran out of memory.
   Fixed.

   o as.linim.linfun
   Erroneously converted the pixel values to numeric values.
   Fixed.

   o as.owin.layered
   Ignored layers with zero area.
   Fixed.

   o plot.ppm
   Paused the plot between frames even when there was only one frame.
   Fixed.

   o plot.layered
   Did not allocate space for legends of 'lpp' objects.
   Fixed.

   o plot.lpp
   Ignored symbolmap arguments like 'cex'
   and confused the arguments 'col' and 'cols'.
   Fixed.

   o plot.diagppm
   Ignored add=TRUE in some cases.
   Fixed.

   o iplot.layered
   Did not handle 'diagramobj' objects correctly.
   Fixed.

   o plot.yardstick
   Changed arguments.

	CHANGES IN spatstat VERSION 1.40-0

OVERVIEW

   o We thank Markus Herrmann, Peter Kovesi, Andrew Lister, 
   Enrique Miranda, Tuomas Rajala, Brian Ripley, Dominic Schuhmacher 
   and Maxime Woringer for contributions.

   o Important bug fixes.

   o Mathematical operators now apply to images.

   o Parametric estimates of relative risk from fitted point process models.

   o Standard errors for relative risk (parametric and non-parametric).

   o Kernel smoothing and rose diagrams for angular data.

   o Perceptually uniform colour maps. 

   o Hierarchical interactions for multitype patterns.

   o Hard core parameters in all interactions no longer need to be specified
     and will be estimated from data.

   o Improvements to analysis of deviance and model selection.

   o New datasets.

   o New vignette, summarising all datasets installed with spatstat.

   o Tests and diagnostics now include a Monte Carlo option.

   o Faster checking of large datasets.

   o Faster simulations.

   o Code for drawing diagrams (arrows, scale bars).

   o Version nickname: 'Do The Maths'

NEW DATASETS

   o bdspots
   Breakdown spots on microelectronic capacitor electrodes.
   Generously contributed by Prof Enrique Miranda.

   o Kovesi
   Colour maps with perceptually uniform contrast.
   Generously contributed by Peter Kovesi.

NEW FUNCTIONS

   o Mathematical operations are now supported for images.
   For example:   alpha <- atan(bei.extra$grad) * 180/pi
   See help(Math.im)

   o relrisk.ppm
   Spatially-varying probabilities of different types of points
   predicted by a fitted point process model.

   o circdensity
   Kernel density estimate for angular data

   o rose
   Rose diagram (rose of directions) for angular data

   o nnorient
   Nearest neighbour orientation distribution.

   o AIC.ppm
   Calculate AIC of a Gibbs model using Takeuchi's rule.

   o interp.colours
   Interpolate a sequence of colour values.

   o anyDuplicated.ppp, anyDuplicated.ppx
   Fast replacements for any(duplicated(x)) for point patterns.

   o textstring, onearrow, yardstick
   Objects representing a text string, an arrow, or a scale bar,
   for use in drawing spatial diagrams.

   o plot.imlist, image.imlist, contour.imlist
   Methods for the new class 'imlist'

   o [<-.layered,  [[<-.layered
   More support for class 'layered'

SIGNIFICANT USER-VISIBLE CHANGES

   o (vignettes)
   New vignette 'datasets' summarises all the datasets installed
   with the spatstat package.

   o relrisk
   The function relrisk is now generic, with methods for ppp and ppm.
   New argument 'relative' specifies whether to calculate the relative risk
   or the absolute probability of each type of point.
   New argument 'se' specifies whether to calculate standard errors.

   o plot.im
   The default colour map for plotting images,
   specified by spatstat.options('image.colfun'), 
   has been changed to a perceptually uniform map.

   o DiggleGratton, Fiksel, MultiHard, MultiStraussHard
   The hard core distance parameters in these models
   can now be omitted by the user, and will be estimated automatically
   from data (by the 'self-starting' feature of interactions).
   This was already true of Hardcore and StraussHard.

   o Hybrid
   Hybrid models now apply the 'self-starting' feature
   to each component model. 

   o anova.ppm
   Can now reconcile models fitted using different dummy points,
   different values of 'rbord', different values of 'use.gam', etc. 

   o profilepl
   New argument 'aic' makes it possible to optimise the parameters 
   by minimising AIC.

   o profilepl
   No longer requires values for parameters which are 'optional' 
   (such as the hard core distance).

   o rmh, simulate.ppm, rmh.ppm, rmh.default
   The Metropolis-Hastings algorithm now starts by deleting any points
   in the initial state that are 'illegal' (i.e. whose conditional intensity
   is equal to zero). This ensures that the result of rmh 
   never contains illegal points.

   o runifpoint, rpoispp, rStrauss, rHardcore, rStraussHard,
   rDiggleGratton, rDGS, runifdisc, rpoint, rMaternI, rMaternII, rSSI,
   rPoissonCluster, rGaussPoisson, rstrat, rsyst, rcell, rthin, rjitter,
   rNeymanScott, rMatClust, rThomas, rCauchy, rVarGamma, rmpoint, rmpoispp, 
   runifpointOnLines, rpoisppOnLines, runiflpp, rpoislpp, runifpointx, 
   rpoisppx, runifpoint3, rpoispp3
      These random point pattern generators now have an argument 'nsim'
      specifying the number of simulated realisations to be generated.

   o pairorient
   New argument 'cumulative'.
   New algorithm to compute kernel estimate of probability density.
   Default behaviour changed.
   Argument 'units' has been renamed 'unit' for consistency.
   Labels and descriptions of columns have been corrected.

   o predict.ppm
   New syntax (backward-compatible).
   New argument 'se' replaces option 'type="se"'.
   Old argument 'total' is deprecated: use 'window' and set 'type="count"'.
   
   o cdf.test
   The methods for class 'ppm' and 'lppm' now handle Gibbs models
   and perform a Monte Carlo test in this case.

   o lurking, diagnose.ppm
   Lurking variable plot can now include simulation envelopes.

   o rmh.ppm
   New argument 'w' determines the window in which the simulated pattern
   is generated.

   o ppp
   Accelerated.

   o Gcom, Gres
   When conditional=TRUE and restrict=TRUE, the Hanisch estimate
   was not calculated exactly as described in Appendix E.1 of 
   Baddeley, Rubak and Moller (2011). The intensity was estimated 
   on the full window rather than the eroded window.
   Fixed.   

   o step, drop1, add1, extractAIC
   The AIC of a Gibbs model is now calculated using Takeuchi's rule
   for the degrees of freedom.

   o model.matrix.ppm, model.matrix.kppm
   New argument 'Q' allows prediction at any desired locations.

   o vcov.ppm
   New argument 'fine' gives more control over computation.

   o predict.ppm
   For multitype models, when the result is a list of images,
   the names of list entries are now identical to the mark levels
   (e.g. "hickory" instead of "markhickory")

   o print.slrm
   Output now respects options('width')

   o image.listof
   New argument 'ribmar' controls margin space around the ribbon
   when equal.ribbon=TRUE.

   o integral.im
   New argument 'domain' specifies the domain of integration.

   o plot.fasp
   New argument 'transpose' allows rows and columns to be exchanged.

   o plot.im
   The list 'ribargs' can now include the parameter 'labels'.

   o rmh, rpoint, rpoispp, rmpoint, rmpoispp
   Accelerated, for inhomogeneous processes.

   o stienen
   Now recognises the parameter 'lwd'. 

   o suffstat
   Accelerated (also affects ppm with method='ho').

   o Poisson, AreaInter, BadGey, Concom, DiggleGatesStibbard, DiggleGratton,
   Fiksel, Geyer, Hardcore, Hybrid, LennardJones, MultiHard, MultiStrauss,
   MultiStraussHard, OrdThresh, Ord, PairPiece, Pairwise, SatPiece, 
   Saturated, Softcore, Strauss, StraussHard, Triplets
      These functions can now be printed (by typing the function name)
      to give a sensible description of the required syntax.

   o fitin
   A plot of the fitted interpoint interaction of a point process model
   e.g. plot(fitin(ppm(swedishpines ~ 1, Strauss(9))))
   now shows the unit of length on the x-axis.
   
   o fitin
   Plots of the fitted interpoint interaction are now possible
   for some higher-order interactions such as Geyer and AreaInter.

   o anova.ppm
   New argument 'warn' to suppress warnings.

   o rmhmodel.ppm
   Argument 'win' renamed 'w' for consistency with other functions.

   o print.ppm
   Printed output for the fitted regular parameters
   now respects options('digits').

   o print.ppm, print.summary.ppm
   Output now respects options('width') and spatstat.options('terse')

   o print.ppm
   By default, standard errors are not printed 
   for a model fitted with method="logi" (due to computational load)

   o plot.profilepl
   Now recognises 'lty', 'lwd', 'col' etc

   o vesicles, gorillas
   Some of the raw data files for these datasets are also installed in spatstat
   for demonstration and training purposes. 

BUG FIXES

   o rmh, rmh.ppm, rmh.default, simulate.ppm
   The result of simulating a model with a hard core
   did not necessarily respect the hard core constraint,
   and simulation of a model with strong inhibition
   did not necessarily converge. 
   This only happened if the first order trend was large,
   the starting state (n.start or x.start) was not given,
   and the number of iterations (nrep) was not very large.
   It occurred because of a poor choice for the default starting state.
   Bug was present since about 2010.
   Fixed.
   
   o markcorrint
   Results were completely incorrect.
   Bug introduced in spatstat 1.39-0, october 2014.
   Fixed.

   o Kinhom
   Ignored argument 'reciplambda2' in some cases.
   Bug introduced in spatstat 1.39-0, october 2014.
   Fixed.

   o relrisk
   When at="pixels", a small fraction of pixel values were sometimes
   wildly inaccurate, due to numerical errors. This affected the 
   range of values in the result, and therefore the appearance of plots.
   Fixed.

   o model.images
   Crashed if the model was multitype.
   Fixed.

   o profilepl
   Crashed in some cases when the interaction was multitype.
   [Spotted by Andrew Lister.]
   Fixed.

   o profilepl
   Crashed if the model involved covariates that were not
   given in a 'data' argument.
   Fixed.

   o envelope.ppm
   Crashed if global=TRUE and savefuns=TRUE.
   Fixed.

   o setminus.owin
   Crashed if the result was empty and the input was polygonal.
   Fixed.

   o predict.ppm
   Crashed sometimes when type="cif" and ngrid was very large.
   Fixed.

   o pixelquad
   If X was a multitype point pattern, the result was mangled.
   Fixed.

   o relrisk
   Did not accept a character string value for the argument 'case'.
   Fixed.

   o intensity.ppm
   Format of result was incorrect for ppm(Y ~ 1) where Y is multitype.
   Fixed.

   o $<-.hyperframe
   Columns containing character values were converted to factors.
   Fixed.

   o clickppp
   Sometimes filled the window in solid black colour..
   Fixed.

   o plot.psp
   Ignored 'show.all' in some cases.
   Fixed.

   o plot.ppp
   Warned about NA values amongst the marks, even if there were no NA's
   in the column(s) of marks selected by the argument 'which.marks'.
   Fixed.

   o stienen
   Did not suppress the border circles when border=FALSE.
   Fixed.

	CHANGES IN spatstat VERSION 1.39-1

OVERVIEW

   o Urgent bug fix.

   o We thank Suman Rakshit and Brian Ripley for contributions.

BUG FIXES

   o bdry.mask, convexhull
   In R-devel only, these functions could return an empty window,
   causing errors in other packages.
   [Spotted by Brian Ripley.]
   Fixed.

   o project2segment
   An error occurred if any line segments had length zero.
   [Spotted by Suman Rakshit.]
   Fixed.


	CHANGES IN spatstat VERSION 1.39-0

OVERVIEW

   o We thank Shane Frank, Shaaban Ghalandarayeshi, Ute Hahn, 
     Mahdieh Khanmohammadi, Nicoletta Nava, Jens Randel Nyengaard,
     Sebastian Schutte, Rasmus Waagepetersen and Carl G. Witthoft 
     for contributions.

   o ANOVA extended to Gibbs models.

   o Improved algorithm for locally-scaled K-function.

   o Leave-one-out calculation of fitted values in ppm objects.

   o New dataset: presynaptic vesicles.

   o Geometrical operations with windows and images.

   o More edge corrections for K-function.

   o Improved handling and plotting of 'fv' objects.

   o Utilities for perspective views of surfaces.

   o New classes 'anylist', 'solist' will ultimately replace 'listof'.

   o Bug fixes.

   o Version nickname: 'Smoke and Mirrors'

NEW DATASETS

   o vesicles
   Synaptic vesicles 
   (includes raw data files for training purposes)

NEW CLASSES

   o anylist
   List of objects. 
   (A replacement for 'listof')

   o solist
   List of two-dimensional spatial objects.
   (A replacement for some uses of 'listof')

NEW FUNCTIONS

   o perspPoints, perspLines, perspSegments, perspContour
   Draw points and lines on a surface, as seen in perspective view.

   o hopskel.test
   Hopkins-Skellam test of CSR

   o project2set
   For each data point in a point pattern X, find the nearest
   spatial location in a given window W.

   o stienen, stienenset
   Stienen diagrams

   o dirichlet.vertices
   Vertices of the Dirichlet tessellation

   o discs 
   Union of discs.
   Given a point pattern dataset recording the locations and diameters
   of objects, find the region covered by the objects.

   o increment.fv
   Increments of a summary function: g(x) = f(x+h)-f(x-h).

   o rotmean
   Rotational average of pixel values in an image

   o fardist
   Distance from each pixel/data point to farthest part of window boundary

   o circumradius.owin
   Circumradius of a window

   o rmax.Trans, rmax.Ripley
   Compute the maximum distance 'r' for which the 
   translation edge correction and isotropic edge correction   
   are valid.

   o is.grey
   Determines whether a colour value is a shade of grey.

   o harmonise
   Convert several objects of the same class to a common format.
   (New generic function with existing methods harmonise.im and harmonise.fv)

   o area
   New generic function, with methods for 'owin' and 'default'.

   o Fhazard
   Hazard rate of empty space function

   o anylist, as.anylist, [.anylist, [<-.anylist, print.anylist, summary.anylist
   Support for new class 'anylist'

   o solist, as.solist, [.solist, [<-.solist, print.solist, summary.solist
   Support for new class 'solist'

   o plot.anylist, plot.solist
   Plot methods for the classes 'anylist' and 'solist'
   (Currently identical to 'plot.listof')

SIGNIFICANT USER-VISIBLE CHANGES

   o anova.ppm
   Now applies to Gibbs models as well as Poisson models,
   using adjusted composite likelihood ratio test statistic.

   o persp.im
   If visible=TRUE, the algorithm will also calculate which pixels of x
   are visible in the perspective view. This is useful for drawing
   points or lines on a perspective surface.

   o Kscaled
   Improved algorithm [thanks to Ute Hahn.]
   New arguments 'renormalise' and 'normpower' allow renormalisation
   of intensity, similar to Kinhom.

   o Kest
   New option: correction="rigid" computes the rigid motion correction.

   o pairwise interactions 
   Fitted parameters and other calculations for pairwise interaction models
   DiggleGatesStibbard, DiggleGratton, Fiksel, Geyer, Strauss 
   may change slightly due to a change in handling numerical rounding effects.

   o eval.fv
   Functions no longer need to have exactly the same sequence of 'r' values.
   They will now be made compatible using 'harmonise.fv'.

   o fitted.ppm
   New argument 'leaveoneout' allows leave-one-out calculation
   of fitted intensity at original data points.

   o Kinhom, Linhom
   New argument 'leaveoneout' specifies whether the leave-one-out rule
   should be applied when calculating the fitted intensities. 
   
   o crosspaircounts
   Results may change slightly due to a change in handling numerical 
   rounding effects.

   o Fest, Gest
   New argument 'domain' supports bootstrap methods.
 
   o plot.fv
   New argument 'mathfont' determines the font (e.g. plain, italic, bold)
   for mathematical expressions on the axes and in the legend.
   Defaults to italic.

   o scanpp 
   Upgraded to handle multiple columns of mark data.

   o circumradius
   The function 'circumradius' is now generic, with methods
   for the classes 'owin' and 'linnet'.

   o edge.Trans
   New argument 'give.rmax' 

   o fvnames, plot.fv
   The symbol '.a' is now recognised. It stands for 'all function values'.

   o as.function.fv
   Argument 'extrapolate' can have length 1 or 2.

   o varblock
   New argument 'confidence' determines the confidence level.

   o $<-.fv
   This can now be used to add an extra column to an 'fv' object
   (previously it refused).

   o minnndist, maxnndist
   New argument 'positive'. If TRUE, coincident points are ignored:
   the nearest-neighbour distance of a point is the distance to the
   nearest point that does not coincide with the current point.

   o plot.fv
   Improved handling of 'shade' argument.

   o Kmeasure
   Now passes '...' arguments to as.mask()

   o Ksector
   Now allows start < 0.  
   New arguments 'units' and 'domain'.

   o pairorient
   New arguments 'units' and 'domain'.

   o eroded.areas
   New argument 'subset'

   o disc
   New argument 'delta' 

   o plot.plotppm
   New argument 'pppargs'

   o harmonise.fv, harmonise.im
   These are now methods for the new generic 'harmonise'

   o Fest, Gest
   These functions now also compute the theoretical value of hazard
   for a Poisson process, if correction = "km".

   o with.fv
   Improved mathematical labels.

   o Gfox, Jfox
   Improved mathematical labels.

   o area.owin
   This function is now a method for the new generic 'area'

   o edges
   Default for argument 'check' changed to FALSE.

BUG FIXES

   o varblock
   Calculations were incorrect if more than one column of 
   edge corrections was computed. 
   [Bug introduced in spatstat 1.21-1, november 2010.]
   Fixed.

   o varblock
   Crashed if one of the quadrats contained no data points.
   Fixed.

   o lohboot
   Interval was calculated wrongly when global=TRUE and fun="Lest" or "Linhom".
   Fixed.

   o nnmark
   Crashed when at="points" if there was only a single column of marks.
   [Spotted by Shane Frank.]
   Fixed.

   o plot.msr
   Some elements of the plot were omitted or cut off.
   Fixed.

   o plot.msr
   Did not work with 'equal.scales=TRUE'.
   Fixed.

   o plot.msr, augment.msr
   Crashed if every data point was duplicated.
   Fixed.

   o as.im.owin
   Crashed if X was a 1 x 1 pixel array.
   Fixed.

   o owin
   Coordinates of polygon data were altered slightly when fix=TRUE. 
   [Spotted by Carl Witthoft.]
   Fixed.
   
   o objects of class 'fv'
   Assigning a new value to names(x) or colnames(x) or dimnames(x)
   would cause the internal data format to become corrupted.
   Fixed.

   o to.grey, complementarycolour
   Did not work properly on 'colourmap' objects.
   Fixed.

   o Kest
   Ignored argument 'var.approx' if the window was a rectangle.
   Fixed.

   o rmh.ppm, rmhmodel.ppm
   Ignored the argument 'new.coef'.
   [Spotted by Sebastian Schutte]
   Fixed.

   o as.function.fv
   The meanings of 'extrapolate=TRUE' and 'extrapolate=FALSE' were swapped.
   Fixed.

   o varblock
   Handled the case 'fun=Lest' incorrectly.
   Fixed.

   o [.fv
   Sometimes garbled the internal data format, causing plot.fv to crash.
   Fixed.

   o range.fv
   Sometimes returned NA even when na.rm=TRUE.
   Fixed.

   o Fest
   Argument 'eps' was not interpreted correctly.
   Fixed.

   o plot.fv
   Argument 'lwd' was not passed to legend()

   o flipxy.owin
   Sometimes deleted the name of the unit of length.
   Fixed.

	CHANGES IN spatstat VERSION 1.38-1

OVERVIEW

   o We thank Ute Hahn and Xavier Raynaud for contributions.

   o Urgent Bug Fixes.

   o Nickname: 'Le Hardi'

NEW FUNCTIONS

   o "[<-.fv", "$<-.fv"
   Subset replacement methods for 'fv' objects.

SIGNIFICANT USER-VISIBLE CHANGES

   o clarkevans.test
   Simulations are now performed with a fixed number of points.

   o plot.owin, plot.ppp, plot.psp, plot.im
   The default size of the outer margin of white space has been
   reduced. 

   o dclf.test
   Improved information in printed output.

BUG FIXES

   o update.ppm
   Results were incorrect in several cases.
   [Spotted by Xavier Raynaud.]
   Bug introduced in spatstat 1.38-0.
   Fixed.

   o Kinhom, Linhom
   Calculations were incorrect if 'lambda' was a fitted point process model.
   [Spotted by Xavier Raynaud.]
   Bug introduced in spatstat 1.38-0.
   Fixed.

   o envelope.envelope
   Ignored the arguments 'global' and 'VARIANCE'.
   Fixed.

   o fv objects
   If 'f' was an object of class 'fv', then an assignment like f$name <- NULL
   mangled the internal format of the object 'f', leading to errors
   in print.fv and plot.fv.
   [Spotted by Ute Hahn.]
   Fixed.

   o split.ppp
   split(X, A) where A is a rectangular tessellation,
   produced errors if the window of 'A' did not include the window of 'X'.
   [Spotted by Ute Hahn.]
   Fixed.

   o names<-.hyperframe
   Mangled the internal format.
   [Spotted by Ute Hahn.]
   Fixed.
   
   o plot.fv
   y axis label was incorrect in some cases when the 'fv' object
   had only a single column of function values.
   [Spotted by Ute Hahn.]
   Fixed.

   
	CHANGES IN spatstat VERSION 1.38-0

OVERVIEW

   o We thank Malissa Baddeley, Colin Beale, Oscar Garcia, Daniel Esser, 
     David Ford, Eric Gilleland, Andrew Hardegen, Philipp Hunziker, 
     Abdollah Jalilian, Tom Lawrence, Lore De Middeleer, Robin Milne, 
     Mike Porter, Suman Rakshit, Pablo Ramon, Jason Rudokas, 
     Christopher Ryan, Dominic Schuhmacher, Medha Uppala 
     and Rasmus Waagepetersen for contributions.

   o spatstat now Requires the package 'goftest' 
     and Suggests the package 'Matrix'.

   o New dataset: 'sporophores'

   o Palm likelihood method for fitting cluster processes and Cox processes.

   o Quasi-likelihood and weighted composite likelihood methods
     for estimating trend in cluster processes and Cox processes.

   o Further extensions to model formulas in ppm and kppm.

   o Faster variance calculations for ppm objects.

   o One-sided tests and one-sided envelopes of summary functions.

   o Cramer-Von Mises and Anderson-Darling tests of spatial distribution.

   o Cressie-Read test statistic in quadrat counting tests.

   o Spatial cumulative distribution functions.

   o Faster algorithm for point pattern matching.

   o Improvements to plots.

   o Increased support for envelopes.

   o New generic functions 'Window', 'Frame' and 'domain'.

   o Directional K-function and directional distribution.

   o Raster calculations accelerated.

   o Summary functions accelerated.

   o Many improvements and bug fixes.

   o Version nickname: 'Wicked Plot'

NEW DATASETS

   o sporophores
   Spatial pattern of three species of mycorrhizal fungi around a tree.
   [Contributed by E. David Ford.]

NEW FUNCTIONS

   o improve.kppm
   Re-estimate the trend in a kppm (cluster or Cox) model
   using quasi-likelihood or weighted first-order composite likelihood.
   [Contributed by Abdollah Jalilian and Rasmus Waagepetersen.]

   o Window, Window<-
   Generic functions to extract and change the window of a spatial object
   in two dimensions. Methods for ppp, psp, im, and many others.

   o Frame, Frame<-
   Generic functions to extract and change the containing rectangle ('frame')
   of a spatial object in two dimensions. 

   o domain
   Generic function to extract the spatial domain of a spatial object
   in any number of dimensions. 

   o Ksector
   Directional version of the K-function.

   o pairorient
   Point pair orientation distribution.

   o spatialcdf
   Compute the spatial cumulative distribution of a spatial covariate,
   optionally using spatially-varying weights.

   o cdf.test 
   [Supersedes 'kstest'.]
   Test of goodness-of-fit of a Poisson point process model.
   The observed and predicted distributions of the values of a 
   spatial covariate are compared using either the
   Kolmogorov-Smirnov, Cramer-Von Mises or Anderson-Darling test.

   o berman.test
   Replaces 'bermantest'.

   o harmonise.fv
   Make several functions compatible.

   o simulate.lppm
   Simulate a fitted point process model on a linear network.

   o subset.ppp, subset.lpp, subset.pp3, subset.ppx
   Methods for 'subset', for point patterns.

   o closepairs.pp3, crosspairs.pp3
   Low-level functions to find all close pairs of points in three dimensions

   o volume.linnet
   Method for the generic 'volume'. Returns the length of the linear network.

   o padimage
   Pad the border of a pixel image.
 
   o as.layered
   Convert spatial data to a layered object.

   o panel.contour, panel.image, panel.histogram
   Panel functions for 'pairs' plots.

   o range.fv, min.fv, max.fv
   Range, minimum and maximum of function values.

SIGNIFICANT USER-VISIBLE CHANGES

   o ppm.formula
   The left hand side of the formula can now be the name of 
   an object in the list 'data', or an expression involving such objects.

   o ppm
   The right hand side of the formula can now include 
   the symbol '.' representing all covariates in the list 'data'.

   o ppm
   New argument 'subset' makes it possible to fit the model
   in a subset of the spatial domain defined by an expression.

   o kppm
   New option: method="palm", will fit the model by maximising Palm likelihood.

   o pppdist
   Substantially accelerated. 
   New argument 'auction' controls choice of algorithm.

   o rhohat
   New arguments 'weights' and 'horvitz' for weighted calculations.

   o persp.im
   Surface heights and colours can now be controlled by different images.
   Option to draw a grey apron around the sides of the perspective plot. 
   Return value has a new attribute 'expand'.

   o plot.listof
   New arguments 'halign' and 'valign' give improved control
   over the alignment of panels.

   o plot.listof
   If all components of the list are objects of class 'fv' 
   representing functions, then if equal.scales=TRUE, these
   functions will all be plotted with the same axes 
   (i.e. the same xlim and the same ylim).

   o envelope
   The argument 'transform' is now processed by 'with.fv'
   giving more options, such as 'transform=expression(. - r)'

   o envelope, dclf.test, mad.test
   One-sided tests and one-sided envelopes can now be produced, 
   by specifying the argument 'alternative'.

   o dclf.test, mad.test
   A pointwise test at fixed distance 'r' can now be performed
   by setting rinterval = c(r,r).

   o envelope
   New arguments 'fix.n' and 'fix.marks' for envelope.ppp and envelope.ppm
   make it easy to generate simulated patterns conditional on the
   total number of points, or on the number of points of each type.

   o quadrat.test
   Can now calculate the Cressie-Read test statistic
   instead of the Pearson X2 statistic.

   o Kres, Gres, Kcom, Gcom, psst, psstA, psstG
   New argument 'model' makes it easier to generate simulation envelopes
   of the residual summary functions.

   o layered, plot.layered
   The layer plot arguments can include the argument '.plot'
   specifying a function to perform the plotting instead of the
   generic 'plot'.

   o deriv.fv
   New arguments make it possible to differentiate a periodic function.

   o ppm
   Argument 'data' or 'covariates' can now include entries
   which are not spatial covariates, provided they do not appear 
   in the model formula.

   o closepairs, crosspairs
   These functions are now generic, with methods for 'ppp' and 'pp3'

   o rLGCP
   Updated to conform to new usage of RandomFields package.
   Argument syntax has changed.
   Now allows control over pixel resolution.

   o bw.diggle
   New arguments 'correction' and 'hmax' for controlling the calculation.

   o predict.lppm
   New argument 'new.coef' for computing predictions with a 
   different vector of model coefficients.

   o predict.ppm
   If 'locations' is a pixel image, its pixels determine the
   spatial locations for prediction.

   o cut.ppp
   Argument 'z' can now be a window.

   o split.ppp
   Argument 'f' can now be a window.

   o print.ppm, summary.ppm, coef.summary.ppm
   The table of parameter estimates, standard errors and confidence intervals
   now also includes the value of the (signed square root) Wald test statistic.

   o plot.im
   Now automatically detects problems in some Windows graphics displays
   and tries to avoid them.

   o plot.im
   The position of axis tick marks alongside the colour ribbon
   can now be controlled using the parameter 'at' in the argument 'ribargs'.

   o plot.ppp
   Can now plot numeric marks using characters chosen by 'pch' or 'chars'
   with size determined by mark value.

   o plot.ppp
   New argument 'meansize' for controlling mark scale.

   o hsvim, rgbim
   New argument 'autoscale' causes automatic scaling of colour channel values.

   o plot.ppp
   If type='n', a legend is now displayed when x is a marked point pattern.

   o whist
   Accelerated by a factor of 5.

   o Fest, Jest
   Accelerated by a factor of 2 to 3.

   o fryplot
   Accelerated.
   Now displays a legend if the point pattern is marked.
   Now handles numerical marks nicely.
   New argument 'axes'.

   o frypoints
   Accelerated.
   New arguments 'to', 'from' and 'dmax'.

   o duplicated.ppp
   New option: rule = 'unmark'

   o rjitter
   Argument 'radius' now has a default.

   o Smooth.msr
   New argument 'drop'

   o LambertW
   Now handles NA and infinite values.

   o update.ppm
   Now handles formulae with a left-hand side.

   o raster.x, raster.y, raster.xy
   These functions can now handle images, as well as masks.

   o Smooth.ppp
   If the mark values are exactly constant, the resulting smoothed values
   are now exactly constant.

   o eval.im, eval.fv, eval.fasp
   Argument 'envir' can now be a list, instead of an environment.

   o plot.ppp
   The printout (of the resulting symbol map object)
   now displays the numerical value of the mark scale.

   o with.fv
   Improved mathematical labels.

   o plot.fv
   Improved mathematical labels on x axis.

   o ppm
   Improved error messages.

   o vcov.ppm
   Computations greatly accelerated for Hybrid interactions
   and for Area-interaction models.

   o vcov.kppm
   Computations greatly accelerated (when fast=TRUE)   

   o interp.im
   Argument 'x' can now be a point pattern.

   o pool.envelope
   Improved handling of text information.

   o miplot
   Improved layout.

   o print.summary.ppp
   Improved layout. 
   Now respects spatstat.options('terse')

   o print.profilepl
   Improved layout. 
   Now respects spatstat.options('terse')

   o anova.ppm
   Now respects spatstat.options('terse')

   o print.fv, print.envelope
   Now respect spatstat.options('terse') and options('width')
   
   o summary.envelope
   Now respects options('width')
   
   o kstest, bermantest
   These functions will soon be Deprecated.
   They are retained only for backward compatibility.

BUG FIXES

   o vcov.ppm
   Sometimes gave wrong answers for Poisson models fitted by method='logi'.
   Fixed.

   o unnormdensity
   If weights were missing, the density was normalised,
   contrary to the documentation.
   Fixed.

   o logLik.ppm, anova.ppm, AIC
   For models fitted by 'ippm', the number of degrees of freedom was incorrect.
   Fixed.

   o im.apply
   Pixels outside the window were not assigned the value NA as they should.
   Fixed.

   o pixellate.owin
   Crashed, unpredictably, if the pixel raster had unequal numbers
   of rows and columns.
   [Spotted by Rasmus Waagepetersen.]
   Fixed.

   o vcov.ppm
   Crashed for pairwise interaction models fitted by method="logi".
   Fixed.

   o predict.ppm
   Crashed for models fitted by method="logi"
   if the model included external covariates.
   Fixed.

   o predict.ppm
   Crashed if the argument 'covariates' or 'data' in the original call to 'ppm'
   included entries that were not spatial covariates. [These entries were
   ignored by ppm but caused predict.ppm to crash.]
   Fixed.

   o simulate.kppm, rNeymanScott, rThomas, rMatClust
   Crashed randomly when simulating an inhomogeneous model.
   [Spotted by Philipp Hunziker.]
   Fixed.
   
   o bw.diggle
   In some extreme cases, generated an error message
   about `NaN values in Foreign function call.'
   [Spotted by Colin Beale.]
   Fixed.

   o textureplot
   Crashed if 'spacing' was too large.
   Fixed.

   o superimpose.psp
   Crashed if the result was empty.
   Fixed.

   o istat
   Crashed with an error message about 'vars'.
   Fixed.

   o dirichlet, delaunay, delaunay.distance
   Crashed in rare cases due to a problem in package 'deldir'. 
   [Spotted by Pierre Legendre.]
   Fixed.

   o rgbim, hsvim
   Crashed if any argument was constant.
   Fixed.

   o scaletointerval
   Crashed if x was constant.
   Fixed.

   o linnet, [.linnet
   Crashed if the result contained only a single vertex.
   [Spotted by Daniel Esser.]
   Fixed.

   o plot.fv
   If some of the function values were NA,
   they were replaced by fictitious values
   (by linearly interpolating).
   Fixed.

   o crossdist.ppp
   Ignored argument 'squared' if periodic=FALSE.
   [Spotted by Mike Porter.]
   Fixed.

   o marks<-.ppp
   Ignored argument 'drop'.
   [Spotted by Oscar Garcia.]
   Fixed.
 
   o update.ppm
   Sometimes did not respect the argument 'use.internal'.
   Fixed.

   o plot.rhohat
   Did not respect the argument 'limitsonly'.
   Fixed.

   o contour.im
   Argument 'axes' defaulted to TRUE, but FALSE was intended.
   Fixed.

   o print.hyperframe, as.data.frame.hyperframe
   Column names were mangled if the hyperframe had a single row.
   Fixed.

   o as.psp.data.frame
   Generated a warning about partially-matched names in a data frame.
   [Spotted by Eric Gilleland.]
   Fixed.

   o plot.leverage.ppm
   Generated a warning from 'contour.default'
   if the leverage function was constant.
   Fixed.

   o plot.diagppm
   Issued warnings about unrecognised graphics parameters.
   Fixed.

   o update.symbolmap
   Discarded information about the range of input values.
   Fixed.

   o plot.fv
   Label for y axis was garbled, if argument 'shade' was given.
   Fixed.

   o plot.ppp
   The legend was sometimes plotted when it should not have been 
   (e.g. when add=TRUE).
   Fixed.

   o plot.listof, plot.im
   In an array of plots, containing both images and other spatial objects,
   the titles of the panels were not correctly aligned.
   Fixed.

   o plot.tess, plot.quadratcount
   Ignored arguments like 'cex.main'.
   Fixed.

   o iplot
   Navigation buttons (Left, Right, Up, Down, Zoom In, Zoom Out)
   did not immediately refresh the plot.
   Fixed.

   o iplot.layered
   Reported an error 'invalid argument type' if all layers were deselected.
   Fixed.

	CHANGES IN spatstat VERSION 1.37-0

OVERVIEW

   o Ege Rubak is now a joint author of spatstat. 

   o We thank Peter Forbes, Tom Lawrence and Mikko Vihtakari for contributions.

   o Spatstat now exceeds 100,000 lines of code.

   o New syntax for point process models (ppm, kppm, lppm)
     equivalent to syntax of lm, glm, ...

   o Covariates in ppm and kppm can now be tessellations.

   o Confidence intervals and prediction intervals for fitted models.

   o Quasirandom point patterns and sequences.

   o Plots using texture fill.

   o Support for mappings from data to graphical symbols and textures.

   o Automatic re-fitting of model in Ginhom, Kinhom, Finhom, Jinhom.

   o Support for Mixed Poisson distribution.

   o Interpretation of mark scale parameters has changed in plot.ppp

   o Syntax of multitype interactions (eg MultiStrauss) has changed.

   o Bug fix in Metropolis-Hastings simulation of 'StraussHard' models

   o Changed default behaviour of perfect simulation algorithms.

   o Improvements to layout of text output.

   o Version nickname: 'Model Prisoner'

NEW CLASSES

   o symbolmap
   An object of class 'symbolmap' represents a mapping
   from data to graphical symbols

   o texturemap
   An object of class 'texturemap' represents a mapping
   from data to graphical textures.

NEW FUNCTIONS

   o split.hyperframe, split<-.hyperframe
   methods for split and split<- for hyperframes.

   o dmixpois, pmixpois, qmixpois, rmixpois
   (log-)normal mixture of Poisson distributions.

   o vdCorput, Halton, Hammersley, rQuasi
   quasirandom sequences and quasirandom point patterns.

   o Smoothfun
   create a function(x,y) equivalent to the result of Smooth.ppp

   o minnndist, maxnndist
   Faster ways to compute min(nndist(X)), max(nndist(X))

   o add.texture
   Draw a simple texture inside a specified region.

   o textureplot
   Display a factor-valued pixel image using texture fill.

   o texturemap
   Create a texture map

   o plot.texturemap
   Plot a texture map in the style of a legend
   
   o symbolmap
   Create a symbol map

   o update.symbolmap
   Modify a symbol map

   o invoke.symbolmap
   Apply symbol map to data values, and plot them

   o plot.symbolmap 
   Plot the symbol map in the style of a legend

   o as.owin.boxx
   Converts a 'boxx' to an 'owin' if possible.

   o ellipse
   Create an elliptical window.

   o clickbox
   Interactively specify a rectangle, by point-and-click on a graphics device.

   o complementarycolour
   Compute the complementary colour value of a given colour value,
   or the complementary colour map of a given colour map.

   o gauss.hermite
   Gauss-Hermite quadrature approximation to the expectation
   of any function of a normally-distributed random variable.	

   o boundingbox
   Generic function, replaces bounding.box

   o edges
   Extract boundary edges of a window. 
   Replaces and extends 'as.psp.owin'

   o pixelcentres
   Extract centres of pixels as a point pattern.

SIGNIFICANT USER-VISIBLE CHANGES

   o ppm, kppm, lppm
   NEW SYNTAX FOR POINT PROCESS MODELS
   The model-fitting functions 'ppm', 'kppm' and 'lppm' now accept
   a syntax similar to 'lm' or 'glm', for example  ppm(X ~ Z), 
   but still accept the older syntax ppm(X, ~Z). 
   To support both kinds of syntax, the functions 'ppm' and 'kppm'
   are now generic, with methods for the classes 'formula', 'ppp' and 'quad'. 
   The 'formula' method handles a syntax like ppm(X ~ Z) while the
   'ppp' method handles the old syntax ppm(X, ~Z).
   Similarly 'lppm' is generic with methods for 'formula' and 'lpp'.

   o ppm, kppm, lppm
   Covariates appearing in the model formula can be objects 
   which exist in the R session, instead of always having to be
   elements of the list `covariates'.
   
   o ppm.formula, kppm.formula, lppm.formula
   Formulae involving polynom() are now expanded, symbolically,
   so that polynom(x, 3) becomes x + I(x^2) + I(x^3) 
   and polynom(x,y,2) becomes x + y + I(x^2) + I(x*y) + I(y^2).
   This neatens the model output, and also makes it possible
   for anova() and step() to add or delete single terms in the polynomial.

   o predict.ppm
   New argument 'interval' allows confidence intervals or prediction intervals
   to be calculated.

   o predict.ppm
   New argument 'total' allows for prediction of the total number of points
   in a specified region.
   
   o plot.ppp, plot.lpp
   For marked point patterns, a legend is automatically added
   to the plot, by default. Arguments have changed: new arguments
   include parameters of the legend, and an optional symbol map.
   Result has changed: it is now an object of class 'symbolmap'.

   o plot.ppp, plot.lpp
   Interpretation of the parameters 'markscale' and 'maxsize' 
   has changed. The size of a circle in the plot is now defined 
   as the circle's diameter instead of its radius. (Size of
   a square is measured, as before, by its side length). 

   o parres
   Now handles the case where the fitted model is not separable
   but its restriction to the given 'subregion' is separable.

   o envelope
   Now issues a warning if the usage of envelope() appears to be `invalid' 
   in the sense that the simulated patterns and the data pattern
   have not been treated equally.

   o Kinhom, Finhom, Ginhom, Jinhom
   New argument 'update'.
   If 'lambda' is a fitted model (class ppm or kppm) and update=TRUE,
   the model is re-fitted to the data pattern, before the intensities
   are computed.

   o rDiggleGratton, rDGS, rHardcore, rStrauss, rStraussHard
   By default the point pattern is now generated on
   a larger window, and trimmed to the original window.
   New argument expand=TRUE.

   o MultiStrauss, MultiHard, MultiStraussHard
   The syntax of these functions has changed.
   The new code should still accept the old syntax.

   o rhohat
   rhohat.ppp and rhohat.quad have new argument 'baseline'

   o ippm
   Algorithm improved. Argument syntax changed.

   o default.dummy, quadscheme
   Dummy points can now be generated by a quasirandom sequence.

   o plot.owin
   The window can now be filled with one of 8 different textures.
   Arguments changed. 

   o ppm, kppm
   Covariates in the model can now be tessellations.

   o [.im
   New argument 'tight' allows the resulting image to be trimmed 
   to the smallest possible rectangle.

   o [.psp, rlinegrid, rpoisline
   These functions now handle binary mask windows.

   o rotate
   The user can specify the centre of rotation.

   o rescale
   rescale() and all its methods now have argument 'unitname'
   which can be used to change the name of the unit of length.

   o anova.ppm
   Output format has been improved. 
   Number of columns of result has changed.

   o print.ppp, print.summary.ppp, print.owin, print.summary.owin,
   print.im, print.summary.im, print.fv, print.msr, print.profilepl
   These functions now avoid over-running the text margin
   (i.e. they respect options('width') where possible).

   o layerplotargs<-
   Now handles any spatial object, converting it to a 'layered' object.

   o effectfun
   Improved display in case se.fit=TRUE.

   o scaletointerval
   New argument 'xrange'

   o contour.im
   New argument 'show.all'.
   Default value of 'axes' changed to FALSE.

   o identify.ppp
   Now handles multivariate marks. 

   o plot.listof
   Improved layout.
   New arguments 'hsep', 'vsep'.
   Argument 'mar.panel' may have length 1, 2 or 4.

   o plot.splitppp
   This function is no longer identical to plot.listof.
   Instead it is a much simpler function which just
   calls plot.listof with equal.scales=TRUE.

   o anova.ppm
   Output is neater.

   o plot.layered
   New argument 'do.plot'

   o plot.psp
   New argument 'do.plot'
   
   o as.psp.owin
   New argument 'window'

   o plot.im, contour.im, textureplot
   New argument 'clipwin'

   o plot.ppp
   New argument 'clipwin'

   o plot.msr
   New argument 'how' allows density to be plotted as image and/or contour

   o diagnose.ppm, plot.diagppm
   More options for 'plot.neg'

   o plot.leverage.ppm, plot.influence.ppm, plot.msr
   Argument 'clipwin' can now be used to restrict the display
   to a subset of the full data.

   o [.hyperframe, [<-.hyperframe, $.hyperframe, $<-.hyperframe
   These functions are now documented.

   o leverage.ppm, influence.ppm, dfbetas.ppm
   Resulting objects are now smaller (in memory size).

   o print.ppm
   Now indicates whether the irregular parameters 'covfunargs'
   were optimised (by profilepl or ippm) or whether they were simply
   provided by the user.

   o plot.ppp
   A point pattern with numerical marks can now be plotted as
   filled dots with colours determined by the marks, 
   by setting pch=21 and bg=<colourmap>

   o colourmap
   Now handles dates and date-time values (of class 'Date' or 'POSIXt').

   o plot.ppp, print.ppp, summary.ppp
   Improved handling of dates and date-time values 
   (of class 'Date' or 'POSIXt') in the marks of a point pattern.

   o cut.im
   Now refuses to handle images whose pixel values are
   factor, logical or character.

   o centroid.owin
   New argument 'as.ppp'

   o superimpose
   Improved default names for columns of marks.

   o Softcore()
   Improved printout.

   o kppm, lgcp.estpcf, lgcp.estK
   Adjusted to new structure of RandomFields package.
   No change in syntax.

   o data(murchison)
   This dataset now belongs to class 'listof' so that it can be
   plotted directly.

   o data(clmfires)
   The format of the covariate data has changed.
   The objects 'clmcov100' and 'clmcov200' are now 
   elements of a list 'clmfires.extra'.

   o bounding.box
   This function is now Deprecated; it has been replaced 
   by the generic boundingbox().

   o as.psp.owin 
   This function is now Deprecated; it has been replaced 
   and extended by the function edges().

   o plot.kstest
   Changed defaults so that the two curves are distinguishable.

   o with.fv
   Improved mathematical labels.

BUG FIXES

   o intensity.quadratcount
   Values were incorrect for a rectangular tessellation
   (the matrix of intensities was transposed).
   Fixed.

   o rmh, simulate.ppm
   Simulation of the Strauss-hard core model (StraussHard) was incorrect
   (intensity of the simulated process was about 15% too low).
   Bug introduced in spatstat 1.31-0 (January 2013).

   o intensity.quadratcount
   Crashed for a rectangular tessellation with only a single row or column.
   Fixed.
   
   o model.images.ppm
   Crashed sometimes if the argument W was given.
   Fixed.

   o eval.im
   Crashed when applied to images with only a single row or column.
   Fixed.

   o ppp, marks<-.ppp
   If the marks were a vector of dates, they were erroneously 
   converted to numbers.
   Fixed.

   o ippm
   Crashed if the model formula included an offset term
   that was not a function.
   Fixed.

   o leverage.ppm
   Crashed sometimes when the model had irregular parameters ('covfunargs').
   Fixed.

   o residuals.ppm
   Crashed sometimes when type='score'.
   Fixed.

   o scaletointerval
   Did not handle dates and date-time values correctly.
   Fixed.

   o rbind.hyperframe, as.list.hyperframe
   Gave incorrect results for hyperframes with 1 row.
   Fixed.

   o Kinhom
   Did not renormalise the result (even when renormalise=TRUE), in some cases.
   Spotted by Peter Forbes.
   Fixed.

   o disc
   If mask=TRUE the disc was erroneously clipped to the square [-1,1] x [-1,1].
   Fixed.

   o plot.fv
   Sometimes shaded the wrong half of the graph 
   when the 'shade' coordinates were infinite.
   Fixed.

   o print.ppm
   Gave an error message if the coefficient vector had length zero.
   Fixed.

   o vcov.ppm
   Gave an error message if the coefficient vector had length zero.
   Fixed.

   o plot.distfun, as.im.distfun
   These functions effectively ignored the argument 'invert' 
   in the original call to distfun.
   Fixed.

   o plot.msr
   Ignored certain additional arguments such as 'pch'.
   Fixed.

   o cut.im
   Crashed if the image had 1 row or 1 column of pixels.
   Fixed.

   o iplot.ppp
   Crashed with message about missing object 'vals'.
   Fixed.

   o effectfun
   Demanded a value for every covariate supplied in the original call to ppm, 
   even for covariates which were not used in the model.
   Fixed.

   o plot.listof, plot.hyperframe
   When plotting 3D point patterns (class pp3), these functions
   issued warnings about 'add' being an unrecognised graphics argument.
   Fixed.

	CHANGES IN spatstat VERSION 1.36-0

OVERVIEW

   o We thank Sebastian Meyer, Kevin Ummer, Jean-Francois Coeurjolly,
   Ege Rubak, Rasmus Waagepetersen, Oscar Garcia and Sourav Das
   for contributions.

   o Important change to package dependencies.

   o Geometrical inconsistencies in polygons are now repaired automatically.

   o Improved quadrature schemes and reduced bias in ppm.

   o New vignette 'Summary of Recent Changes to Spatstat'.

   o Approximation to K function and pcf for Gibbs models.

   o Counterpart of 'apply' for lists of images.

   o Hexagonal grids and tessellations.

   o Extensions to scan test and Allard-Fraley cluster set estimator.

   o Change the parameters of a fitted model before simulating it.

   o Accelerated Kest, Kinhom for rectangular windows.

   o Extensions and improvements to plotting functions.

   o Improvements to labelling of 'fv' objects.

   o New demo of summary functions.

   o More methods for 'intensity'.

   o Version nickname: 'Intense Scrutiny'

NEW FUNCTIONS

   o Kmodel.ppm, pcfmodel.ppm
   Compute approximation to K-function or pair correlation function
   of a Gibbs point process model.

   o im.apply
   Apply a function to corresponding pixel values in several images.

   o hexgrid, hextess
   Create a hexagonal grid of points, or a tessellation of hexagonal tiles

   o shift.tess, rotate.tess, reflect.tess, scalardilate.tess, affine.tess
   Apply a geometrical transformation to a tessellation.

   o quantile.ewcdf
   Extract quantiles from a weighted cumulative distribution function.

   o scanLRTS
   Evaluate the spatially-varying test statistic for the scan test.

   o pcfmulti
   General multitype pair correlation function

   o intensity.splitppp
   Estimate intensity in each component of a split point pattern.

   o intensity.quadratcount
   Use quadrat counts to estimate intensity in each quadrat.

   o as.owin.quadratcount, as.owin.quadrattest
   Extract the spatial window in which quadrat counts were performed.

   o reload.or.compute
   Utility function for R scripts: 
   either reload results from file, or compute them.

   o to.grey
   Convert colour to greyscale.

   o Smooth.im
   Method for Smooth() for pixel images. Currently identical to blur().

   o demo(sumfun)
   Demonstration of nonparametric summary functions in spatstat.

SIGNIFICANT USER-VISIBLE CHANGES

   o Package Dependencies
   spatstat now "Imports" (rather than "Depends" on) 
   the libraries mgcv, deldir, abind, tensor, polyclip.
   This means that these libraries are not accessible to the user
   unless the user explicitly loads them by typing 'library(mgcv)' and so on.

   o owin, as.owin
   Polygon data are no longer subjected to strict checks on 
   geometrical validity (self-crossing points, overlaps etc.)
   Instead, polygon geometry is automatically repaired.
   
   o ppm
   The default quadrature scheme for a point pattern
   has been improved (in the case of a non-rectangular window)
   to remove a possible source of bias.

   o Performance 
   various parts of spatstat now run slightly faster.

   o scan.test 
   Now handles multiple values of circle radius 'r'.

   o plot.scan.test, as.im.scan.test
   These functions can now give the optimal value of circle radius 'r'.

   o pcfcross, pcfdot
   Algorithms have been reimplemented using a single-pass kernel smoother
   and now run much faster. Bandwidth selection rule improved.

   o plot.listof, plot.splitppp
   Default behaviour has changed: panels are now plotted on different scales. 

   o plot.listof, plot.splitppp
   When 'equal.scales=TRUE' the panels are plotted on exactly equal scales
   and are exactly aligned (under certain conditions).

   o ppp, marks.ppp, marks<-.ppp
   New argument 'drop' determines whether a data frame with a single column
   will be converted to a vector.

   o simulate.ppm, rmh.ppm, rmhmodel.ppm
   New argument 'new.coef' allows the user to change the parameters
   of a fitted model, before it is simulated.

   o logLik.ppm
   New argument 'new.coef' allows the user to evaluate the 
   loglikelihood for a different value of the parameter.

   o clusterset
   The argument 'result' has been renamed 'what'.
   It is now possible to give multiple values to 'what'
   so that both types of result can be computed together.

   o residuals.ppm
   Argument 'coefs' has been renamed 'new.coef' for consistency
   with fitted.ppm etc. 

   o residuals.ppm
   If drop=TRUE the window associated with the residuals
   is now taken to be the domain of integration of the composite likelihood.
   
   o intensity.ppp
   Now has argument 'weights'

   o density.ppp, Smooth.ppp, markmean, markvar, intensity.ppp
   Argument 'weights' can now be an 'expression'.

   o pcf
   New argument 'domain' causes the computation to be restricted to 
   a subset of the window.

   o nnclean
   The result now has attributes which give the fitted parameter values,
   information about the fitting procedure, and the histogram bar heights.

   o nnclean
   Extra arguments are now passed to hist.default.

   o plot.tess
   For a tessellation represented by a pixel image, 
   plot.tess no longer treats the pixel labels as palette colours.

   o relrisk
   New argument 'case' allows the user to specify which mark value
   corresponds to the cases in a case-control dataset.

   o Kinhom
   Now accepts correction="good" 

   o spatstat.options
   New option ('monochrome') controls whether plots generated by spatstat
   will be displayed in colour or in greyscale. This will eventually be
   applied to all plot commands in spatstat. 

   o plot.im, persp.im, contour.im, plot.owin, plot.psp, plot.fv, plot.fasp
   These functions now obey spatstat.options('monochrome')

   o plot.ppp, plot.owin, plot.im, plot.psp, plot.tess, plot.layered
   New universal argument 'show.all' determines what happens
   when a plot is added to an existing plot. If show.all = TRUE
   then everything is plotted, including the main title and colour ribbon.

   o plot.ppp
   New argument 'show.window' 

   o plot.im 
   New arguments 'add' and 'do.plot'.
   More arguments recognised by 'ribargs'

   o plot.layered
   New arguments 'add', 'main' 
   Better argument handling.

   o plot.fv
   Improved handling of argument 'shade'

   o layered, layerplotargs, plot.layered
   The plotting argument can now be a list of length 1,
   which will be replicated to the correct length.

   o varblock
   Ugly legends have been repaired.

   o quad.ppm
   New argument 'clip'

   o edge.Trans
   New arguments 'dx', 'dy'

   o disc
   Argument 'centre' can be in various formats.

   o affine, shift
   Argument 'vec' can be in various formats.

   o Geyer, BadGey
   A warning is no longer issued when the parameter 'sat' is fractional.

   o adaptive.density
   Now has argument 'verbose'

   o Smooth.ppp
   'sigma' is now a formal argument of Smooth.ppp

   o plot.quadratcount, plot.quadrattest
   These functions have now been documented.

   o Summary functions and envelopes
   Improved mathematical labels in plots.

   o Kest
   Accelerated, in the case of a rectangular window.

   o Kscaled
   Argument 'lambda' can now be a fitted model (class ppm)

   o print.fv
   Improved layout.

   o plot.bermantest
   Improved graphics.

   o which.max.im
   This function is now deprecated.
   which.max.im(x) is superseded by im.apply(x, which.max)

   o smooth.ppp, smooth.fv, smooth.msr
   These functions are now deprecated, in favour of 'Smooth' with a capital 'S'

BUG FIXES

   o bw.ppl
   Crashed if the point pattern had multiple points at the same location.
   Fixed.

   o quantile
   Crashed when applied to the result of 'ewcdf'.
   Fixed.

   o marks<-.ppp
   Crashed with a message about 'unrecognised format'
   if the current or replacement values of marks
   were date/time values (belonging to class 'Date' or 'POSIXt').
   Fixed.

   o plot.im
   Crashed in case log=TRUE if the window was not a rectangle.
   Fixed.

   o vcov.ppm
   Crashed sometimes for models with a hard core term
   (Hardcore, StraussHard, MultiHard or MultiStrauss interactions).
   Spotted by Rasmus Waagepetersen.
   Fixed.

   o multiplicity.data.frame
   Results were incorrect and included NA's (spotted by Sebastian Meyer).
   Fixed.

   o markvar
   Values were incorrect.
   Fixed.

   o Smooth.ppp
   Ignored argument 'diggle'.
   Fixed.

   o rotate.im, affine.im
   Factor-valued images were not handled correctly.
   Fixed.

   o shift.layered
   If argument 'origin' was used, different layers were shifted by 
   different amounts.
   Fixed.

   o tile.areas
   Sometimes returned a list instead of a numeric vector.
   Fixed.

   o print.ppp
   If the marks were date/time values (belonging to class 'Date' or 'POSIXt'),
   print.ppp reported that they were double precision numbers.
   Fixed.

   o plot.layered
   Graphics were mangled if the argument 'add=FALSE' was given explicitly.
   Fixed.

   o Smooth.ppp
   The argument 'sigma' was only recognised if it was explicitly named.
   For example in 'Smooth(X, 5)' the '5' was ignored.
   Fixed.

   o clusterset
   The bounding frame of the result was smaller than the
   original bounding frame of the point pattern dataset,
   when result="domain" and exact=TRUE.
   Fixed.

   o plot.im
   Ignored argument 'col' if it was a 'function(n)'.
   Fixed.

   o Kinhom
   Ignored argument 'correction' if there were more than 1000 points.
   Fixed.

   o [.fv
   Mangled the plot label for the y axis.
   Fixed.

   o cbind.fv
   Mangled the plot label for the y axis.
   Fixed.

   o plot.envelope
   Main title was always 'x'.
   Fixed.

   o print.ppp
   Ran over the right margin.
   Fixed.

   o union.owin, intersect.owin, setminus.owin
   Sometimes deleted the name of the unit of length.
   Fixed.

	CHANGES IN spatstat VERSION 1.35-0

OVERVIEW

   o We thank Melanie Bell, Leanne Bischof, Ida-Maria Sintorn,
     Ege Rubak, Martin Hazelton, Oscar Garcia, 
     Rasmus Waagepetersen, Abdollah Jalilian
     and Jens Oehlschlaegel for contributions.

   o Support for analysing replicated spatial point patterns.

   o New vignette on analysing replicated spatial point patterns.

   o Objective function surface plots.

   o Estimator of point process intensity using nearest neighbour distances.

   o Improved estimator of pair correlation function.

   o Four new datasets. 

   o Simple point-and-click interface functions for general use.

   o More support for fv objects.

   o More support for ppx objects.

   o Extensions to nearest neighbour functions.

   o Morphological operations accelerated.

   o Bug fix to pair correlation functions.

   o Bug fix to k-th nearest neighbour distances

   o Version nickname: 'Multiple Personality'

NEW CLASSES

  o mppm
  An object of class 'mppm' represents a Gibbs point process model
  fitted to several point pattern datasets. The point patterns may
  be treated as independent replicates of the same point process,
  or as the responses in an experimental design, so that the 
  model may depend on covariates associated with the design.
  Methods for this class include print, plot, predict, anova and so on.

  o objsurf
  An object of class 'objsurf' contains values of the likelihood 
  or objective function in a neighbourhood of the maximum.

  o simplepanel
  An object of class 'simplepanel' represents a spatial arrangement of buttons
  that respond to mouse clicks, supporting a simple, robust graphical interface.
  
NEW FUNCTIONS

  o mppm
  Fit a Gibbs model to several point patterns.
  The point pattern data may be organised as a designed experiment
  and the model may depend on covariates associated with the design.

  o anova.mppm
  Analysis of Deviance for models of class mppm

  o coef.mppm
  Extract fitted coefficients from a model of class mppm

  o fitted.mppm
  Fitted intensity or conditional intensity for a model of class mppm

  o kstest.mppm
  Kolmogorov-Smirnov test of goodness-of-fit for a model of class mppm

  o logLik.mppm
  log likelihood or log pseudolikelihood for a model of class mppm

  o plot.mppm
  Plot the fitted  intensity or conditional intensity of a model of class mppm

  o predict.mppm
  Compute the fitted  intensity or conditional intensity 
  of a model of class mppm

  o quadrat.test
  Quadrat counting test of goodness-of-fit for a model of class mppm

  o residuals.mppm
  Point process residuals for a model of class mppm

  o subfits
  Extract point process models for each individual point pattern dataset,
  from a model of class mppm

  o vcov.mppm
  Variance-covariance matrix for a model of class mppm

  o integral.msr
  Integral of a measure.

  o objsurf
  For a model fitted by optimising an objective function, this command
  computes the objective function in a neighbourhood of the optimal value.

  o contour.objsurf, image.objsurf, persp.objsurf, plot.objsurf
  Plot an 'objsurf' object.

  o fvnames
  Define groups of columns in a function value table, for use in plot.fv, etc

  o multiplicity
  New generic function for which multiplicity.ppp is a method.

  o unique.ppx, duplicated.ppx, multiplicity.ppx
  Methods for unique(), duplicated() and multiplicity() for 'ppx' objects.
  These also work for 'pp3' and 'lpp' objects.

  o closepairs, crosspairs, closepaircounts, crosspaircounts
  Low-level functions for finding all close pairs of points 

  o nndensity 
  Estimate point process intensity using k-th nearest neighbour distances

  o simplepanel, run.simplepanel
  Support for a simple point-and-click interface for general use.

NEW DATASETS

   o pyramidal
   Diggle-Lange-Benes data on pyramidal neurons in cingulate cortex.
   31 point patterns divided into 3 groups.
   
   o waterstriders
   Nummelin-Penttinen waterstriders data.
   Three independent replicates of a point pattern formed by insects.

   o simba
   Simulated data example for mppm.
   Two groups of point patterns with different interpoint interactions.

   o demohyper
   Simulated data example for mppm.
   Point patterns and pixel image covariates, in two groups
   with different regression coefficients.

SIGNIFICANT USER-VISIBLE CHANGES

   o plot.hyperframe
   The argument 'e' now has a different format.
   Instead of plot(h, plot(XYZ)) one must now type plot(h, quote(plot(XYZ)))
   This is necessary in order to avoid problems with 'S4 method dispatch'.
   
   o pcf.ppp, pcfinhom
   New argument 'divisor' enables better performance of the estimator
   of pair correlation function for distances close to zero.
   
   o applynbd
   The arguments N, R and criterion may now be specified together.

   o markstat
   The arguments N and R may now be specified together.

   o ppx
   New argument 'simplify' allows the result to be converted to
   an object of class 'ppp' or 'pp3' if appropriate.

   o as.function.fv
   Now allows multiple columns to be interpolated

   o multiplicity.ppp
   This function is now a method for the generic 'multiplicity'.
   It has also been accelerated.

   o nnfun.ppp, distfun.ppp
   New argument 'k' allows these functions to compute k-th nearest neighbours.

   o rVarGamma, kppm, vargamma.estK, vargamma.estpcf
   New argument 'nu.pcf' provides an alternative way to specify
   the kernel shape in the VarGamma model, instead of the existing
   argument 'nu.ker'. Function calls that use the ambiguous argument
   name 'nu' will no longer be accepted.

   o nnmap
   Image is now clipped to the original window.

   o dilation, erosion, opening, closing
   Polygonal computations greatly accelerated.

   o plot.colourmap
   Improved appearance and increased options, for discrete colourmaps.

   o plot.msr
   Improved appearance

   o plot.ppp, plot.owin
   An `empty' plot can now be generated by setting type="n"

   o nndist.ppp, nnwhich.ppp, nncross.ppp
   Column names of the result are now more informative.

BUG FIXES

   o nncross.ppp
   Results were completely incorrect when k > 1.
   Spotted by Jens Oehschlaegel. 
   Bug was introduced in spatstat 1.34-1. 
   Fixed.

   o rVarGamma
   Simulations were incorrect; they were generated using the wrong value
   of the parameter 'nu.ker'. Spotted by Rasmus Waagepetersen and
   Abdollah Jalilian. Bug was always present.		    
   Fixed.
   
   o pair correlation functions (pcf.ppp, pcfdot, pcfcross, pcfinhom, ...)
   The result had a negative bias at the maximum 'r' value,
   because contributions to the pcf estimate from interpoint distances
   greater than max(r) were mistakenly omitted. 
   Spotted by Rasmus Waagepetersen and Abdollah Jalilian. 
   Bug was always present.
   Fixed.

   o demo(spatstat)
   This demonstration script had some unwanted side-effects, such as
   rescaling the coordinates of standard datasets 'bramblecanes', 
   'amacrine' and 'demopat', which caused the demonstration to crash 
   when it was repeated several times, and caused errors in demo(data).
   Fixed.

   o rmh
   Visual debugger crashed sometimes with message 'XI not found'.
   Fixed.

   o predict.ppm
   Crashed if the model was fitted using 'covfunargs'.
   Fixed.

   o bounding.box
   Crashed if one of the arguments was NULL.
   Fixed.

   o multiplicity.ppp
   Did not handle data frames of marks. 
   Fixed.

	CHANGES IN spatstat VERSION 1.34-1

OVERVIEW

   o We thank Kurt Hornik, Ted Rosenbaum, Ege Rubak and Achim Zeileis
    for contributions.

   o Important bug fix.

SIGNIFICANT USER-VISIBLE CHANGES

   o as.box3
   Now accepts objects of class 'ppx' or 'boxx'.

   o crossdist.ppp, crossdist.pp3, crossdist.default
   New argument 'squared' allows the squared distances to be computed
   (saving computation time in some applications)

BUG FIXES

   o union.owin, is.subset.owin, dilation.owin
   Results were sometimes completely wrong for polygons with holes.
   Spotted by Ted Rosenbaum.
   Fixed.

   o psstA, areaLoss
   Crashed in some cases, with error message
   'Number of items to replace is not a multiple of replacement length'. 
   Spotted by Achim Zeileis.
   Fixed.

	CHANGES IN spatstat VERSION 1.34-0

OVERVIEW

   o We thank Andrew Bevan, Ege Rubak, Aruna Jammalamadaka, 
   Greg McSwiggan, Jeff Marcus, Jose M Blanco Moreno,
   and Brian Ripley for contributions.

   o spatstat and all its dependencies are now Free Open Source.

   o spatstat does not require the package 'gpclib' any more.
   
   o spatstat now depends on the packages 'tensor', 'abind' and 'polyclip'

   o polygon clipping is now enabled always.

   o Substantially more support for point patterns on linear networks.

   o Faster computations for pairwise interaction models.

   o Bug fixes in nearest neighbour calculations.

   o Bug fix in leverage and influence diagnostics.

   o Version nickname: "Window Cleaner"

   o spatstat now requires R version 3.0.2 or later

NEW FUNCTIONS

   o as.lpp
   Convert data to a point pattern on a linear network.

   o distfun.lpp
   Distance function for point pattern on a linear network.

   o eval.linim
   Evaluate expression involving pixel images on a linear network.

   o linearKcross, linearKdot, linearKcross.inhom, linearKdot.inhom
   Multitype K functions for point patterns on a linear network

   o linearmarkconnect, linearmarkequal
   Mark connection function and mark equality function 
   for multitype point patterns on a linear network

   o linearpcfcross, linearpcfdot, linearpcfcross.inhom, linearpcfdot.inhom
   Multitype pair correlation functions for point patterns on a linear network

   o linfun
   New class of functions defined on a linear network

   o nndist.lpp, nnwhich.lpp, nncross.lpp
   Methods for nndist, nnwhich, nncross for point patterns on a linear network

   o nnfun.lpp
   Method for nnfun for point patterns on a linear network

   o vcov.lppm
   Variance-covariance matrix for parameter estimates of a fitted
   point process model on a linear network.

   o bilinearform
   Computes a bilinear form 

   o tilenames, tilenames<-
   Extract or change the names of tiles in a tessellation.

SIGNIFICANT USER-VISIBLE CHANGES

   o package dependencies 
   Previous versions of spatstat used the package 'gpclib' 
   to perform geometrical calculations on polygons.
   Spatstat now uses the package 'polyclip' for polygon calculations instead.

   o free open-source licence
   The restrictive licence conditions of 'gpclib' no longer apply 
   to users of spatstat. Spatstat and all its dependencies are now
   covered by a free open-source licence.

   o polygon clipping
   In previous versions of spatstat, geometrical calculations
   on polygons could be performed 'exactly' using gpclib
   or 'approximately' using pixel discretisation. 
   Polygon calculations are now always performed 'exactly'.
   
   o intersect.owin, union.owin, setminus.owin
   If A and B are polygons, the result is a polygon.

   o erosion, dilation, opening, closing
   If the original set is a polygon, the result is a polygon.

   o intersect.tess, dirichlet
   The tiles of the resulting tessellation are polygons 
   if the input was polygonal.

   o plot.owin
   Polygons with holes can now be plotted with filled colours
   on any device.

   o lppm
   New arguments 'eps' and 'nd' control the quadrature scheme.

   o pairwise interaction Gibbs models
   Many calculations for these models have been accelerated.

BUG FIXES

   o nncross.pp3
   Values were completely incorrect in some cases.
   Usually accompanied by a warning about NA values.
   (Spotted by Andrew Bevan.)
   Fixed.

   o nnmap, nnmark
   A small proportion of pixels had incorrect values.
   [These were the pixels lying on the boundary of a Dirichlet cell.]
   Fixed. 

   o leverage.ppm, influence.ppm, dfbetas.ppm
   Results were incorrect for non-Poisson processes.
   Fixed.

   o distcdf
   Results were incorrect in some cases
   when W was a window and V was a point pattern.
   Fixed.

   o Kcross, Kdot, pcfcross, pcfdot
   Results were incorrect in some rare cases.
   Fixed.

   o as.fv.kppm
   Erroneously returned a NULL value.
   Fixed.

   o vcov.ppm
   For point process models fitted with method = 'logi',
   sometimes crashed with error "object 'fit' not found".
   (Spotted by Ege Rubak).
   Fixed.

   o vcov.ppm
   For multitype point process models, sometimes crashed
   with error "argument 'par' is missing".
   Fixed.

   o plot.im
   Crashed if some of the pixel values were infinite.
   Fixed.

   o owin 
   owin(poly=..) crashed if there were NA's in the polygon coordinates.
   Spotted by Jeff Marcus.
   Fixed.

   o plot.fv
   Crashed, giving an incomprehensible error,
   if the plot formula contained a number with a decimal point.
   Fixed.

   o alltypes
   Crashed if envelopes=TRUE and global=TRUE, 
   with error message 'csr.theo not found'.
   Spotted by Jose M Blanco Moreno.
   Fixed.

   o chop.tess, rMosaicField
   Format of result was garbled in some cases.
   Fixed.

   o vcov.ppm
   Sometimes gave an irrelevant warning "parallel option not available".
   Fixed.

	CHANGES IN spatstat VERSION 1.33-0

OVERVIEW

   o We thank Kurt Hornik and Brian Ripley for advice.

   o The package namespace has been modified.

   o Numerous internal changes.

   o Likelihood cross-validation for smoothing bandwidth.

   o More flexible models of intensity in cluster/Cox processes.

   o New generic function for smoothing.

   o Version nickname: 'Titanic Deckchair'

NEW FUNCTIONS

    o bw.ppl
    Likelihood cross-validation technique 
    for bandwidth selection in kernel smoothing.

    o is.lppm, is.kppm, is.slrm
    Tests whether an object is of class 'lppm', 'kppm' or 'slrm'

    o Smooth
    New generic function for spatial smoothing.

    o Smooth.ppp, Smooth.fv, Smooth.msr
    Methods for Smooth
    (identical to smooth.ppp, smooth.fv, smooth.msr respectively)

    o fitted.kppm
    Method for 'fitted' for cluster/Cox models

SIGNIFICANT USER-VISIBLE CHANGES

    o namespace
    The namespace of the spatstat package has been changed.

    o internal functions
    Some undocumented internal functions are no longer visible,
    as they are no longer exported in the namespace. These functions
    can still be accessed using the form spatstat:::functionname.
    Functions that are not visible are not guaranteed to exist 
    or to remain the same in future. 

    o methods
    For some generic functions defined in the spatstat package,
    it is possible that R may fail to find one of the methods
    for the generic. This is a temporary problem due to a restriction
    on the size of the namespace in R 3.0.1. It will be fixed in 
    future versions of R and spatstat. It only applies to methods
    for a generic which is a spatstat function (such as nndist)
    and does not apply to methods for generics defined elsewhere
    (such as density). In the meantime, if this problem should occur, 
    it can be avoided by calling the method explicitly, in the form
    spatstat:::genericname.classname.

    o speed
    The package should run slightly faster overall, due to the
    improvement of the namespace, and changes to internal code.

    o envelope
    New argument 'envir.simul' determines the environment
    in which to evaluate the expression 'simulate'.

    o kppm
    More flexible models of the intensity, and greater control over the
    intensity fitting procedure, are now possible using the arguments
    'covfunargs', 'use.gam', 'nd', 'eps' passed to ppm.
    Also the argument 'X' may now be a quadrature scheme.

    o distcdf
    Arguments W and V can now be point patterns.

    o Kest
    New option: correction = "good" 
    selects the best edge correction that can be computed in reasonable time.

    o bw.diggle
    Accelerated.

    o predict.ppm
    Calculation of standard error has been accelerated.

    o smooth.ppp, smooth.fv, smooth.msr
    These functions will soon be 'Deprecated' in favour of
    the methods Smooth.ppp, Smooth.fv, Smooth.msr respectively.

    o stratrand, overlap.owin, update.slrm, edge.Trans, edge.Ripley
    These already-existing functions are now documented.

BUG FIXES

    o kppm, matclust.estpcf, pcfmodel
    The pair correlation function of the Matern Cluster Process
    was evaluated incorrectly at distances close to 0.
    This could have affected the fitted parameters 
    in matclust.estpcf() or kppm(clusters="MatClust").
    Fixed.

    o anova.ppm
    Would cause an error in future versions of R
    when 'anova.glm' is removed from the namespace.
    Fixed.

	CHANGES IN spatstat VERSION 1.32-0

OVERVIEW

   o We thank Ege Rubak for major contributions.

   o Thanks also to Patrick Donnelly, Andrew Hardegen,
     Tom Lawrence, Robin Milne, Gopalan Nair and Sean O'Riordan.

   o New 'logistic likelihood' method for fitting Gibbs models.

   o Substantial acceleration of several functions
     including profile maximum pseudolikelihood
     and variance calculations for Gibbs models.

   o Nearest neighbours for point patterns in 3D

   o Nearest-neighbour interpolation in 2D

   o New 'progress plots' 

   o Hard core thresholds can be estimated automatically.

   o More support for colour maps

   o More support for 'fv' objects

   o Spatstat now has version nicknames.
   The current version is "Logistical Nightmare".
 
   o Minor improvements and bug fixes.

NEW FUNCTIONS

   o nncross.pp3
   Method for 'nncross' for point patterns in 3D

   o nnmark
   Mark of nearest neighbour - can be used for interpolation

   o dclf.progress, mad.progress
   Progress plots (envelope representations) for the DCLF and MAD tests.

   o deriv.fv
   Numerical differentiation for 'fv' objects.

   o interp.colourmap
   Smooth interpolation of colour map objects - makes it easy to build
   colour maps with gradual changes in colour

   o tweak.colourmap
   Change individual colour values in a colour map object

   o beachcolourmap
   Colour scheme appropriate for `altitudes' (signed numerical values)

   o as.fv
   Convert various kinds of data to an 'fv' object

   o quadscheme.logi
   Generates quadrature schemes for the logistic method of ppm.

   o beginner
   Introduction for beginners.

SIGNIFICANT USER-VISIBLE CHANGES

   o ppm
   New option: method = "logi" 
   Fits a Gibbs model by the newly developed 'logistic likelihood' method
   which is often faster and more accurate than maximum pseudolikelihood.
   Code contributed by Ege Rubak.
   
   o profilepl
   Greatly accelerated, especially for area-interaction models.

   o vcov.ppm
   Greatly accelerated for higher-order interaction models.

   o smooth.ppp
   Now handles bandwidths equal to zero (by invoking 'nnmark')

   o Hardcore, StraussHard
   The hard core distance 'hc' can now be omitted; 
   it will be estimated from data.

   o plot.ppp
   Now behaves differently if there are multiple columns of marks.
   Each column of marks is plotted, in a series of separate plots
   arranged side-by-side.

   o plot.im
   Argument 'col' can now be a function

   o lohboot
   Now computes confidence intervals for L-functions as well
   (fun="Lest" or fun="Linhom")

   o dclf.test, mad.test
   The argument X can now be an object produced by a previous call
   to dclf.test or mad.

   o plot.fv
   Labelling of plots has been improved in some cases.

   o smooth.fv
   Further options added.

   o density.ppp
   The argument 'weights' can now be a matrix.

   o smooth.ppp
   Accelerated, when there are several columns of marks.

   o density.ppp
   Accelerated slightly.

   o simulate.ppm, simulate.kppm
   The total computation time is also returned.

   o simulate.kppm
   Now catches errors (such as 'insufficient memory').
   
   o latest.news, licence.polygons
   Can now be executed by typing the name of the function without parentheses.

   o latest.news
   The text is now displayed one page at a time.

BUG FIXES

   o Hest, Gfox, Jfox
   The 'raw' estimate was not computed correctly (or at least 
   it was not the raw estimate described in the help files).
   Spotted by Tom Lawrence.
   Fixed.

   o edges2vees
   Format of result was incorrect if there were fewer than 3 edges.
   Fixed.

   o Jfox
   The theoretical value (corresponding to independence between X and Y)
   was erroneously given as 0 instead of 1.
   Spotted by Patrick Donnelly.
   Fixed.

   o ppm, quadscheme, default.dummy 
   If the grid spacing parameter 'eps' was specified,
   the quadrature scheme was sometimes slightly incorrect
   (missing a few dummy points near the window boundary).
   Fixed.

   o print.timed
   Matrices were printed incorrectly.
   Fixed.

	CHANGES IN spatstat VERSION 1.31-3

OVERVIEW

   o spatstat now 'Suggests' the package 'tensor'

   o Code slightly accelerated.

   o More support for pooling of envelopes.

   o Bug fixes.

NEW FUNCTIONS

   o nnmap
   Given a point pattern, finds the k-th nearest point in the pattern
   from each pixel in a raster.

   o coef.fii, coef.summary.fii
   Extract the interaction coefficients of a fitted interpoint interaction

   o edges2vees
   Low-level function for finding triples in a graph.


SIGNIFICANT USER-VISIBLE CHANGES

   o predict.ppm
   New argument 'correction' allows choice of edge correction
   when calculating the conditional intensity.

   o pool.envelope
   New arguments 'savefuns' and 'savepatterns'.

   o pool.envelope
   Envelopes generated with VARIANCE=TRUE can now be pooled.

   o pool.envelope
   The plot settings of the input data are now respected.

   o Numerous functions have been slightly accelerated.

BUG FIXES

   o predict.ppm
   Calculation of the conditional intensity omitted the edge correction
   if correction='translate' or correction='periodic'.
   Fixed.

   o shift.lpp, rotate.lpp, scalardilate.lpp, affine.lpp,
    shift.linnet, rotate.linnet, scalardilate.linnet, affine.linnet
   The enclosing window was not correctly transformed. 
   Fixed.

   o rHardcore, rStraussHard, rDiggleGratton, rDGS
   The return value was invisible.
   Fixed.

   o ppm
   In rare cases the results obtained with forcefit=FALSE and forcefit=TRUE
   were different, due to numerical rounding effects.
   Fixed.

	CHANGES IN spatstat VERSION 1.31-2

OVERVIEW

   o We thank Robin Corria Anslie, Julian Gilbey, Kiran Marchikanti,
   Ege Rubak and Thordis Linda Thorarinsdottir for contributions.

   o spatstat now depends on R 3.0.0

   o More support for linear networks

   o More functionality for nearest neighbours

   o Bug fix in fitting Geyer model

   o Performance improvements and bug fixes

NEW FUNCTIONS

   o affine.lpp, shift.lpp, rotate.lpp, rescale.lpp, scalardilate.lpp
   Geometrical transformations for point patterns on a linear network

   o affine.linnet, shift.linnet, rotate.linnet, 
   rescale.linnet, scalardilate.linnet
   Geometrical transformations for linear networks

   o [.linnet
   Subset operator for linear networks

   o timed
   Records the computation time taken
   
SIGNIFICANT USER-VISIBLE CHANGES

   o nncross
   nncross.ppp can now find the k-th nearest neighbours, for any k.

   o nndist, nnwhich
   New argument 'by' makes it possible to find nearest neighbours
   belonging to specified subsets in a point pattern, for example,
   the nearest neighbour of each type in a multitype point pattern.

   o [.fv
   Now handles the argument 'drop'.

   o with.fv
   Argument 'drop' replaced by new argument 'fun'
   (with different interpretation).

   o [.lpp
   Subset index may now be a window (class 'owin')

   o Kest
   Options correction='border' and correction='none'
   now run about 4 times faster, thanks to Julian Gilbey.

   o density.ppp
   Numerical underflow no longer occurs when sigma is very small
   and 'at="points"'. A warning is no longer issued.
   Thanks to Robin Corria Anslie.

   o crossing.psp
   New argument 'fatal' allows the user to handle empty intersections

   o union.owin
   It is now guaranteed that if A is a subset of B, then union.owin(A,B)=B.

   o plot.colourmap
   Now passes arguments to axis() to control the plot.
   Appearance of plot improved.

   o image.listof
   Now passes arguments to plot.colourmap() if equal.ribbon=TRUE.

   o kppm
   Accelerated (especially for large datasets).

   o plot.envelope
   plot.envelope is now equivalent to plot.fv and is essentially redundant.

   o rThomas, rMatClust, rNeymanScott
   Improved explanations in help files.

   o All functions
   Many functions have been slightly accelerated.

BUG FIXES

   o ppm
   Results were incorrect for the Geyer saturation model
   with a non-integer value of the saturation parameter 'sat'.
   Spotted by Thordis Linda Thorarinsdottir.
   Bug introduced in spatstat 1.20-0, July 2010.
   Fixed.

   o ppm
   Fitting a stationary Poisson process using a nonzero value of 'rbord',
   as in "ppm(X, rbord=R)" with R > 0, gave incorrect results.
   Fixed.

   o predict.slrm
   Crashed with message 
   'longer object length is not a multiple of shorter object length' 
   if the original data window was not a rectangle.
   Fixed.

   o iplot
   Main title was sometimes incorrect.
   Fixed.

   o plot.layered
   Ignored argument 'main' in some cases.
   Fixed.

   o plot.listof, image.listof
   Crashed sometimes with a message 'figure margins too large'
   when equal.ribbon=TRUE.
   Fixed.

   o print.ppx
   Crashed if the object contained local coordinates.
   Fixed.

   o transect.im
   Crashed if the transect lay partially outside the image domain.
   Fixed.

   o rthin
   Crashed if X was empty.
   Fixed.

   o max.im, min.im, range.im
   Ignored additional arguments after the first argument.
   Fixed.

   o update.lppm
   Updated object did not remember the name of the original dataset.
   Fixed.

   o envelope
   Grey shading disappeared from plots of envelope objects 
   when the envelopes were transformed using eval.fv or eval.fasp.
   Fixed.

   
	CHANGES IN spatstat VERSION 1.31-1

OVERVIEW

   o We thank Marcelino de la Cruz, Daniel Esser, Jason Goldstick,
     Abdollah Jalilian, Ege Rubak and Fabrice Vinatier for contributions.

   o Nonparametric estimation and tests for 
     point patterns in a linear network.

   o More support for 'layered' objects.

   o Find clumps in a point pattern.

   o Connected component interaction model.

   o Improvements to interactive plots.

   o Visual debugger for Metropolis-Hastings algorithm.

   o Bug fix in Metropolis-Hastings simulation of Geyer process.

   o Faster Metropolis-Hastings simulation.

   o Faster computation of 'envelope', 'fv' and 'fasp' objects.

   o Improvements and bug fixes.

NEW FUNCTIONS

   o connected.ppp
   Find clumps in a point pattern.

   o kstest.lpp, kstest.lppm
   The spatial Kolmogorov-Smirnov test can now be applied 
   to point patterns on a linear network (class 'lpp') and 
   point processes on a linear network (class 'lppm').

   o bermantest.lpp, bermantest.lppm
   Berman's Z1 and Z2 tests can now be applied to point patterns
   on a linear network (class 'lpp') and point processes on a linear
   network (class 'lppm').

   o rhohat.lpp, rhohat.lppm
   Nonparametric estimation of the dependence of a point pattern
   on a spatial covariate: 'rhohat' now applies to 
   objects of class 'lpp' and 'lppm'.

   o intensity.lpp
   Empirical intensity of a point pattern on a linear network.

   o as.function.rhohat
   Converts a 'rhohat' object to a function,
   with extrapolation beyond the endpoints.

   o [.layered
   Subset operator for layered objects.

   o shift, rotate, affine, rescale, reflect, flipxy, scalardilate
   These geometrical transformations now work for 'layered' objects.

   o iplot.layered
   Interactive plotting for 'layered' objects.

   o as.owin.layered
   Method for as.owin for layered objects.

   o [.owin
   Subset operator for windows, equivalent to intersect.owin.

   o rcellnumber
   Generates random integers for the Baddeley-Silverman counterexample.

   o is.lpp
   Tests whether an object is a point pattern on a linear network.

   o is.stationary.lppm, is.poisson.lppm
   New methods for is.stationary and is.poisson for class 'lppm'

   o sessionLibs
   Print library names and version numbers (for use in Sweave scripts)

SIGNIFICANT USER-VISIBLE CHANGES

   o iplot
   iplot is now generic, with methods for 'ppp', 'layered' and 'default'.
   iplot methods now support zoom and pan navigation.

   o rmh.default
   New argument 'snoop' allows the user to activate a visual debugger
   for the Metropolis-Hastings algorithm.

   o connected
   connected() is now generic, with methods for 'im', 'owin' and 'ppp'.

   o alltypes
   Now works for lpp objects 

   o rlabel
   Now works for lpp, pp3, ppx objects

   o plot.kstest
   Can now perform P-P and Q-Q plots as well.

   o plot.fasp
   New argument 'samey' controls whether all panels 
   have the same y limits.

   o plot.fasp
   Changed default value of 'samex'.

   o Objects of class 'envelope', 'fv' and 'fasp' 
   Reduced computation time and storage required for these objects.
   
   o pcfmodel.kppm
   Improved calculation.

   o plot.fv
   Improved collision-avoidance algorithm
   (for avoiding overlaps between curves and legend)

   o ppm
   Improved error handling

   o envelope
   All methods for 'envelope' now handle fun=NULL   

   o setminus.owin
   Better handling of the case where both arguments are rectangles.

   o rmh
   Simulation has been further accelerated.

   o lppm
   Accelerated.

   o vcov.ppm
   Accelerated.

   o marktable
   Accelerated.

   o Triplets() interaction
   Accelerated.

   o alltypes
   Accelerated when envelope=TRUE.

BUG FIXES

   o rmh
   Simulation of the Geyer saturation process was incorrect.
   [Bug introduced in previous version, spatstat 1.31-0.]
   Fixed.

   o rmh
   Simulation of the Geyer saturation process was 
   incorrectly initialised, so that the results of a short run 
   (i.e. small value of 'nrep') were incorrect, 
   while long runs were correct.
   [Bug introduced in spatstat 1.17-0, october 2009.]
   Fixed.

   o ppm 
   Objects fitted with use.gam=TRUE caused fatal errors in
   various functions including print, summary, vcov and model.frame.
   Spotted by Jason Goldstick.
   Fixed.

   o lpp, runiflpp, rpoislpp
   Empty point patterns caused an error.
   Fixed.

   o rmh.default
   Crashed for hybrid models, with message 
   'Attempt to apply non-function'.
   Spotted by Ege Rubak.
   Fixed.

   o relrisk
   Crashed when 'at="points"' for a multitype pattern
   with more than 2 types.
   Spotted by Marcelino de la Cruz.
   Fixed.

   o erosion.owin, dilation.psp, border
   Ignored the arguments "..." in some cases
   (namely when the window was polygonal and 'gpclib' was disabled).
   Fixed.

   o rsyst, rcell
   Did not correctly handle the argument 'dx'.
   Spotted by Fabrice Vinatier.
   Fixed.

   o correction="trans"
   Various functions such as Kest 
   no longer recognised 'correction = "trans"'.
   Fixed.

   o istat
   Crashed with an error message about envelopes. 
   Fixed.

   o summary.ppm, print.ppm
   p-values which were exactly equal to zero were reported as NA.
   Fixed.

   o [.im
   Crashed if the intersection consisted of
   a single row or column of pixels.
   Fixed.

   o plot.im
   Sometimes incorrectly displayed an image consisting of 
   a single row or column of pixels.
   Fixed.

   o plot.layered
   The plot region was determined by the first layer,
   so that objects in subsequent layers could sometimes 
   fall outside the plot region.
   Fixed.

   o transect.im
   If the arguments 'from' and 'to' were numeric vectors of length 2,
   the result was garbled.
   Fixed.   

   o Inhomogeneous K functions and pair correlation functions
   [Kinhom, pcfinhom, Kcross.inhom, Kdot.inhom, pcfcross.inhom, etc.]
   These functions reported an error 'lambda is not a vector'
   if the intensity argument lambda was computed using density(, at="points").
   Fixed.

   o rlabel
   Did not accept a point pattern with a hyperframe of marks.
   Fixed.

   o alltypes
   Crashed when envelope=TRUE if the summary function 'fun'
   did not have default values for the marks i and j.
   Fixed.

   o Kres, Gres, psst, psstA
   Ignored the unit of length.
   Fixed.

	CHANGES IN spatstat VERSION 1.31-0

OVERVIEW

   o We thank Frederic Lavancier and Ege Rubak for contributions.

   o Major bug fix in simulation of area-interaction process.

   o Metropolis-Hastings simulations accelerated.

   o Rounding of spatial coordinates

   o clmfires dataset corrected.

   o Bug fixes and minor improvements.

NEW FUNCTIONS

   o round.ppp
   Round the spatial coordinates of a point pattern 
   to a specified number of decimal places.

   o rounding
   Determine whether a dataset has been rounded.

SIGNIFICANT USER-VISIBLE CHANGES

   o rmh
   Simulation of the following models has been accelerated:
   areaint, dgs, diggra, fiksel, geyer, hardcore, lennard, multihard,
   strauss, straush, straussm, strausshm.

   o rmh
   The transition history of the simulation (which is saved if 'track=TRUE')
   now also contains the value of the Hastings ratio for each proposal.

   o clmfires
   The clmfires dataset has been modified to remove errors and inconsistencies.

   o plot.linim
   Appearance of the plot has been improved, when style='width'.

   o summary.ppm
   Now reports whether the spatial coordinates have been rounded.

   o dclf.test, mad.test
   The range of distance values ('rinterval') used in the test
   is now printed in the test output, and is saved as an attribute.

BUG FIXES

   o rmh
   Simulation of the Area-Interaction model was completely incorrect.
   Spotted by Frederic Lavancier.
   The bug was introduced in spatstat version 1.23-6 or later.
   Fixed.

   o dclf.test
   The test statistic was incorrectly scaled (by a few percent).
   This did not affect the p-value of the test.
   Fixed.

   o ppx
   If argument 'coord.type' was missing, various errors occurred:
   a crash may have occurred, or the results may have depended
   on the storage type of the data. 
   Spotted by Ege Rubak.
   Fixed. 

   o plot.ppx
   Crashed for 1-dimensional point patterns.
   Spotted by Ege Rubak.
   Fixed.

	CHANGES IN spatstat VERSION 1.30-0


OVERVIEW 

   o We thank Jorge Mateu, Andrew Bevan, Olivier Flores, Marie-Colette van Lieshout, Nicolas Picard and Ege Rubak for contributions.

   o The spatstat manual now exceeds 1000 pages.

   o Hybrids of point process models.

   o Five new datasets

   o Second order composite likelihood method for kppm.

   o Inhomogeneous F, G and J functions.

   o Delaunay graph distance

   o Fixed serious bug in 'lppm' for marked patterns.

   o bug fix in some calculations for Geyer model

   o Improvements to linear networks code

   o Pixel images can now be displayed with a logarithmic colour map.

   o spatstat now formally 'Depends' on the R core package 'grDevices'

   o miscellaneous improvements and bug fixes

NEW DATASETS

   o clmfires
   Forest fires in Castilla-La Mancha

   o gordon
   People sitting on the grass in Gordon Square, London

   o hyytiala 
   Mixed forest in Hyytiala, Finland (marked by species)

   o paracou
   Kimboto trees in Paracou, French Guiana (marked as adult/juvenile)

   o waka
   Trees in Waka national park (marked with diameters)

NEW FUNCTIONS

   o Hybrid
   The hybrid of several point process interactions
   [Joint research with Jorge Mateu and Andrew Bevan]

   o is.hybrid
   Recognise a hybrid interaction or hybrid point process model.

   o Finhom, Ginhom, Jinhom
   Inhomogeneous versions of the F, G and J functions
   [Thanks to Marie-Colette van Lieshout]

   o delaunay.distance
   Graph distance in the Delaunay triangulation.

   o distcdf
   Cumulative distribution function of the distance between
   two independent random points in a given window.

   o bw.frac
   Bandwidth selection based on window geometry

   o shortside.owin, sidelengths.owin
   Side lengths of (enclosing rectangle of) a window

SIGNIFICANT USER-VISIBLE CHANGES

   o ppm
   Can now fit models with 'hybrid' interactions
   [Joint research with Jorge Mateu and Andrew Bevan]

   o kppm
   Now has the option of fitting models using Guan's (2006)
   second order composite likelihood.

   o envelope.lpp
   Now handles multitype point patterns.

   o envelope.envelope
   New argument 'transform' allows the user to apply a transformation
   to previously-computed summary functions.

   o runifpointOnLines, rpoisppOnLines, runiflpp, rpoislpp
   Can now generate multitype point patterns.

   o rmhmodel, rmh, simulate.ppm
   Now handle point process models with 'hybrid' interactions.

   o kppm
   Accelerated, and more reliable, due to better choice of starting values 
   in the optimisation procedure.

   o kppm
   The internal format of kppm objects has changed.

   o minimum contrast estimation
   Error messages from the optimising function 'optim' are now trapped
   and handled.

   o rhohat
   This command is now generic, with methods for ppp, quad, and ppm.

   o raster.x, raster.y, raster.xy
   These functions have a new argument 'drop'

   o summary.ppm
   Improved behaviour when the model covariates are a data frame.

   o progressreport
   Output improved.

   o second order summary functions
   (Kest, Lest, Kinhom, pcf.ppp, Kdot, Kcross, Ldot etc etc)
   These functions now accept correction="translation" as an 
   alternative to correction = "translate", for consistency.

   o plot.im
   New argument 'log' allows colour map to be equally spaced on a log scale.

   o as.owin.ppm, as.owin.kppm
   New argument 'from' allows the user to extract the spatial window
   of the point data (from="points") or the covariate images (from="covariates")

   o dclf.test, mad.test
   The rule for handling tied values of the test statistic has been changed.
   The tied values are now randomly ordered to obtain a randomised integer rank.

   o with.fv
   New argument 'enclos' allows evaluation in other environments

BUG FIXES

   o lppm
   For multitype patterns, the fitted model was completely incorrect
   due to an error in constructing the quadrature scheme.
   Fixed.

   o Geyer
   For point process models with the 'Geyer' interaction, 
   vcov.ppm() and suffstat() sometimes gave incorrect answers.
   [Spotted by Ege Rubak.]
   Fixed.

   o as.im.im
   Did not correctly handle factor-valued images
   if one of the arguments 'dimyx', 'eps', 'xy' was given.
   Fixed.

   o envelope.lppm
   Crashed if the model was multitype.
   Fixed.

   o lpp
   Did not handle empty patterns.
   Fixed.

   o density.ppp
   If 'sigma' was a bandwidth selection function such as bw.scott()
   which returned a numeric vector of length 2, a warning message was issued, 
   and the smoothing bandwidth was erroneously taken to be
   the first element of the vector.
   Fixed.

   o Fest, Jcross, Jdot, Jmulti
   If these functions were computed using correction = 'rs', 
   plotting them would sometimes give an error,      
   with the message "no finite x/y limits".
   Fixed.

   o pcfmodel.kppm
   For models with clusters="VarGamma"
   the value of the pcf at distance r=0 was given as NaN. 
   Fixed.

   o vcov.ppm
   Result was incorrect in rare cases, due to numerical rounding effects.
   Fixed.

   o rLGCP, simulate.kppm
   For models fitted to point patterns in an irregular window, 
   simulation sometimes failed, with a message that the image 'mu' 
   did not cover the simulation window.
   (Spotted by George Limitsios.)
   Fixed.

   o rLGCP, simulate.kppm
   Crashed sometimes with an error about unequal x and y steps
   (from 'GaussRF').
   Fixed.

	CHANGES IN spatstat VERSION 1.29-0

OVERVIEW 

   o We thank Colin Beale, Li Haitao, Frederic Lavancier, Erika Mudrak and Ege Rubak for contributions.

   o random sequential packing
 
   o Allard-Fraley estimator

   o method for pooling several quadrat tests

   o better control over dummy points in ppm

   o more support for data on a linear network

   o nearest neighbour map 

   o changes to subsetting of images

   o improvements and bug fixes 

NEW FUNCTIONS

   o clusterset
   Allard-Fraley estimator of high-density features in a point pattern

   o pool.quadrattest
   Pool several quadrat tests

   o nnfun
   Nearest-neighbour map of a point pattern or a line segment pattern

   o as.ppm
   Converts various kinds of objects to ppm

   o crossdist.lpp
   Shortest-path distances between pairs of points in a linear network

   o nobs.lppm
   Method for 'nobs' for lppm objects.

   o as.linim
   Converts various kinds of objects to 'linim'

   o model.images.slrm
   Method for model.images for slrm objects

   o rotate.im
   Rotate a pixel image

SIGNIFICANT USER-VISIBLE CHANGES

   o "[.im" and "[<-.im"
   New argument 'j' allows any type of matrix indexing to be used.

   o "[.im"
   Default behaviour changed in the case of a rectangular subset.
   New argument 'rescue' can be set to TRUE to reinstate previous behaviour.

   o rSSI
   Performs 'Random Sequential Packing' if n=Inf.

   o ppm
   New argument 'eps' determines the spacing between dummy points.
   (also works for related functions quadscheme, default.dummy, ...)

   o fitted.ppm, predict.ppm
   Argument 'new.coef' specifies a vector of parameter values
   to replace the fitted coefficients of the model.

   o lppm
   Stepwise model selection using step() now works for lppm objects.

   o vcov.slrm
   Can now calculate correlation matrix or Fisher information matrix
   as well as variance-covariance matrix.

   o eval.fv
   Improved behaviour when plotted.

   o "[.fv"
   Improved behaviour when plotted.

   o lohboot
   When the result is plotted, the confidence limits are now shaded.

   o lohboot
   New argument 'global' allows global (simultaneous) confidence bands
   instead of pointwise confidence intervals.

   o vcov.ppm
   Accelerated by 30% in some cases.

   o quadrat.test.splitppp
   The result is now a single object of class 'quadrattest'

   o progressreport
   Improved output (also affects many functions which print progress reports)

   o Full redwood data (redwoodfull)
   Plot function redwoodfull.extra$plotit has been slightly improved.

   o nncross
   This function is now generic, with methods for 'ppp' and 'default'.

   o distfun
   The internal format of objects of class 'distfun' has been changed.

   o duplicated.ppp, unique.ppp   
   New argument 'rule' allows behaviour to be consistent with package 'deldir'

BUG FIXES

   o bdist.tiles
   Values were incorrect in some cases due to numerical error.
   (Spotted by Erika Mudrak.)
   Fixed.

   o vcov.ppm, suffstat
   These functions sometimes gave incorrect values 
   for marked point process models.
   Fixed.

   o simulate.ppm, predict.ppm
   Did not correctly handle the 'window' argument. (Spotted by Li Haitao).
   Fixed.

   o smooth.ppp, markmean
   If sigma was very small, strange values were produced, due to
   numerical underflow. (Spotted by Colin Beale).
   Fixed.

   o MultiHard, MultiStrauss, MultiStraussHard
   Crashed if the data point pattern was empty.
   (Spotted by Ege Rubak).
   Fixed.

   o vcov.ppm
   Crashed sporadically, with multitype interactions.
   (Spotted by Ege Rubak).
   Fixed.

   o rStrauss, rHardcore, rStraussHard, rDiggleGratton, rDGS
   If the simulated pattern was empty, these functions would either
   crash, or return a pattern containing 1 point.
   (Spotted by Frederic Lavancier).
   Fixed.

   o model.matrix.slrm
   Crashed if the model was fitted using split pixels.
   Fixed.

   o residuals.ppm, diagnose.ppm
   Did not always correctly handle models that included offset terms.
   Fixed.

   o project.ppm
   When a model was projected by project.ppm or by ppm(project=TRUE),
   the edge corrections used the projected models were sometimes different
   from the edge corrections in the original model, so that the 
   projected and unprojected models were not comparable.
   Fixed.

   o plot.listof, plot.splitppp
   Crashed sometimes due to a scoping problem.
   Fixed.

   o dclf.test, mad.test
   Crashed if any of the function values were infinite or NaN.
   Fixed.

   o psstA
   Default plot did not show the horizontal line at y=0
   corresponding to a perfect fit.
   Fixed.

   o vcov.ppm
   names attribute was spelt incorrectly in some cases.
   Fixed.


	CHANGES IN spatstat VERSION 1.28-2

OVERVIEW 

   o We thank Thomas Bendtsen, Ya-Mei Chang, Daniel Esser, 
     Robert John-Chandran, Ege Rubak and Yong Song for contributions.

   o New code for Partial Residual Plots and Added Variable Plots.

   o maximum profile pseudolikelihood computations vastly accelerated.

   o New dataset: cells in gastric mucosa

   o now possible to capture every k-th state of Metropolis-Hastings algorithm.

   o size of 'ppm' objects reduced.

   o scope of 'intensity.ppm' extended.

   o quadrat.test can now perform Monte Carlo tests and one/two-sided tests

   o improvements to 'plot.fv'

   o improvement to 'rescale'

   o some datasets reorganised.

   o numerous bug fixes

NEW DATASET

   o mucosa
   Cells in gastric mucosa
   Kindly contributed by Dr Thomas Bendtsen

NEW FUNCTIONS

   o parres
   Partial residual plots for spatial point process models.
   A diagnostic for the form of a covariate effect.

   o addvar
   Added variable plots for spatial point process models.
   A diagnostic for the existence of a covariate effect.

SIGNIFICANT USER-VISIBLE CHANGES

  o profilepl
  Accelerated (typically by a factor of 5).

  o rmh, rmhcontrol
  It is now possible to save every k-th iteration of the Metropolis-Hastings
  algorithm. The arguments 'nsave' and 'nburn' may be given to rmh
  or to rmhcontrol. They specify that the point pattern will be saved
  every 'nsave' iterations, after an initial burn-in of 'nburn' iterations.

  o simulate.ppm
  New argument 'singlerun' determines whether the simulated patterns
  are generated using independent runs of the Metropolis-Hastings algorithm
  or are obtained by performing one long run of the algorithm and saving
  every k-th iteration.

  o exactMPLEstrauss
  New argument 'project' determines whether the parameter gamma
  is constrained to lie in [0,1].

  o intensity.ppm
  Now works for stationary point process models with the interactions
  DiggleGratton, DiggleGatesStibbard, Fiksel, PairPiece and Softcore.

  o plot.fv
  Improved algorithm for avoiding collisions between graphics and legend.

  o plot.fv
  New argument 'log' allows plotting on logarithmic axes.

  o envelope
  Can now calculate an estimate of the true significance level
  of the "wrong" test (which declares the observed summary function
  to be significant if it lies outside the pointwise critical boundary
  anywhere). Controlled by new argument 'do.pwrong'.

  o quadrat.test
  New argument 'alternative' allows choice of alternative hypothesis
  and returns one-sided or two-sided p-values as appropriate.

  o quadrat.test
  Can now perform Monte Carlo test as well 
  (for use in small samples where the chi^2 approximation is inaccurate)

  o Softcore
  Improved numerical stability.
  New argument 'sigma0' for manual control over rescaling.

  o rescale
  If scale argument 's' is missing, then the data are rescaled
  to native units. For example if the current unit is 0.1 metres, 
  coordinates will be re-expressed in metres.

  o psst
  Extra argument 'verbose=TRUE'

  o is.subset.owin
  Accelerated for polygonal windows

  o rmh.default
  'track' is no longer a formal argument of rmh.default; it is now a 
  parameter of rmhcontrol. However there is no change in usage: 
  the argument 'track' can still be given to rmh.default.

  o clf.test
  Has been renamed 'dclf.test' 
  to give proper attribution to Peter Diggle.

  o betacells
  This dataset has been restructured. The vector of cell profile areas,
  formerly given by betacells.extra$area, has now been included
  as a column of marks in the point pattern 'betacells'.

  o ants
  The function ants.extra$plot() has been renamed plotit() 
  for conformity with other datasets.

  o redwoodfull
  The function redwoodfull.extra$plot() has been renamed plotit() 
  for conformity with other datasets.

  o nbfires
  For conformity with other datasets, there is now an object nbfires.extra

BUG FIXES

  o ripras
  Expansion factor was incorrect in the rectangular case.
  Fixed.

  o Triplets
  Crashed sometimes with error "dim(X) must have positive length".
  Fixed.

  o affine.im
  Crashed in the case of a diagonal transformation matrix!
  Spotted by Ege Rubak.
  Fixed.

  o envelope.envelope
  Ignored the argument 'global'.
  Fixed.

  o MultiStraussHard
  The printed output showed the hardcore radii as NULL.
  Spotted by Ege Rubak.
  Fixed.

  o "[.psp"
  Crashed if the data were generated by rpoisline().
  Spotted by Marcelino de la Cruz.
  Fixed.

  o plot.linim
  If style="colour", the main title was always "x".
  Fixed.

  o plot.ppx
  Setting add=TRUE did not prevent the domain being plotted.
  Fixed.

  o rmh
  Crashed if x.start was an empty point pattern.
  Spotted by Ege Rubak.
  Fixed.

  o as.ppp.data.frame
  Crashed if any points lay outside the window.
  Spotted by Ege Rubak.
  Fixed.

  o Ripley isotropic edge correction
  Divide-by-zero error in rare cases.
  Spotted by Daniel Esser.
  Fixed.

  o summary functions
  For many of the summary functions (e.g. Kest, pcf),
  the result of saving the object to disc was an enormous file.
  Spotted by Robert John-Chandran.
  Fixed.

  o pcf.fv
  Default plot was wrongly coloured.
  Fixed.
  
	CHANGES IN spatstat VERSION 1.28-1

OVERVIEW 

   o We thank Ege Rubak, Gopal Nair, Jens Oehlschlaegel and Mike Zamboni
     for contributions.

   o New approximation to the intensity of a fitted Gibbs model.

   o Minor improvements and bug fixes

   o spatstat now 'Suggests' the package 'gsl'

NEW FUNCTIONS

   o intensity, intensity.ppp, intensity.ppm
   Calculate the intensity of a dataset or fitted model.
   Includes new approximation to the intensity of a fitted Gibbs model

   o LambertW
   Lambert's W-function

SIGNIFICANT USER-VISIBLE CHANGES

  o envelope
  Improved plot labels for envelopes that were generated using
  the 'transform' argument.

  o plot.fv
  Improved algorithm for collision detection.

  o plot.im
  Now returns the colour map used.

  o plot.listof, plot.splitppp
  Slight change to handling of plot.begin and plot.end

  o square
  Now accepts vectors of length 2

  o plot.fii
  Increased resolution of the plot obtained from plot(fitin(ppm(...))) 

  o image.listof
  If equal.ribbon=TRUE, the colour ribbon will no longer be 
  displayed repeatedly for each panel, 
  but will now be plotted only once, at the right hand side of the plot array.

BUG FIXES

  o vcov.ppm
  Results were sometimes incorrect for a Gibbs model with non-trivial trend.
  Spotted by Ege Rubak.
  Fixed.

  o nncross
  In rare cases the results could be slightly incorrect.
  Spotted by Jens Oehlschlaegel.
  Fixed.

  o plot.fv
  When add=TRUE, the x limits were sometimes truncated.
  Spotted by Mike Zamboni.
  Fixed.

  o plot.im
  Labels for the tick marks on the colour ribbon
  were sometimes ridiculous, e.g. "2.00000001".
  Fixed.

	CHANGES IN spatstat VERSION 1.28-0

OVERVIEW 

   o We thank Farzaneh Safavimanesh, Andrew Hardegen and Tom Lawrence 
     for contributions.

   o Improvements to 3D summary functions.

   o A multidimensional point pattern (ppx) can now have 'local' coordinates
   as well as spatial and temporal coordinates and marks.

   o Changed format for point patterns on a linear network (lpp).
   Changes are backward compatible. Many computations run faster.

   o More support for fitted cluster models (kppm).

   o split method for multidimensional point patterns (ppx)
   and point patterns on a linear network (lpp).

   o Fixed bug causing errors in plot.im

   o Miscellaneous improvements and bug fixes

NEW FUNCTIONS

   o exactMPLEstrauss
   Fits the stationary Strauss point process model
   using an exact maximum pseudolikelihood technique.
   This is mainly intended for technical investigation of algorithms.

   o split.ppx
   Method for 'split' for multidimensional point patterns (class 'ppx').
   This also works for point patterns on a linear network (class 'lpp').

   o model.images
   This function is now generic, with methods for classes ppm, kppm, lppm

   o model.frame, model.matrix
   These generic functions now have methods for classes kppm, lppm

   o as.owin.kppm, as.owin.lppm
   New methods for 'as.owin' for objects of class kppm, lppm

   o as.linnet.lppm
   Extracts the linear network in which a point process model was fitted.

SIGNIFICANT USER-VISIBLE CHANGES

   o class 'ppx'
   An object of class 'ppx' may now include 'local' coordinates 
   as well as 'spatial' and 'temporal' coordinates, and marks.

   o ppx
   Arguments have changed.
   
   o class 'lpp'
   The internal format of lpp objects has been extended
   (but is backward-compatible). Many computations run faster.
   To convert an object to the new format: X <- lpp(as.ppp(X), as.linnet(X)).

   o F3est
   Calculation of theoretical Poisson curve ('theo') has changed,
   and is now controlled by the argument 'sphere'.

   o rmh, rmhstart
   The initial state ('start') can now be missing or null.

   o im, as.im
   The pixel coordinates in an image object are now generated
   more accurately. This avoids a numerical error in plot.im.

   o eval.fv, eval.fasp
   Evaluation is now applied only to columns that contain
   values of the function itself (rather than values of the
   derivative, hazard rate, etc). This is controlled by the
   new argument 'dotonly'.

   o spatstat.options
   New option 'nvoxel'

   o quad.ppm
   Now accepts kppm objects.

   o str
   This generic function (for inspecting the internal structure of an object)
   now produces sensible output for objects of class 'hyperframe', 'ppx', 'lpp'

   o ppx, coords.ppx, coords<-.ppx
   The arguments to these functions have changed.

   o lgcp.estK, Kmodel
   Computation can be greatly accelerated 
   by setting spatstat.options(fastK.lgcp=TRUE).

   o G3est
   Computation accelerated.

   o envelope
   Computation slightly accelerated.

   o spatstat.options
   New option 'fastK.lgcp' 

BUG FIXES

   o nndist.psp
   Caused an error if length(k) > 1.
   Fixed.

   o plot.im
   Sometimes reported an error 
   "useRaster=TRUE can only be used with a regular grid."
   This was due to numerical rounding effects on the coordinates
   of a pixel image. 
   Fixed.
   
   o plot.fv
   If a formula was used to specify the plot,
   the names of variables in the formula were sometimes
   incorrectly matched to *functions*.
   Spotted by Farzaneh Safavimanesh.
   Fixed.

   o F3est
   Took a very long time if the containing box was very flat,
   due to the default value of 'vside'.
   Fixed.

   o rmh, rmhmodel
   An erroneous warning about 'outdated format of rmhmodel object' 
   sometimes occurred.
   Fixed.

   o marks<-.ppx
   Names of result were incorrect. Fixed.

   o hyperframe class
   Various minor bug fixes.


	CHANGES IN spatstat VERSION 1.27-0

OVERVIEW 

   o Variance estimates are now available for all Gibbs point process models.

   o Cressie-Loosmore-Ford test implemented

   o plot.fv now avoids collisions between the legend and the graphics.

   o Extension to predict.ppm

   o Improvements to envelopes and multitype summary functions. 

   o Line transects of a pixel image.

   o Changes to defaults in Metropolis-Hastings simulations.

   o More geometrical operations

   o Bug fixes.

   o We thank Aruna Jammalamadaka for contributions.

NEW FUNCTIONS

   o clf.test
   Perform the Cressie (1991)/ Loosmore and Ford (2006) test of CSR 
   (or another model)

   o mad.test
   Perform the Maximum Absolute Deviation test of CSR (or another model).

   o convolve.im
   Compute convolution of pixel images.

   o Kmulti.inhom
   Counterpart of 'Kmulti' for spatially-varying intensity.

   o rmhexpand
   Specify a simulation window, or a rule for expanding the
   simulation window, in Metropolis-Hastings simulation (rmh)

   o transect.im
   Extract pixel values along a line transect.

   o affine.im
   Apply an affine transformation to a pixel image.

   o scalardilate
   Perform scalar dilation of a geometrical object 
   relative to a specified origin.

   o reflect
   Reflect a geometrical object through the origin.

   o "[.lpp", "[.ppx"
   Subset operators for the classes "lpp" (point pattern on 
   linear network) and "ppx" (multidimensional space-time
   point pattern).
 
   o is.rectangle, is.polygonal, is.mask
   Determine whether a window w is a rectangle, a domain with polygonal 
   boundaries, or a binary pixel mask.

   o has.offset
   Determines whether a fitted model object (of any kind)
   has an offset.

SIGNIFICANT USER-VISIBLE CHANGES

   o predict.ppm
   This function can now calculate the conditional intensity of a model
   relative to any point pattern X (not just the original data pattern).

   o vcov.ppm
   This function now handles all Gibbs point process models.

   o plot.fv
   Collisions between the legend box and the graphics are now detected
   and avoided. 

   o rmh.ppm, rmh.default, simulate.ppm, qqplot.ppm, envelope.ppm
   These functions now have slightly different default behaviour
   because of changes to the handling of arguments to 'rmhcontrol'.

   o rmhcontrol
   The default value of the parameters 'periodic' and 'expand'
   has changed.

   o rmhcontrol
   The parameter 'expand' can now be in any format 
   acceptable to rmhexpand().

   o rmh.ppm, rmh.default, simulate.ppm
   Any 'rmhcontrol' parameter can now be given directly 
   as an argument to rmh.ppm, rmh.default or simulate.ppm.

   o Kmulti, Gmulti, Jmulti
   The arguments I, J can now be any kind of subset index
   or can be functions that yield a subset index.

   o envelope.envelope
   In envelope(E, fun=NULL) if E does not contain simulated
   summary functions, but does contain simulated point patterns, 
   then 'fun' now defaults to Kest, instead of flagging an error.

   o print.ppp, summary.ppp
   If the point pattern x was generated by Metropolis-Hastings
   simulation using 'rmh', then print(x) and summary(x) show 
   information about the simulation parameters.

   o print.ppm
   Standard errors for the parameter estimates,
   and confidence intervals for the parameters,
   can now be printed for all Gibbs models 
   (but are printed only for Poisson models by default).

   o eval.im
   Images with incompatible dimensions are now resampled 
   to make them compatible (if harmonize=TRUE).

   o spatstat.options
   New option 'print.ppm.SE' controls whether standard errors 
   and confidence intervals are printed for all Gibbs models,
   for Poisson models only, or are never printed.

   o inside.owin
   Now accepts the form list(x,y) for the first argument.

   o image.listof
   New argument 'equal.ribbon' allows several images to be plotted
   with the same colour map.

   o is.subset.owin
   Improved accuracy in marginal cases.

   o expand.owin
   Functionality extended to handle all types of expansion rule.

   o default.rmhcontrol, default.expand
   These functions now work with models of class 'rmhmodel' 
   as well as 'ppm'

   o print.rmhcontrol
   Output improved.

BUG FIXES

   o linearK, linearKinhom
   If any data points were located exactly at a vertex of the 
   linear network, the weights for Ang's correction were incorrect, 
   due to numerical error. This sometimes produced infinite 
   or NA values of the linear K function.
   Fixed.
   
   o predict.ppm
   In some cases, predict.ppm(type="cif") generated a spurious warning 
   that "number of rows of result is not a multiple of vector length."
   Fixed.

   o crossing.psp
   Results were sometimes incorrect due to numerical rounding error
   associated with GCC bug #323.
   Fixed.

   o MultiHard, MultiStrauss, MultiStraussHard
   If the mark values contained non-alphanumeric characters,
   the names of the interaction coefficients in coef(ppm(...)) 
   were sometimes garbled.
   Fixed.

   o profilepl
   For edge corrections other than the border correction,
   an error message about 'rbord' would sometimes occur.
   Fixed.

   o is.marked, is.multitype
   These functions gave the wrong answer for 'lpp' objects.
   Fixed.

   o marks<-.lpp,  marks<-.ppx
   Format of result was garbled if new columns of marks were added.
   Fixed.

   o reach.rmhmodel
   Gave the wrong answer for Geyer and BadGey models.
   Fixed.

   o envelope.envelope
   Ignored the argument 'savefuns'.
   Fixed.

   o BadGey
   Sometimes wrongly asserted that the parameter 'sat' was invalid.
   Occurred only in ppm(project=TRUE).
   Fixed.

	CHANGES IN spatstat VERSION 1.26-1

OVERVIEW 

   o Variance-covariance matrix for Gibbs point process models.

   o Bootstrap confidence bands for pair correlation function and K function.

   o Bug fix in scan test.

   o Area-interaction model accelerated.

   o we thank Jean-Francois Coeurjolly and Ege Rubak for contributions.

NEW FUNCTIONS

  o lohboot
  Computes bootstrap confidence bands for pair correlation function
  and K function using Loh's (2008) mark bootstrap.

SIGNIFICANT USER-VISIBLE CHANGES

  o vcov.ppm
  Now works for all Gibbs point process models, thanks to new code (and theory)
  from Jean-Francois Coeurjolly and Ege Rubak

  o AreaInter
  Computations related to the area-interaction point process 
  (ppm, predict.ppm, residuals.ppm, diagnose.ppm, qqplot.ppm)
  have been accelerated.

BUG FIXES

  o scan.test
  Results were sometimes incorrect due to numerical instability
  (a 'Gibbs phenomenon'). 
  Fixed.
  
	CHANGES IN spatstat VERSION 1.26-0

OVERVIEW 

   o We thank Jens Oehlschlaegel for contributions.

   o Further substantial acceleration of spatstat functions.

   o Workaround for bug in RandomFields package.

   o Numerous modifications to internal code.

NEW FUNCTIONS

   o RandomFieldsSafe
   There is a bug in the package 'RandomFields' (version <= 2.0.54)
   which causes a crash to occur, in the development version of R
   but not in R 2.15.0. To avoid crashing spatstat, we have written
   the temporary, undocumented function RandomFieldsSafe() 
   which returns TRUE if it is safe to use the RandomFields package.
   Examples in the spatstat help files for kppm, lgcp.estK, lgcp.estpcf
   and rLGCP are only executed if RandomFieldsSafe() returns TRUE.

SIGNIFICANT USER-VISIBLE CHANGES

   o Many functions
   Many spatstat functions now run faster, and will handle larger datasets,
   thanks to improvements in the internal code, 
   following suggestions from Jens Oehlschlaegel.

   o Many functions
   The response to an 'Interrupt' signal is slightly slower.

	CHANGES IN spatstat VERSION 1.25-5

OVERVIEW 

   o We thank Ya-Mei Chang, Jens Oehlschlaegel and Yong Song for contributions.

   o Extended functionality of 'rhohat' to local likelihood smoothing
   and bivariate smoothing.

   o Nearest neighbour distance computations accelerated.

   o spatstat now 'Suggests:' the package 'locfit'

NEW FUNCTIONS

   o rho2hat
   Bivariate extension of 'rhohat' for estimating spatial residual risk, 
   or intensity as a function of two covariates.

SIGNIFICANT USER-VISIBLE CHANGES

   o rhohat
   Estimation can now be performed using local likelihood fitting
   with the 'locfit' package, or using kernel smoothing.

   o nncross
   Substantially accelerated.
   New arguments added to control the return value and the sorting of data.

BUG FIXES

   o plot.msr
   Crashed if the argument 'box' was given.
   Fixed.

	CHANGES IN spatstat VERSION 1.25-4

OVERVIEW 

   o We thank Jonathan Lee and Sergiy Protsiv for contributions.

   o Improvements and bug fixes to K function for very large datasets

NEW FUNCTIONS

   o rStraussHard
   Perfect simulation for Strauss-hardcore process (with gamma <= 1)

SIGNIFICANT USER-VISIBLE CHANGES

   o plot.im
   The colour ribbon can now be placed left, right, top or bottom 
   using new argument 'ribside'

   o profilepl
   Does not generate warnings when some of the candidate models
   have zero likelihood - for example when fitting model with a hard core.

   o Kest
   Now includes fast algorithm for 'correction="none"'
   which will handle patterns containing millions of points.

BUG FIXES

   o Kest, Lest
   Gave incorrect values in very large datasets, due to numerical overflow.
   `Very large' typically means about 1 million points in a random pattern, 
   or 100,000 points in a tightly clustered pattern.
   [Overflow cannot occur unless there are at least 46,341 points.]
   [Spotted by Sergiy Protsiv.]
   Fixed.

   o Kest, Lest
   Ignored 'ratio=TRUE' if the argument 'domain' was given.
   [Spotted by Jonathan Lee.]
   Fixed.

   o rjitter
   Output was sometimes incorrect. 
   [Spotted by Sergiy Protsiv.]
   Fixed.

	CHANGES IN spatstat VERSION 1.25-3

OVERVIEW 

   o We thank Daniel Esser for contributions.

   o Improved support for fitted point process models.

   o Bug fixes.

NEW FUNCTIONS

   o simulate.slrm
   Method for 'simulate' for spatial logistic regression models.

   o labels.ppm, labels.kppm, labels.slrm
   Methods for 'labels' for fitted point process models.

   o commonGrid
   Determine a common spatial domain and pixel resolution
   for several pixel images and/or binary masks

SIGNIFICANT USER-VISIBLE CHANGES

   o effectfun
   Now has argument 'se.fit' allowing calculation of standard errors
   and confidence intervals.

   o [.msr
   Now handles character-valued indices. 

   o print.summary.ppm
   Output gives a more precise description of the fitting method.

   o ppm, kppm, slrm
   Confidence intervals for the fitted trend parameters
   can now be obtained using 'confint' 

   o predict.slrm
   New argument 'window' 

   o union.owin
   Now handles a single argument: union.owin(A) returns A.

BUG FIXES

   o selfcrossing.psp
   y coordinate values were incorrect.
   [Spotted by Daniel Esser.]
   Fixed.

   o as.im.owin
   Did not handle a binary mask with a 1 x 1 pixel array.
   Fixed.

   o predict.slrm
   Results of predict(object, newdata) were incorrect 
   if the spatial domain of 'newdata' was larger than the original domain.
   Fixed.

   o ppm
   If the model was the uniform Poisson process,
   the argument 'rbord' was ignored.
   Fixed.

   o image subset assignment "[<-.im"
   Generated an error if the indexing argument 'i' 
   was a point pattern containing zero points.
   Fixed.

   o hyperframe subset assignment "[<-.hyperframe"
   Did not correctly handle the case where a single column 
   of the hyperframe was to be changed.
   Fixed.
   
   o help(bw.relrisk), help(rmh.ppm), help(plot.plotppm)
   These help files had the side-effect of changing some options
   in spatstat.options.
   Fixed.

	CHANGES IN spatstat VERSION 1.25-2

OVERVIEW 

   o We thank Abdollah Jalilian and Thierry Onkelinx for contributions.

   o Very Important Bug fixes.

   o Improved mechanism for handling 'invalid' point processes

NEW FUNCTIONS

   o as.matrix.owin
   Converts a window to a logical matrix.

SIGNIFICANT USER-VISIBLE CHANGES

   o project.ppm
     Improved algorithm.
     Now handles terms in the trend formula as well as the interaction.
     The projected point process is now obtained by re-fitting the model,
     and is guaranteed to be the maximum pseudolikelihood fit.

   o plot.im
     Now handles many arguments recognised by plot.default
     such as 'cex.main'. Also handles argument 'box'.
     New argument 'ribargs' contains parameters controlling the
     ribbon plot only.      

   o spatstat.options
     New option 'project.fast' allows a faster shortcut for project.ppm

   o spatstat.options
     New options 'rmh.p', 'rmh.q', 'rmh.nrep' determine the default values
     of the parameters p, q and nrep of the Metropolis-Hastings algorithm.
     See rmhcontrol

   o ppm
     Slightly accelerated.

BUG FIXES

   o nncross, distfun, AreaInter
     Results of nncross were possibly incorrect 
     when X and Y did not have the same window. 
     This bug affected values of 'distfun' and may also 
     have affected ppm objects with interaction 'AreaInter'.
     [Spotted by Thierry Onkelinx]
     Bug introduced in spatstat 1.9-4 (June 2006).
     Fixed.

   o rCauchy
     Simulations were incorrect in the sense that 
     the value of 'omega' was inadvertently doubled 
     (i.e. omega was incorrectly replaced by 2 * omega).
     Bug introduced in spatstat 1.25-0.
     Fixed.

   o plot.im
     White lines were present in the image display, on some graphics devices,
     due to changes in R 2.14.
     Fixed.

   o update.ppm
     The result of 'update(object, formula)' sometimes contained errors
     in the internal format.
     Bug introduced in spatstat 1.25-0.
     Fixed.

   o example(AreaInter), example(bw.smoothppp),
   example(Kest.fft), example(plot.owin), example(predict.ppm),
   example(simulate.ppm)
	Executing these examples had the side-effect of
	changing some of the parameters in spatstat.options.
	Fixed.

	CHANGES IN spatstat VERSION 1.25-1

OVERVIEW 

   o We thank Neba Funwi-Gabga and Jorge Mateu for contributions.

   o New dataset of gorilla nest sites

   o New functions for perfect simulation 

   o Bug fix for rare crashes in rStrauss

   o Code for ensuring a fitted point process model is a valid point process

NEW DATASET

   o gorillas
   Gorilla nest sites in a National Park in Cameroon.
   Generously contributed by Neba Funwi-Gabga

NEW FUNCTIONS

   o rDiggleGratton, rDGS, rHardcore
   Perfect simulation for the Diggle-Gratton process,
   Diggle-Gates-Stibbard process, and Hardcore process.

   o bw.scott
   Scott's rule of thumb for bandwidth selection in
   multidimensional smoothing

   o valid.ppm
   Checks whether a fitted point process model is a valid point process

   o project.ppm
   Forces a fitted point process model to be a valid point process

SIGNIFICANT USER-VISIBLE CHANGES

   o ppm
   New argument 'project' determines whether the fitted model
   is forced to be a valid point process

   o linnet
   Substantially accelerated.

   o rStrauss
   Slightly accelerated.

   o summary.lpp
   Now prints the units of length.

BUG FIXES

   o rStrauss
   Crashed rarely (once every 10 000 realisations)
   with a memory segmentation fault.
   Fixed.

	CHANGES IN spatstat VERSION 1.25-0

OVERVIEW 

   o Leverage and influence for point process models

   o New cluster models (support for model-fitting and simulation).

   o Fit irregular parameters in trend of point process model

   o Third order summary statistic.

   o Improvements to speed and robustness of code.

   o spatstat now depends on R 2.14

   o We thank Abdollah Jalilian and Rasmus Waagepetersen for contributions.

NEW FUNCTIONS

   o leverage.ppm, influence.ppm, dfbetas.ppm
   Leverage and influence for point process models

   o ippm
   Experimental extension to 'ppm' which fits irregular parameters in trend
   by Fisher scoring algorithm.

   o Tstat
   Third order summary statistic for point patterns
   based on counting triangles.

   o rCauchy, rVarGamma
   simulation of a Neyman-Scott process with Cauchy clusters
   or Variance Gamma (Bessel) clusters.
   Contributed by Abdollah Jalilian.

   o rPoissonCluster
   simulation of a general Poisson cluster process

   o model.covariates
   Identify the covariates involved in a model (lm, glm, ppm etc)

   o as.im.distfun
   Converts a 'distfun' to a pixel image.

   o cauchy.estK, cauchy.estpcf, vargamma.estK, vargamma.estpcf
   Low-level model-fitting functions for the Neyman-Scott process 
   with Cauchy or Variance-Gamma cluster kernel.
   Contributed by Abdollah Jalilian.

SIGNIFICANT USER-VISIBLE CHANGES

   o kppm
   Now accepts clusters="Cauchy" or clusters="VarGamma"
   for the Neyman-Scott process with Cauchy or Variance-Gamma cluster kernel.
   Code contributed by Abdollah Jalilian.

   o rNeymanScott
   Argument 'rcluster' may now take a different format.

   o psst
   Argument 'funcorrection' changed to 'funargs' allowing greater flexibility.

   o plot.fv, plot.envelope
   New argument 'limitsonly' allows calculation of 
   a common x,y scale for several plots.

   o overall speed 
   spatstat is now byte-compiled and runs slightly faster.

   o user interrupt
   Long calculations in spatstat now respond to the Interrupt/Stop signal.

   o update.ppm
   Now runs faster and uses much less memory,
   when the update only affects the model formula (trend formula).
   
   o rNeymanScott, rThomas, rMatClust
   Accelerated thanks to Rasmus Waagepetersen.

   o multitype data and models
   Second order multitype statistics (such as Kcross, pcfcross)
   and multitype interaction models (such as MultiStrauss)
   now run faster, by a further 5%.

BUG FIXES

   o distfun
   Some manipulations involving 'distfun' objects failed if the
   original data X in distfun(X) did not have a rectangular window.
   Fixed.

	CHANGES IN spatstat VERSION 1.24-2

OVERVIEW 

   o Geyer's triplet interaction

   o more functionality for replicated point patterns

   o changed default for simulation window in point process simulation

   o changed default for edge correction in Kcom, Gcom
 
   o data in spatstat is now lazy-loaded

   o bug fixes 

NEW FUNCTIONS

   o Triplets
   Geyer's triplet interaction, for point process models

   o coef.summary.ppm
   New method coef.summary.ppm
   You can now type 'coef(summary(fit))' to extract a table
   of the fitted coefficients of the point process model 'fit'

SIGNIFICANT USER-VISIBLE CHANGES

   o data in spatstat are now lazy-loaded
   so you don't have to type data(amacrine), etc.

   o rmh.default, rmh.ppm, simulate.ppm
   These now handle the 'triplets' interaction
   
   o fryplot
   Now has arguments 'to' and 'from', allowing 
   selection of a subset of points.

   o fryplot, frypoints
   These functions now handle marked point patterns properly.

   o Kcross, Kdot, Kmulti
   New argument 'ratio' determines whether the numerator and denominator
   of the estimate of the multitype K-function will be stored. 
   This enables analysis of replicated point patterns, 
   using 'pool.rat()' to pool the K function estimates.

   o rmh.ppm, simulate.ppm, default.expand
   For point process models which have a trend depending only on x and y,
   the simulation window is now taken to be the same as the original 
   window containing the data (by default). 
   That is, `expansion' does not take place, by default.
   (In previous versions of spatstat the simulation window was larger
   than the original data window.)
   
   o rmh.ppm, simulate.ppm
   The argument sequence for these functions has changed.
   New argument 'expand' allows more explicit control over simulation domain.

   o Kcom, Gcom
   New argument 'conditional' gives more explicit control
   over choice of edge correction in compensator.
   Simplified defaults for edge correction.  

   o Kinhom
   Improved plot labels.

   o profilepl
   Printed output improved.

BUG FIXES

   o Lest
   The variance approximations (Lotwick-Silverman and Ripley)
   obtained with var.approx=TRUE, were incorrect for Lest 
   (although they were correct for Kest) due to a coding error.
   Fixed.
   
   o simulate.ppm
   Ignored the argument 'control' in some cases. 
   Fixed.

   o pcf and its relatives (pcfinhom, pcfcross.inhom, pcfdot.inhom)
   Sometimes gave a warning about 'extra arguments ignored'.
   Fixed.

	CHANGES IN spatstat VERSION 1.24-1

OVERVIEW 

   o Spatial Scan Test

   o Functionality for replicated point patterns

   o Bug fixes

NEW FUNCTIONS

   o scan.test
     Spatial scan test of clustering

   o rat
   New class of 'ratio objects'

   o pool.rat
   New method for 'pool'.
   Combines K function estimates for replicated point patterns (etc) 
   by computing ratio-of-sums 

   o unnormdensity
   Weighted kernel density with weights that do not sum to 1
   and may be negative.

   o compatible
   New generic function with methods for 'fv', 'im', 'fasp' and 'units'

SIGNIFICANT USER-VISIBLE CHANGES

   o Kest
   New argument 'ratio' determines whether the numerator and denominator
   of the estimate of the K-function will be stored. 
   This enables analysis of replicated point patterns, 
   using 'pool.rat()' to pool the K function estimates.

   o Lest
   Now handles theoretical variance estimates (using delta method)
   if var.approx=TRUE

   o as.mask
   Argument 'eps' can now be a 2-vector, specifying x and y resolutions.

   o default.expand
   Behaviour changed slightly.

   o plot.listof, plot.splitppp, contour.listof, image.listof
   The arguments 'panel.begin' and 'panel.end' can now be objects
   such as windows. 

BUG FIXES

   o rgbim, hsvim
   Did not work on images with non-rectangular domains.
   Fixed.

   o scaletointerval
   Did not handle NA's.
   Fixed.


	CHANGES IN spatstat VERSION 1.24-0

OVERVIEW 

   o This version was not released publicly.


	CHANGES IN spatstat VERSION 1.23-6

OVERVIEW 

   o Spatial covariance functions of windows and pixel images.

   o Area-interaction models can now be fitted in non-rectangular windows

   o Bug fix for envelope of inhomogeneous Poisson process

   o Bug fix for raster conversion

   o New vignette on 'Getting Started with Spatstat'

   o Code accelerated.

NEW FUNCTIONS

   o imcov
   Spatial covariance function of pixel image
   or spatial cross-covariance function of two pixel images

   o harmonise.im
   Make several pixel images compatible 
   by converting them to the same pixel grid

   o contour.listof, image.listof
   Methods for contour() and image() for lists of objects

   o dummify
   Convert data to numeric values by constructing dummy variables.

SIGNIFICANT USER-VISIBLE CHANGES

   o setcov
   Can now compute the `cross-covariance' between two regions

   o AreaInter
   Point process models with the AreaInter() interaction
   can now be fitted to point pattern data X in any window.

   o areaGain, areaLoss
   These now handle arbitrary windows W.
   They are now more accurate when r is very small.

   o Kcom
   Computation vastly accelerated, for non-rectangular windows.

   o vignettes
   New vignette 'Getting Started with the Spatstat Package'

   o nncorr, nnmean, nnvario
   These functions now handle data frames of marks.

BUG FIXES

   o envelope.ppm
   If the model was an inhomogeneous Poisson process, 
   the resulting envelope object was incorrect
   (the simulations were correct, but the envelopes were calculated
   assuming the model was CSR). Bug was introduced in spatstat 1.23-5.
   Fixed.

   o envelope.ppm
   If the model was an inhomogeneous Poisson process 
   with intensity a function of x and y only,
   overflow errors sometimes occurred ('insufficient storage' 
   or 'attempting to generate a large number of random points').
   Fixed.

   o as.im.im
   The result of as.im(X, W) was incorrect if 'W' did not cover 'X'.
   Fixed.

   o as.mask
   The result of as.mask(w, xy) was incorrect if 'xy' did not cover 'w'.
   Fixed.

   o plot.fv
   Legend was incorrectly labelled if 'shade' variables were not included
   in the plot formula.
   Fixed.

   o areaGain, areaLoss
   Crashed if the radius r was close to zero.
   Fixed.

	CHANGES IN spatstat VERSION 1.23-5

OVERVIEW 

   o Bug fix to bandwidth selection.

   o Functions to pool data from several objects of the same class.

   o Improvements and bug fixes.

   o We thank Michael Sumner for contributions.

NEW FUNCTIONS

   o pool
   Pool data from several objects of the same class

   o pool.envelope
   Pool simulated data from several envelope objects and create a new envelope

   o pool.fasp
   Pool simulated data from several function arrays and create a new array

   o envelope.envelope
   Recalculate an envelope from simulated data using different parameters

SIGNIFICANT USER-VISIBLE CHANGES

   o bw.diggle, bw.relrisk, bw.smoothppp, bw.optim
   Plot method modified.

   o model.depends
   Now also recognises 'offset' terms.

BUG FIXES

   o bw.diggle
   Bandwidth was too large by a factor of 2.
   Fixed.

   o plot.psp
   Crashed if any marks were NA.
   Fixed.

   o pointsOnLines
   Crashed if any segments had zero length.
   Ignored argument 'np' in some cases.
   Fixed.

   o stieltjes
   Crashed if M had only a single column of function values.
   Fixed.

	CHANGES IN spatstat VERSION 1.23-4

OVERVIEW 

    o Bandwidth selection for density.ppp and smooth.ppp

    o Layered plots. 

    o Model-handling facilities.

    o Improvements and bug fixes.


NEW FUNCTIONS

   o bw.diggle
   Bandwidth selection for density.ppp by mean square error cross-validation.

   o bw.smoothppp
   Bandwidth selection for smooth.ppp by least-squares cross-validation.

   o layered, plot.layered
   A simple mechanism for controlling plots that consist of
   several successive layers of data.

   o model.depends
   Given a fitted model (of any kind), identify which of the covariates
   is involved in each term of the model.

   o model.is.additive
   Determine whether a fitted model  (of any kind) is additive, 
   in the sense that each term in the model involves at most one covariate.


SIGNIFICANT USER-VISIBLE CHANGES

   o smooth.ppp
   Bandwidth 'sigma' is now selected by least-squares cross-validation

   o bw.relrisk
   Computation in large datasets accelerated.
   New arguments 'hmin', 'hmax' control the range of trial values of bandwidth.

   o Hest, Gfox, Jfox
   Improved algebraic labels for plot

   o spatstat.options
   New parameter 'n.bandwidth'

   o density.ppp, smooth.ppp
   Slightly accelerated.

   o point-in-polygon test
   Accelerated.

BUG FIXES

    o with.fv
    Mathematical labels were incorrect in some cases.
    Fixed.

    o bw.relrisk
    Implementation of method="weightedleastsquares" was incorrect
    and was equivalent to method="leastsquares".
    Fixed.

    o smooth.ppp
    NaN values occurred if the bandwidth was very small.
    Fixed.

	CHANGES IN spatstat VERSION 1.23-3

OVERVIEW 

    o Urgent bug fix.

BUG FIXES

    o crossing.psp
    Crashed occasionally with a message about NA or NaN values.
    Fixed.

    o affine.ppp
    Crashed if the point pattern was empty.
    Fixed.

	CHANGES IN spatstat VERSION 1.23-2

OVERVIEW 

    o Bug fixes.

    o Several functions have been accelerated.

    o We thank Marcelino de la Cruz and Ben Madin for contributions.

NEW FUNCTIONS

    o sumouter, quadform
    Evaluate certain quadratic forms.

    o flipxy
    Exchange x and y coordinates.

SIGNIFICANT USER-VISIBLE CHANGES

   o vcov.ppm
   Accelerated.

   o owin, as.owin
   Checking the validity of polygons has been accelerated.

   o crossing.psp, selfcrossing.psp
   Accelerated.

BUG FIXES

    o split.ppp
    If drop=TRUE then some of the point patterns had the wrong windows.
    Spotted by Marcelino de la Cruz.
    Fixed.

    o split.ppp
    Crashed if the tessellation did not cover the point pattern.
    Fixed.

    o predict.ppm
    Crashed when type="se" if NA's were present.
    Spotted by Ben Madin.
    Fixed.

    o plot.ppp
    Incorrectly handled the case where both 'col' and 'cols' were present.
    Fixed.

    o polygon geometry
    The point-in-polygon test gave the wrong answer in some boundary cases.
    Fixed.
    

	CHANGES IN spatstat VERSION 1.23-1

OVERVIEW 

    o Important bug fix to 'localpcf'.

    o Inverse-distance weighted smoothing.

    o Inhomogeneous versions of neighbourhood density functions.

    o Internal repairs and bug fixes.

    o We thank Mike Kuhn and Ben Madin for contributions.

NEW FUNCTIONS

    o idw
